// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js
angular.module('starter', [	'ionic', 'ngIOS9UIWebViewPatch', 'leaflet-directive', 
							'starter.controllers','starter.services','kolorbox.services',
							'kolorbox.utility',
							'kolorbox.components',
							'kolorbox.kbstore', 'ngOpenFB'
])

.run(function($ionicPlatform,LocalStorage,Datastore,Account,KBStore) {

	//Init KB Store
	KBStore.init();


	$ionicPlatform.ready(function() {

		console.log('ionicPlatform ready!!!');

		// Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
		// for form inputs)
		try{
			if (window.cordova && window.cordova.plugins.Keyboard) {
				cordova.plugins.Keyboard.disableScroll(true);
				cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
				console.log('cordova keyboard ready');
			}
			if (window.StatusBar) {
				// org.apache.cordova.statusbar required
				// StatusBar.styleDefault();
				StatusBar.styleBlackOpaque();
			}

		} catch (e) {
			console.log(e);
		}

		if (g_ga_enable === true){
			try{
				console.log('start GA');
				window.ga.startTrackerWithId(g_ga_track_id, function(){
					console.log('GA success');
				}, function(){
					console.log('GA failed');
				});
			} catch (e) {
				console.log("GA error catch: ", e);
			}
		}

		try{
			KBStore.initNativeService();
		}
			catch (e){
			console.log(e);
		}


		//Facebook Pugin
		openFB.init({appId: g_facebook_app_id});

		//social share
		var socialshare = {
			enable:false,
			viaFacebook:false,
			viaWhatsapp:false,
		};

		Datastore.setSocialShare(socialshare);
		//facebook
		if(g_social_share_enable == true){
			if(ionic.Platform.isIOS() || ionic.Platform.isAndroid()){
				window.plugins.socialsharing.canShareVia('com.apple.social.facebook',
			 		'msg', null, null, null,
			 		function(e){
						var socialshare = Datastore.getSocialShare();
						socialshare.enable = true;
						socialshare.viaFacebook = true;
						Datastore.setSocialShare(socialshare);
					},
					function(e){
					
					}
				);
				window.plugins.socialsharing.canShareVia('whatsapp',
					'msg', null, null, null,
					function(e){
							var socialshare = Datastore.getSocialShare();
							socialshare.enable = true;
							socialshare.viaWhatsapp = true;
							Datastore.setSocialShare(socialshare);
					},
					 function(e){
						
					}
				);
			}
			else if(ionic.Platform.isAndroid()){

			}
			else{

			}
		}
	});
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
	// Remove back button text completely
	$ionicConfigProvider.backButton.previousTitleText(false).text('');

	$stateProvider
	.state('app', {
		url: "/app",
		abstract: true,
		templateUrl: "templates/menu.html",
		controller: 'AppCtrl'
	})

	.state('app.loading', {
		url: "/loading",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-loading.html",
				controller: 'LoadingCtrl'
			}
		}
	})

	.state('app.login', {
		url: "/login",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-login.html",
				controller: 'LoginCtrl'
			}
		}
	})

	//----------------------------------
	// Personal Chart
	//----------------------------------
	.state('app.personalchart', {
		url: "/personalchart",
		views: {
			'menuContent': {
				templateUrl: "templates/app-personalchart-list.html",
				controller: 'PersonalChartListCtrl'
			}
		}
	})

	.state('app.personalchart.create', {
		url: "/create",
		cache: false,
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-personalchart-create.html",
				controller: 'PersonalChartCreateCtrl'
			}
		}
	})

	.state('app.personalchart.edit', {
		url: "/edit",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-personalchart-edit.html",
				controller: 'PersonalChartEditCtrl'
			}
		}
	})

	.state('app.personalchart.report', {
		url: "/report",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-personalchart-report.html",
				controller: 'PersonalChartReportCtrl'
			}
		}
	})

	.state('app.personalchart.report_v2', {
		url: "/report_v2",
		cache: false,
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-v2.html",
				controller: 'PersonalChartReportCtrl_v2'
			}
		}
	})

	.state('app.personalchart.report_v2.type', {
		url: "/type",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-type.html",
				controller: 'TypeReportCtrl'
			}
		}
	})

	.state('app.personalchart.report_v2.profile', {
		url: "/profile",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-profile.html",
				controller: 'ProfileReportCtrl'
			}
		}
	})

	.state('app.personalchart.report_v2.authority', {
		url: "/authority",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-authority.html",
				controller: 'AuthorityReportCtrl'
			}
		}
	})


	.state('app.personalchart.report_v2.center', {
		url: "/center",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-center.html",
				controller: 'CenterReportCtrl'
			}
		}
	})

	.state('app.personalchart.report_v2.gate', {
		url: "/gate",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-gate.html",
				controller: 'GateReportCtrl'
			}
		}
	})

	.state('app.personalchart.report_v2.channel', {
		url: "/channel",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-channel.html",
				controller: 'ChannelReportCtrl'
			}
		}
	})

	//----------------------------------
	// Current Transit
	//----------------------------------

	.state('app.curtransitchart', {
		url: "/curtransitchart",
		params: {
			profile_id: null
		},	
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-curtransitchart.html",
				controller: 'CurTransitChartCtrl'
			}
		}
	})

	.state('app.curtransitchart.create', {
		url: "/create",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-curtransitchart-create.html",
				controller: 'CurTransitChartCreateCtrl'
			}
		}
	})

	.state('app.curtransitchart.report', {
		url: "/report",
		params: {
			profile_id: null
		},
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-curtransitchart-report.html",
				controller: 'CurTransitChartReportCtrl'
			}
		}
	})

	//----------------------------------
	// Relationship Chart
	//----------------------------------
	.state('app.relationshipchart', {
		url: "/relationshipchart",
		views: {
			'menuContent': {
				templateUrl: "templates/app-relationshipchart.html",
				controller: 'RelationshipChartCtrl'
			}
		}
	})

	.state('app.relationshipchart.p2', {
		url: "/p2",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-relationshipchart.html",
				controller: 'RelationshipChartCtrl'
			}
		}
	})

	.state('app.relationshipchart.report', {
		url: "/report",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-relationshipchart-report.html",
				controller: 'RelationshipChartReportCtrl'
			}
		}
	})


	//----------------------------------
	// Register and login
	//----------------------------------

	.state('app.register', {
		url: "/register",
		views: {
			'menuContent': {
				templateUrl: "templates/app-register.html",
				controller: 'RegisterCtrl'
			}
		}
	})

	//----------------------------------
	// Forget Password
	//----------------------------------

	.state('app.forgetpassword', {
		url: "/forgetpassword",
		views: {
			'menuContent': {
				templateUrl: "templates/app-forget-password.html",
				controller: 'ForgetPasswordCtrl'
			}
		}
	})

	//----------------------------------
	// Account
	//----------------------------------
	.state('app.account', {
		url: "/account",
		views: {
			'menuContent': {
				templateUrl: "templates/app-account.html",
				controller: 'AccountCtrl'
			}
		}
	})

	.state('app.account.edit', {
		url: "/edit",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-account-edit.html",
				controller: 'AccountEditCtrl'
			}
		}
	})

	.state('app.firstcreate', {
		url: "/firstcreate",
		views: {
			'menuContent': {
				templateUrl: "templates/app-personalchart-create.html",
				controller: 'PersonalChartCreateCtrl'
			}
		}
	})

	.state('app.account.report', {
		url: "/report",
		views: {
			'menuContent@app': {
				templateUrl: "templates/app-personalchart-report.html",
				controller: 'PersonalChartReportCtrl'
			}
		}
	})

	.state('app.account.report_v2', {
		url: "/report_v2",
		cache: false,
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-personalchart-report-v2.html",
				controller: 'PersonalChartReportCtrl_v2'
			}
		}
	})

	//----------------------------------
	// Rave Year
	//----------------------------------
	.state('app.raveyear', {
		url: "/raveyear",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-rave-year.html",
				controller: 'RaveYearCtrl'
			}
		}
	})

	//----------------------------------
	// Settings
	//----------------------------------
	.state('app.settings', {
		url: "/settings",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-settings.html",
				controller: 'SettingsCtrl'
			}
		}
	})

	//----------------------------------
	// About
	//----------------------------------
	.state('app.about', {
		url: "/about",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-about.html",
				controller: 'AboutMenuCtrl'
			}
		}
	})

	.state('app.about.humandesign', {
		url: "/humandesign",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-about-humandesign.html",
				controller: 'AboutHumandesignCtrl'
			}
		}
	})

	.state('app.about.hdreport', {
		url: "/hdreport",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-about-hdreport.html",
				controller: 'AboutHDreportCtrl'
			}
		}
	})

	.state('app.about.rauruhu', {
		url: "/rauruhu",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-about-rauruhu.html",
				controller: 'AboutRaUruHuCtrl'
			}
		}
	})

	.state('app.about.general', {
		url: "/general",
		views: {
			'menuContent@app': {
				templateUrl: "templates/page/app-about-general.html",
				controller: 'AboutGeneralCtrl'
			}
		}
	})

	//----------------------------------
	// Contact Us
	//----------------------------------
	.state('app.contact', {
		url: "/contact",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-contact-us.html"
			}
		}
	})

	//----------------------------------
	// Dictionary
	//----------------------------------
	.state('app.dictionarycategory', {
		url: "/dictionarycategory",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-dictionary-category.html",
				controller: 'DictionaryCategoryCtrl'
			}
		}
	})

	.state('app.dictionarylist', {
		url: "/dictionarylist/:category",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-dictionary-list.html",
				controller: 'DictionaryListCtrl'
			}
		},
		params: {category: null}
	})

	.state('app.dictionarydetail', {
		url: "/dictionarydetail/:id",
		views: {
			'menuContent': {
				templateUrl: "templates/page/app-dictionary-detail.html",
				controller: 'DictionaryDetailCtrl'
			}
		},
		params: {category: null}
	});


	// if none of the above states are matched, use this as the fallback
	//$urlRouterProvider.otherwise('/app/landing'); 
	
	$urlRouterProvider.otherwise('/app/loading');
});
