

angular.module('kolorbox.components', ['ng','ngResource',])
/*
======================================
Sign Up Directive component
======================================
*/
.directive('signupLoginController',function() {
		

var controller = function($state,$scope,$ionicModal,$ionicLoading,$ionicHistory,
																	$ionicPopup,
																	Utility,
																	Account,
																	Social,
																	Datastore,
																	LocalStorage,
																	KBToast){

	$scope.data = {
		username: null,
		password: null,
		code: null,
	};

	$scope.state = 'menu';

	$scope.device = {
		bIsNative: false,
		platform:'',
	}

	if (window.cordova){
		$scope.device.bIsNative = true;
	}

	//Get Device
	$scope.device.platform = ionic.Platform.platform().toLowerCase();

	$ionicModal.fromTemplateUrl('templates/app-account-signup_login.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal
	});

	var Redirect = function(){
		$scope.account.bGetPersonalChartData = false;
		$scope.account.bGetProfileData = false;

		console.log('Login, current state:',$state.current.name)
		$scope.account.bAppCtrlReInit = true;
		//console.log($scope.account);

		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();

		$ionicHistory.nextViewOptions({
			historyRoot : true,
		});

		$state.go('app.personalchart',{},{reload:true});

	}

	var LoginSuccess = function(){
		$scope.account.IsLoggedIn = true;

		if($scope.account.IsGuestAccount === true){
			$scope.account.profile = null;
			Datastore.setPersonalReportList(null);
			LocalStorage.setItem('user_id', null);
			LocalStorage.setItem('IsProfileChartGenerated', false)
			LocalStorage.removeObject('profile');
			LocalStorage.removeObject('personalChart');
		}

		$scope.account.IsGuestAccount = false;
		LocalStorage.setItem('IsGuestAccount',false);
		Redirect();
	}

	var SignUpSuccess = function(){
		$scope.account.IsLoggedIn = true;
		$scope.account.IsGuestAccount = false;
		LocalStorage.setItem('IsGuestAccount',false);
		Redirect();
	}

	var showWarningDialog = function(login,cancel) {
		var confirmPopup = $ionicPopup.confirm({
			title: $scope.t.dialog_login_warning_title,
			template: $scope.t.dialog_login_warning_content,
			cancelText: $scope.t.cancel_button,
			cancelType: 'button-balanced',
			okText: $scope.t.login_button,
			okType: 'button-assertive',
			cssClass: 'confirm-dialog',
		});

		confirmPopup.then(function(res) {
			if(res) {
				login();
			}
			else{
				cancel();
			}
		});
	};

	$scope.requestValidationCode = function(){
		// forgotPasswordData.showError = true;
		if(!$scope.data.username){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.forgetPassword($scope.data.username, function(data, status, headers, config){
			console.log('get forgot password validation code success');
			$scope.data.password = null;
			$scope.state = "validation";
			// forgotPasswordData.showError = false;
			$ionicLoading.hide();
			console.log($scope.state);			
		}, function(data, status, headers, config){
			$ionicLoading.hide();
			if(!data){
				KBToast.error($scope.t.dialog_network_error_title);
			} else {
				KBToast.error($scope.t.dialog_network_error_title);
			}
		});
	}

	$scope.validateCode = function(){
		// forgotPasswordData.showError = true;
		if(!$scope.data.code){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.validateCode($scope.data.code, function(data, status, headers, config){
			console.log('validate code success');
			$scope.state = "newpassword";
			// forgotPasswordData.showError = false;
			$ionicLoading.hide();
			console.log($scope.state);	
		}, function(data, status, headers, config){
			$ionicLoading.hide();
			KBToast.error($scope.t.msg_error_incorrect_code);
		});
	}

	$scope.updatePassword = function(){
		// forgotPasswordData.showError = true;
		if(!$scope.data.password){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.updatePassword($scope.data.code, $scope.data.password, $scope.data.password,
			function(data, status, headers, config){
				console.log('update password success');
				$scope.data.password = null;
				$scope.data.code = null
				$scope.state = "login"
				$ionicLoading.hide();
				KBToast.success($scope.t.msg_password_reset);				
			}, function(data, status, headers, config){
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_reset_password_fail);
			}
		);
	}

	$scope.OpenModal = function() {
		//Clear up
		$scope.data.username = null;
		$scope.data.password = null;
		$scope.data.code = null;
		$scope.state = 'menu';
		$scope.modal.show()
	};

	$scope.CloseModal = function() {
		switch($scope.state) {
			case "menu":
				$scope.modal.hide();
				break;
			case "signup":
				$scope.state = "menu";
				break;
			case "login":
				$scope.state = "menu";
				break;
			case "forgetpassword":
				$scope.state = "login";
				break;
			case "validation":
				$scope.state = "forgetpassword";
				break;
			case "newpassword":
				$scope.state = "validation";
				break;
			default:
				$scope.modal.hide();
		}
		// if($scope.state == 'menu'){
		// 	$scope.modal.hide()
		// }
		// else{
		// 	$scope.state = 'menu';
		// }
	};

	$scope.$on('$destroy', function() {
			$scope.modal.remove();
		});

	$scope.OnLogin = function() {
		console.log('OnLogin');
		$scope.state = 'login';
	}

	$scope.OnSignUp = function() {
		console.log('OnSignUp');
		$scope.state = 'signup';
	}

	$scope.OnForgetPassword = function() {
		$scope.state = 'forgetpassword';
		console.log($scope.state);
	}

	$scope.OnSubmit = function(){

		if(typeof $scope.data.username	=== "undefined" || typeof $scope.data.password === "undefined"){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		if($scope.data.username == '' || $scope.data.password == ''){
			KBToast.error($scope.t.msg_fill_required_info);
			return;	
		}

		if($scope.data.username == null || $scope.data.password == null){
			KBToast.error($scope.t.msg_fill_required_info);
			return;	
		}



		if($scope.state == 'signup'){
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			Account.signUp($scope.data,
				function(data, status, headers, config){
					//Success Callback
					$ionicLoading.hide();

					if(status == 200){
						$scope.modal.hide();
						SignUpSuccess();
					}
				},
				function(data, status, headers, config){
					//Fail Callback
					$ionicLoading.hide();
					console.log(status,data);
					if (status == 409){
						KBToast.error($scope.t.Username_exist);
					}
					else
					{
						KBToast.error($scope.t.create_account_fail);
					}
				}
			);
		}
		else if($scope.state == 'login'){
			console.log('Start Login')

			var LoginProcess = function(){
				$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
				Account.login($scope.data.username,$scope.data.password,
					function(data, status, headers, config){
						//Success Callback
						$ionicLoading.hide();
						if(status == 200){
							console.log('Start Login Success');
							$scope.modal.hide();
							LoginSuccess();
						}
					},
					function(data, status, headers, config){
						//Fail Callback
						console.log('Start Login Fail');
						$ionicLoading.hide();
						KBToast.debug(status +' ' + data);
						KBToast.error($scope.t.login_fail);
					}
				);
			}
			console.log($scope.account)
			if($scope.account.IsGuestAccount === true){
				
				//Get Account exist paid report or not
				var bHasPaidReport = false;

				if($scope.account.profile === null || typeof $scope.account.profile === 'undefined'){
					bHasPaidReport = false
				}
				else{
					if($scope.account.profile.paid === true){
						bHasPaidReport = true
					}
					else{
						var personalReportList = Datastore.getPersonalReportList();
						for (i in personalReportList){
							if(personalReportList[i].paid === true){
								bHasPaidReport = true
								break;
							}
						}
					}
				}

				if(bHasPaidReport === true){
					showWarningDialog(
						function(){
							//Confirm to login
							LoginProcess();
						},
						function(){
							//cancel
							//router to sign up page
							$scope.state = 'signup';
						}
					)
				}
				else{
					LoginProcess();
				}
			}
			else{
				LoginProcess();
			}
		}
	};

	$scope.OnFBSubmit = function(){

		//1. Login Facebook
		Social.loginFacebook(
			function(data){
				//Facebook Plugin Login Success
				//2. Django Server Login
				$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
											
				//2.1 Login
				if($scope.state == 'login'){
					Account.loginWithSocialAccount('facebook',data.id,
						function(data, status, headers, config){
							$ionicLoading.hide();
							if(status == 200){
								//Login Success
								$scope.modal.hide();
								LoginSuccess();
							}
							else{
								KBToast.debug(status +' ' + data);
								KBToast.error($scope.t.login_fail);
							}
						},
						function(data, status, headers, config){
							//Login Fail
							$ionicLoading.hide();
							KBToast.debug(status +' ' + data);
							KBToast.error($scope.t.login_fail);
						}
					);
				}//end of login
				else if($scope.state == 'signup'){
					Account.connectSocialAccount('facebook',data.id,
						function(data, status, headers, config){
							$ionicLoading.hide();
							if(status == 200){
								$scope.modal.hide();
								SignUpSuccess();
							}
						},
						function(data, status, headers, config){
							$ionicLoading.hide();
							if(status == 409){
								KBToast.error('This facebook account has already in use');
							}
							else{
								KBToast.debug(status +' ' + data);
							}
						}
					);
				}//end of sign up
			},
			function(data){
				//Facebook Plugin Login FAil
				KBToast.debug(data);
				KBToast.error($scope.t.login_fail);
			}
		);//end of loginWithFacebook							
	};
}//end of controller

	return {
			restrict: 'E',
			scope: {
				account: '=',
				t: '=',
				settings:'=',
				style: '@',
			},
			controller: controller,
			replace: true,
			template: '<button menu-close class="{{style}}" style="color:#000;" ng-click="OpenModal()">{{t.signup_login_button}}</button>',
			link: function($scope, $element, $attrs) {
			}
	};
})

/*
======================================
Logout Directive component
======================================
*/
.directive('logoutController',function() {
		

	var controller = function($scope,$state,$ionicModal,$ionicLoading,$ionicHistory,Utility,
																					Account,
																					Social,
																					Datastore,
																					LocalStorage,
																					KBToast){
		$ionicModal.fromTemplateUrl('templates/app-account-logout.html',{
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal
		});

		$scope.OpenModal = function() {
			$scope.modal.show()
		};

		$scope.CloseModal = function() {
			$scope.modal.hide()
		};

		$scope.$on('$destroy', function() {
			$scope.modal.remove();
		});

		$scope.OnLogout = function(){
					
			Account.logout();
			$scope.account.IsLoggedIn =	Account.isLoggedIn();

			//Clear Up
			$scope.account.profile = null;
			Datastore.setPersonalReportList(null);
			LocalStorage.setItem('user_id', null);
			LocalStorage.setItem('IsProfileChartGenerated', false)
			LocalStorage.removeObject('profile');
			LocalStorage.removeObject('personalChart');

			$scope.account.bGetPersonalChartData = false;
			$scope.account.bGetProfileData = false;
			$scope.account.IsProfileChartGenerated = false;

			$ionicHistory.clearHistory();
			$ionicHistory.clearCache();
			$ionicHistory.nextViewOptions({
				historyRoot : true,
			});
			$state.go('app.login');

		};
	};

	return {
			restrict: 'E',
			scope: {
				account: '=',
				t: '=',
				style: '@',
			},
			controller: controller,
			replace: true,
			template: '<button menu-close class="{{style}}" ng-click="OpenModal()"><i class="fa fa-sign-out fa-lg fa-fw"></i> {{t.logout_button}}</button>',
			link: function($scope, $element, $attrs) {}
	};
})

/*
======================================
Loction Picker Directive component
======================================
*/
.directive('locationPicker',function() {
		

	var controller = function($scope,$filter,$ionicModal,$ionicLoading,LocalStorage){
			

		$scope.OpenLocPickerModal = function(){
			//console.log('Recently Search List:',$scope.search)
			if(!$scope.showPicker){
				return;
			}
			
			$scope.LocPickerModal.show();
		}

		$scope.CloseLocPickerModal = function(){
			$scope.LocPickerModal.hide();
		}

		$scope.selectUTC = function(utc) {
			$scope.birth.location = null;
			$scope.birth.timezone = "";
			$scope.birth.city = "";
			$scope.data.label = "UTC " + utc.offset;
			$scope.search.state = "utcoffset";
			$scope.birth.offset = utc.offset;

			$scope.LocPickerModal.hide();
		}
		
		$scope.selectLocation = function(loc,bIsSearch) {
			$scope.birth.location = angular.copy(loc);
			$scope.birth.timezone = loc.tz;
			$scope.birth.city	= $filter('capitalize')(loc.name);
			$scope.data.label = $scope.birth.city
			$scope.search.state = "location";
			$scope.birth.offset = null;

			var exist = _.findWhere( $scope.recentlySearch,{
				name: loc.name,
				cc: loc.cc,
			})

			//console.log('exist',exist)	

			if(exist === null || typeof exist === 'undefined'){
				$scope.recentlySearch.unshift(loc)
				LocalStorage.setObject('recentlySearch',$scope.recentlySearch)	
			}
			else{
				if (bIsSearch === true){
					//Move object to the front
					var index = $scope.recentlySearch.indexOf(exist)
					$scope.recentlySearch.splice(index,1)
					$scope.recentlySearch.unshift(loc)
					LocalStorage.setObject('recentlySearch',$scope.recentlySearch)
				}	
			}

			$scope.LocPickerModal.hide();
		}

		$scope.$watch('birth.city', function(newVal, oldVal){
			console.log('birth.city switch',newVal,oldVal)
			if(newVal == "" || newVal === null || typeof newVal == "undefined"){
				if(!$scope.t){
					return;
				}
				
				// $scope.data.label = $scope.t.text_city_select;
				$scope.search.city = ""	
				
				if ($scope.birth){
					$scope.birth.location = null;	

					if ($scope.birth.offset === "" || $scope.birth.offset === null || typeof $scope.birth.offset === "undefined") {
						$scope.birth.offset = null;
					} 
					else {
						$scope.data.label = "UTC " + $scope.birth.offset;
					}
				}
			}
			else{
				$scope.data.label = $scope.birth.city;
				//$scope.search.city = $scope.birth.city
			}
		});

		// $scope.$watch('birth.location.lat', function(newVal, oldVal){

		// 	console.log('birth.location.lat switch',newVal,oldVal)
		// 	if($scope.birth && $scope.birth.location){
		// 		$scope.map.center.lat = $scope.birth.location.lat;
		// 		$scope.map.center.lng = $scope.birth.location.lng;
		// 		$scope.map.center.zoom = 5;

		// 		$scope.map.markers.mark.lat = $scope.birth.location.lat;
		// 		$scope.map.markers.mark.lng = $scope.birth.location.lng;
		//  	}
		// });

		//init
		$scope.data = {};
		$scope.search = {};
		$scope.search.city = "";
		$scope.recentlySearch = LocalStorage.getObject('recentlySearch');
		$scope.search.state = "location";
		
		$scope.device = {
			bIsNative: false,
			platform:'',
		}

		if (window.cordova){
			$scope.device.bIsNative = true;
		}

		//Get Device
		$scope.device.platform = ionic.Platform.platform().toLowerCase();


		if($scope.recentlySearch  === null || typeof $scope.recentlySearch == 'undefined'){
			$scope.recentlySearch = [];
			LocalStorage.setObject('recentlySearch',$scope.recentlySearch)
		}


		
		$ionicModal.fromTemplateUrl('templates/modal/location-picker.html',{
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.LocPickerModal = modal
		});
	};

	return {
		restrict: 'E',
		scope: {
			birth: '=',
			t: '=',
			locations: '=',
			utcoffsets: '=',
			map: '=',
			showError: '=',
			showPicker: '='
		},
		controller: controller,
		replace: true,
		template: '<div ng-click="OpenLocPickerModal()" class="input-border text-center" style="padding-top:20px;padding-bottom:10px;position:relative;">' +
					'<label ng-if="birth.location === null && birth.offset === null" style="color:#fff;">{{t.text_city_select}}</label>' +
					'<label ng-if="birth.location !== null" >{{data.label}}</label>' +
					'<label ng-if="birth.location === null && birth.offset !== null" >{{data.label}}</label>' +
					'<label ng-if="birth.location == null && birth.offset === null && showError" class="assertive label-error">'+
						'<small>{{t.text_required}}</small>' +
					'</label>' +
				  '</div>',
		link: function($scope, $element, $attrs) {}
	};
})

/*
.directive('locationPickerCtrl',function() {
		

	var controller = function($scope,$filter,$ionicModal,$ionicLoading,Utility,Account,Datastore,LocalStorage){
			
		$scope.map = Datastore.getGoogleMapSetting();

		$scope.selectLocation = function(loc) {
			$scope.birth.location = angular.copy(loc);
			$scope.birth.timezone = loc.tz;
			$scope.birth.city	= $filter('capitalize')(loc.name);			
			$scope.state.locationSelected = true;
		}

		$scope.$watch('birth.city', function(newVal, oldVal){
			if(newVal && oldVal && newVal.length < oldVal.length){
				$scope.birth.location = null;
				$scope.state.locationSelected = false;
			}
		});

		$scope.$watch('birth.location.lat', function(newVal, oldVal){
			if($scope.birth && $scope.birth.location){
				$scope.map.center.lat = $scope.birth.location.lat;
				$scope.map.center.lng = $scope.birth.location.lng;
				$scope.map.center.zoom = 5;

				$scope.map.markers.mark.lat = $scope.birth.location.lat;
				$scope.map.markers.mark.lng = $scope.birth.location.lng;
		 	}
		});

	};

	return {
		restrict: 'E',
		scope: {
			birth: '=',
			t: '=',
			locations: '=',
			state: '=',
		},
		controller: controller,
		replace: true,
		templateUrl: 'templates/app-location-picker.html',
		link: function($scope, $element, $attrs) {}
	};
})
*/

/*
======================================
Gate Row Directive component
======================================
*/
.directive('chartPanelDetail',function() {

	var controller = function($scope){		
		/*
		$scope.planets = [
				{name:'sun',icon: $scope.icondir+'Sun_symbol.svg'},
				{name:'earth',icon: $scope.icondir+'Earth_symbol.svg'},
				{name:'moon',icon: $scope.icondir+'Moon_symbol.svg'},
				{name:'north_node',icon: $scope.icondir+'Northnode_symbol.svg'},
				{name:'south_node',icon: $scope.icondir+'Southnode_symbol.svg'},
				{name:'mercury',icon: $scope.icondir+'Mercury_symbol.svg'},
				{name:'venus',icon: $scope.icondir+'Venus_symbol.svg'},
				{name:'mars',icon: $scope.icondir+'Mars_symbol.svg'},
				{name:'jupiter',icon: $scope.icondir+'Jupiter_symbol.svg'},
				{name:'saturn',icon: $scope.icondir+'Saturn_symbol.svg'},
				{name:'uranus',icon: $scope.icondir+'Uranus_symbol.svg'},
				{name:'neptune',icon: $scope.icondir+'Neptune_symbol.svg'},
				{name:'pluto',icon: $scope.icondir+'Pluto_symbol.svg'},
		];*/

		
		$scope.planets = [
				{name:'sun',icon: $scope.icondir+'sun.png'},
				{name:'earth',icon: $scope.icondir+'earth.png'},
				{name:'moon',icon: $scope.icondir+'moon.png'},
				{name:'north_node',icon: $scope.icondir+'north_node.png'},
				{name:'south_node',icon: $scope.icondir+'south_node.png'},
				{name:'mercury',icon: $scope.icondir+'mercury.png'},
				{name:'venus',icon: $scope.icondir+'venus.png'},
				{name:'mars',icon: $scope.icondir+'mars.png'},
				{name:'jupiter',icon: $scope.icondir+'jupiter.png'},
				{name:'saturn',icon: $scope.icondir+'saturn.png'},
				{name:'uranus',icon: $scope.icondir+'uranus.png'},
				{name:'neptune',icon: $scope.icondir+'neptune.png'},
				{name:'pluto',icon: $scope.icondir+'pluto.png'},
		];

		$scope.$watch('con', function(newVal, oldVal){
			for( key in newVal){
				for (i in $scope.planets){
					if($scope.planets[i].name == key){
						$scope.planets[i].con = newVal[key];
						break;
					}
				}
			}
		});

		$scope.$watch('uncon', function(newVal, oldVal){
			for( key in newVal){
				for (i in $scope.planets){
					if($scope.planets[i].name == key){
						$scope.planets[i].uncon = newVal[key];
						break;
					}
				}
			}
		});
	}

	return {
		restrict: 'E',
		scope: {
				con: '=',
				uncon: '=',
				color: '@',
				icondir: '@',
				iscurtransit: '='
		},
		controller: controller,
		//replace: true,
		templateUrl: 'templates/app-chartpanel-detail.html',
		link: function($scope, $element, $attrs) {}
	};
})


;
