angular.module('starter.controllers',['ionic','kolorbox.utility','kolorbox.utility','kolorbox.services','kolorbox.components','kolorbox.kbstore'])


.controller('AppCtrl', function($scope,$state,$ionicLoading,$ionicHistory,
															$ionicPopup,
															$timeout,
															$ionicModal,
															$ionicPlatform,
															$log,
															KBToast,
															LocalStorage,
															Datastore,
															Airstation,
															Location,
															Location_v2,
															Translation,
															Account,
															Utility,
															KBToast,
															Social,
															TimeOffset,
															ReportManager,
															AboutContentManager,
															SectionContentManager){
	
	//------------------------------
	// Function Define
	//------------------------------
	$scope.logout = function(){
		
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		Account.logout();
		Social.logout();
		$scope.account.IsLoggedIn =	Account.isLoggedIn();

		//Clear Up
		$scope.account.profile = null;
		Datastore.setPersonalReportList([]);
		LocalStorage.setItem('user_id', null);
		LocalStorage.setItem('IsProfileChartGenerated', false)
		// LocalStorage.setItem('IsGuestAccount', true);
		LocalStorage.removeObject('IsGuestAccount');
		LocalStorage.removeObject('profile');
		LocalStorage.removeObject('personalChart');
		

		$scope.account.bGetPersonalChartData = false;
		$scope.account.bGetProfileData = false;
		$scope.account.IsProfileChartGenerated = false;
		$scope.account.IsGuestAccount = null;
		$scope.state = "menu";

		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();
		$ionicHistory.nextViewOptions({
			historyRoot : true,
		});

		Init();
		console.log('end of logout');
		// $state.go('app.personalchart.create');
	}

	var ShowRetryDialog = function(){
		var alertPopup = $ionicPopup.alert({
			title: $scope.t.dialog_network_error_title,
			template: $scope.t.dialog_network_error_content,
			okText: $scope.t.retry_button,
			okType: 'button-assertive',
			cssClass: 'confirm-dialog',
		});

		alertPopup.then(function(res){
			Init();
		});
	}

	var Redirect = function(){

		$scope.account.bAppCtrlReInit = false
		
		if($scope.account.IsProfileChartGenerated === false){
			console.log('AppCtrl Redirect firstcreate')

			$ionicHistory.nextViewOptions({
				historyRoot : true,
			});

			$state.go('app.firstcreate');
		}
		else if ($state.current.name != 'app.personalchart'){
			$ionicHistory.nextViewOptions({
				historyRoot : true,
			});
			$state.go('app.personalchart');
		}
	}

	var RefreshProfileData = function() {
		console.log("Refresh Profile from server");
		Account.getProfile(
			function(data, status, headers, config){
				//Success Callback
				if(status == 200){
					$scope.account.profile = data[0];
					LocalStorage.setObject('profile',$scope.account.profile);

				}//end of status 200
				else{
					KBToast.error('Fail to get profile data');
					KBToast.debug(status +' ' + data);
				}
				$scope.refresh = false;

			},//end of get profile success
			function(data, status, headers, config){
				//Fail Callback
				KBToast.error('Fail to get profile data');
				KBToast.debug(status +' ' + data);
				if(status == 401){
					console.log('Get profile Unauthorized');
				}

				$scope.refresh = false;
			}
		);
	}

	var GetProfileData = function(sccuess,fail){
		console.log("GetProfileData");

		var getProfileComplete = function(){
			if($scope.account.profile.chart_img_url != ""){
				LocalStorage.setItem('IsProfileChartGenerated',true);
				$scope.account.IsProfileChartGenerated = true;
			}
			else{
				LocalStorage.setItem('IsProfileChartGenerated',false);
				$scope.account.IsProfileChartGenerated = false;
			}

			LocalStorage.setItem('user_id', $scope.account.profile.id);
			LocalStorage.setObject('profile',$scope.account.profile);

			$scope.account.bGetProfileData = true;

			sccuess();

			console.log($scope.account.profile);
		}

		//Get Profile from Local Storage
		// $scope.account.profile = LocalStorage.getObject('profile');

		// if($scope.account.profile !== null && $scope.account.profile.is_staff !== undefined && $scope.account.profile.is_staff !== null){
		// 	console.log("Profile Exist In Local");
		// 	//console.log($scope.account);
		// 	Utility.AdjustBirthByLocation($scope.account.profile);
		// 	getProfileComplete();
		// }
		// else{
			//Get Profile from Server
			console.log("Get Profile from server");
			Account.getProfile(
				function(data, status, headers, config){
					//Success Callback
					if(status == 200){
						$scope.account.profile = data[0];

						console.log("GetProfileData Success");
						//console.log($scope.account.profile);

						//Get time zone from location
						Utility.AdjustBirthByLocation($scope.account.profile);
						getProfileComplete();

					}//end of status 200
					else{
						KBToast.error('Fail to get profile data');
						KBToast.debug(status +' ' + data);
					}		 
				},//end of get profile success
				function(data, status, headers, config){
					//Fail Callback
					KBToast.error('Fail to get profile data');
					KBToast.debug(status +' ' + data);
					if(status == 401){
						console.log('Get profile Unauthorized');
						$scope.logout();
					}
					else{
						fail();
					}
				}
			);
		// }
	}

	var GetPersonalChartData = function(sccuess,fail){
		console.log("GetPersonalChartData");

		var GetPersonalChartComplete = function(){

			Datastore.setPersonalReportList($scope.personalReportList);
			$scope.account.bGetPersonalChartData = true;

			if($scope.personalReportList.length > 0){
				$scope.account.bPesonalChartExist = true
			}
			else{
				$scope.account.bPesonalChartExist = false
			}
			sccuess();
		}

		//Get Personal Chart from Data Storage
		$scope.personalReportList = Datastore.getPersonalReportList();

		if($scope.personalReportList !== null){
			console.log("Personal Chart List Exist In Local");
			//console.log($scope.account);

			GetPersonalChartComplete();
		}
		else{
			//Get Personal Chart From Server
			console.log("Get Personal Chart List From Server");
			Airstation.list({app:'hdapp',resource:'personalchart'},
				function(rpn_data){
					//2.1 Success Handle
					console.log("GetPersonalChartData Success");

					//2.2 Adjust Birth Datetime
					for (index in rpn_data){
						var chart_data = rpn_data[index];
						Utility.AdjustBirthByLocation(chart_data);
					}

					$scope.personalReportList = rpn_data;
					GetPersonalChartComplete();
				},
				function(error) {
					//2.1 Fail Handle
					KBToast.error('failed to get personal chart list');
					fail();
				}
			);
		}
	}

	//Get dictionary data
	var getDictionaryData = function(){
		$scope.getCenterTypeList();
		$scope.getTypeTypeList();
		$scope.getGateTypeList();
		$scope.getAuthorityTypeList();
		$scope.getProfileTypeList();
		$scope.getChannelTypeList();
	}

	$scope.checkEmail = function (email) {
	    var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;

	    if (!filter.test(email)) {
		    return false;
	 	} else return true;
	}

	$scope.getCenterTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'centertype', lg: $scope.settings.lg}, function(data){
			console.log('get centertype success, data:', data);
			$scope.ds.centerTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('centertypelist_'+$scope.settings.lg, $scope.ds.centerTypeList);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get centertype failed, error', error);
			$scope.ds.centerTypeList[$scope.settings.lg] = LocalStorage.getObject('centertypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getTypeTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'typetype', lg: $scope.settings.lg}, function(data){
			console.log('get typetype list success, data:', data);
			$scope.ds.typeTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('typetypelist_'+$scope.settings.lg, $scope.ds.typeTypeList);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get typetype list failed, error:', error);
			$scope.ds.typeTypeList[$scope.settings.lg] = LocalStorage.getObject('typetypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getGateTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'gatetype', lg: $scope.settings.lg}, function(data){
			console.log('get gatetype list success, data:', data);
			$scope.ds.gateTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('gatetypelist_'+$scope.settings.lg, $scope.ds.gateTypeList);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get gatetype list failed, error:', error);
			$scope.ds.gateTypeList[$scope.settings.lg] = LocalStorage.getObject('gatetypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getAuthorityTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'authoritytype', lg: $scope.settings.lg}, function(data){
			console.log('get authoritytype list success, data:', data);
			$scope.ds.authorityTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('authoritytypelist_'+$scope.settings.lg, $scope.ds.authoritytypelist);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get authoritytype list failed, error:', error);
			$scope.ds.authorityTypeList[$scope.settings.lg] = LocalStorage.getObject('authoritytypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getProfileTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'profiletype', lg: $scope.settings.lg}, function(data){
			console.log('get profiletype list success, data:'. data);
			$scope.ds.profileTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('profiletypelist_'+$scope.settings.lg, $scope.ds.profileTypeList);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get profiletype list failed, error:', error);
			$scope.ds.profileTypeList[$scope.settings.lg] = LocalStorage.getObject('profiletypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getChannelTypeList = function(successCallback, failCallback){
		Airstation.list({app: 'hdapp', resource: 'channeltype', lg: $scope.settings.lg}, function(data){
			console.log('get channeltype list success, data:', data);
			$scope.ds.channelTypeList[$scope.settings.lg] = data;
			LocalStorage.setObject('channeltypelist_'+$scope.settings.lg, $scope.ds.channelTypeList);
			if(successCallback){
				successCallback(data);
			}
		}, function(error){
			console.log('get channeltype list failed, error:', error);
			$scope.ds.channelTypeList[$scope.settings.lg] = LocalStorage.getObject('channeltypelist_'+$scope.settings.lg);
			if(failCallback){
				failCallback();
			}
		});
	}

	$scope.getRaveYear = function(){
		Airstation.get({app: 'hdapp', resource: 'raveyear'}, function(data){
			console.log('get raveyear success, data:', data);
			$scope.ds.raveyear = data.results;
			LocalStorage.setObject('raveyear', $scope.ds.raveyear);
		}, function(error){
			console.log('get raveyear failed, error:', error);
			$scope.ds.raveyear = LocalStorage.getObject('raveyear');
		});
	}

	//------------------------------
	// Functions for login and signup
	//------------------------------
	$scope.data = {
		username: null,
		password: null,
		code: null,
	};

	$scope.state = 'menu';

	var directToPersonal = function(){
		$scope.account.bGetPersonalChartData = false;
		$scope.account.bGetProfileData = false;

		console.log('Login, current state:',$state.current.name)
		$scope.account.bAppCtrlReInit = true;
		//console.log($scope.account);

		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();

		$ionicHistory.nextViewOptions({
			historyRoot : true,
		});

		$state.go('app.personalchart',{},{reload:true});

	}

	var LoginSuccess = function(){
		console.log("LoginSuccess");
		$scope.account.IsLoggedIn = true;

		if($scope.account.IsGuestAccount === true){
			$scope.account.profile = null;
			Datastore.setPersonalReportList(null);
			LocalStorage.setItem('user_id', null);
			LocalStorage.setItem('IsProfileChartGenerated', false)
			LocalStorage.removeObject('profile');
			LocalStorage.removeObject('personalChart');
		}

		$scope.state = "menu";
		$scope.account.IsGuestAccount = false;
		LocalStorage.setItem('IsGuestAccount',false);
		directToPersonal();
	}

	var SignUpSuccess = function(){
		console.log("SignUpSuccess");
		$scope.account.IsLoggedIn = true;
		$scope.account.IsGuestAccount = false;
		LocalStorage.setItem('IsGuestAccount',false);
		if ($scope.status.payment === true) {
			$scope.state = "thankyou";
			// setTimeout(function() {
			// 	$ionicHistory.goBack()
			// }, 5000);
			$scope.status.paymentCountDown = 5;
			console.log("countdown", $scope.status.paymentCountDown);
			$scope.onCountDown();
		} 
		else {
			directToPersonal();
		}
	}

	var showWarningDialog = function(login,cancel) {
		var confirmPopup = $ionicPopup.confirm({
			title: $scope.t.dialog_login_warning_title,
			template: $scope.t.dialog_login_warning_content,
			cancelText: $scope.t.cancel_button,
			cancelType: 'button-balanced',
			okText: $scope.t.login_button,
			okType: 'button-assertive',
			cssClass: 'confirm-dialog',
		});

		confirmPopup.then(function(res) {
			if(res) {
				login();
			}
			else{
				cancel();
			}
		});
	}

	$scope.onCountDown = function() {
		if ($scope.status.paymentCountDown > 0) {
			console.log("countdown", $scope.status.paymentCountDown);
			$scope.status.paymentCountDown--;
			$scope.counter = setTimeout($scope.onCountDown, 1000);
			if(!$scope.$$phase) {
				$scope.$apply();
			}
		} 
		else {
			$scope.onStopCountDown();
			$ionicHistory.goBack();
		}
	}

	$scope.onStopCountDown = function() {
		clearTimeout($scope.counter);
	}

	$scope.goState = function(state) {
		$state.go(state);
	}

	$scope.goBack = function() {
		$ionicHistory.goBack();
	}

	$scope.priceSplit = function(price_str, index) {
		var res = price_str.split("$", 2);
		res[0] = res[0] + "$";
		return res[index];
	}

	$scope.channelSplit = function(channel_str, index) {
		var res = channel_str.split(" ", 2);
		return res[index];
	}

	$scope.loginWithSocialAccount = function(provider){
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		if(provider === "facebook"){
			Social.loginWithFacebook(function(token){
				$log.log('login to facebook success, token:', token);
				//get access token from server
				var formData = {
					access_token: token
				}
				Airstation.post({app: 'account', resource: 'socialsignup'}, formData, function(data){
					$log.log('create social account success, username: ', data.username);
					var userprofile = data;
					Account.login(data.username, token, function(data, status, header, config){
						$log.log('login with social account success, data:', data);
						$scope.ds.isSocialAccount = true;
						LocalStorage.setItem('is_social_account', true);

						$scope.account.is_social_account = LocalStorage.getItem('is_social_account');
						$scope.account.profile = data;

						//Update the username by using the Facebook name
						var local_soical_account = LocalStorage.getObject('social_account');
						var formdata = {
							username: local_soical_account.name + local_soical_account.id.substring(0,5)
						};
						console.log("facebook update", formdata);
						console.log("scope account id", LocalStorage.getObject('profile').id);

						Airstation.put(
							{
								app:'account',
								resource:'update',
								id:LocalStorage.getObject('profile').id,
							},
							formdata,
							function(rpn_data){

							},function(error){
								//2.1 Fail Handle
								if (error.data === "username already exist") {
									KBToast.error($scope.t.Username_exist);	
								} 
								else {
									KBToast.error($scope.t.update_profile_fail);
								}
							}
						);

						$ionicLoading.hide();
						if(status == 200){
							console.log('Start Login Success');
							SignUpSuccess();
						}
					}, function(data, status, headers, config){
						$log.log('login with social accout failed, status:', status, ', data:', data);
						$ionicLoading.hide();
						if(!data){
							KBToast.error($scope.t.text_no_network);
						} else {
							KBToast.error($scope.t.login_fail);
						}
					});
				}, function(error, status){
					$log.log('create social account failed, error:', error);
					// KBToast.error($scope.t.login_fail);
					//clear social account
					console.log("get social_account storage", LocalStorage.getObject("social_account"));
					Account.logout();

						Airstation.post({app: 'account', resource: 'socialsignup'}, formData, function(data){
							$log.log('get social account success, username: ', data.username);
							var userprofile = data;
							Account.login(data.username, token, function(data, status, header, config){
								$log.log('login with social account success, data:', data);
								$scope.ds.isSocialAccount = true;
								LocalStorage.setItem('is_social_account', true);

								$scope.account.is_social_account = LocalStorage.getItem('is_social_account');
								$scope.account.profile = data;
								console.log("scope account", $scope.account);

								$ionicLoading.hide();
								if(status == 200){
									console.log('Start Login Success');
									LoginSuccess();
								}
							}, function(data, status, headers, config){
								$log.log('login with social accout failed, status:', status, ', data:', data);
								$ionicLoading.hide();
								if(!data){
									KBToast.error($scope.t.text_no_network);
								} else {
									KBToast.error($scope.t.login_fail);
								}
							});
						}, function(error, status){
							$log.log('create social account failed, error:', error);
							KBToast.error($scope.t.login_fail);
							//clear social account
							Social.logout();
							$scope.logout();
						});

					$ionicLoading.hide();
				});

			}, function(error){
				$log.log('login to facebook failed, error: ', error);
				KBToast.error($scope.t.login_fail);
				$ionicLoading.hide();
			});
		}
	}

	$scope.requestValidationCode = function(){
		// forgotPasswordData.showError = true;
		if (!$scope.checkEmail($scope.data.username)) {
			KBToast.error($scope.t.msg_fill_valid_email);
			return;
		}

		if(!$scope.data.username){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.forgetPassword($scope.data.username, function(data, status, headers, config){
			console.log('get forgot password validation code success');
			$scope.data.password = null;
			$scope.previousState = $scope.state;
			$scope.state = "validation";
			$ionicLoading.hide();
			console.log($scope.state);			
		}, function(data, status, headers, config){
			$ionicLoading.hide();
			if(!data){
				KBToast.error($scope.t.dialog_network_error_title);
			} 
			else {
				KBToast.error(data.identifier[0]);
			}
		});
	}

	$scope.validateCode = function(){
		// forgotPasswordData.showError = true;
		if(!$scope.data.code){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.validateCode($scope.data.code, function(data, status, headers, config){
			console.log('validate code success');
			$scope.state = "newpassword";
			$ionicLoading.hide();
			console.log($scope.state);	
		}, function(data, status, headers, config){
			$ionicLoading.hide();
			KBToast.error($scope.t.msg_error_incorrect_code);
		});
	}

	$scope.updatePassword = function(){
		// forgotPasswordData.showError = true;
		if(!$scope.data.password){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		Account.updatePassword($scope.data.code, $scope.data.password, $scope.data.password,
			function(data, status, headers, config){
				console.log('update password success');
				$scope.data.password = null;
				$scope.data.code = null
				$scope.state = "login"
				$ionicHistory.goBack();
				$ionicLoading.hide();
				KBToast.success($scope.t.msg_password_reset);				
			}, function(data, status, headers, config){
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_reset_password_fail);
			}
		);
	}

	$ionicPlatform.registerBackButtonAction(function () {
		console.log("registerBackButtonAction");
		if ($scope.state === "forgetpassword") {
			$scope.state = "login";
			$ionicHistory.goBack();	
		}
		else if($ionicHistory.backView()) {
			$ionicHistory.goBack();	
		}
		else navigator.app.exitApp();
	}, 100);

	$scope.registerStateBack = function() {
		switch($scope.state) {
			case "menu":
				$ionicHistory.goBack();
				break;
			case "signup":
				$scope.state = "menu";
				break;
			case "login":
				$scope.state = "menu";
				break;
			case "forgetpassword":
				$scope.state = "login";
				break;
			case "resetpassword":
				$scope.state = "login";
				break;
			case "validation":
				$scope.state = "forgetpassword";
				break;
			case "newpassword":
				$scope.state = "validation";
				break;
			case "directlogin":
				$scope.state = "login"
			default:
				$ionicHistory.goBack();
		}
	}

	$scope.goBackPassword = function() {
		switch($scope.state) {
			case "forgetpassword":
				$scope.state = "login";
				$ionicHistory.goBack();
				break;
			case "resetpassword":
				$scope.state = "login";
				$ionicHistory.goBack();
				break;
			case "validation":
				$scope.state = $scope.previousState;
				break;
			case "newpassword":
				$scope.state = "validation";
				break;
			case "directlogin":
				$scope.state = "login"
			default:
				$ionicHistory.goBack();
		}

	}

	$scope.OnLogin = function() {
		console.log('OnLogin');
		$scope.state = 'login';
	}

	$scope.OnSignUp = function() {
		console.log('OnSignUp');
		$scope.state = 'signup';
	}

	$scope.OnForgetPassword = function() {
		$scope.data.username = "";
		$scope.state = 'forgetpassword';
		console.log($scope.state);
	}

	$scope.OnResetPassword = function() {
		$scope.data.username = $scope.account.profile.username;
		$scope.state = 'resetpassword';
	}

	$scope.OnSubmit = function(){

		if(typeof $scope.data.username	=== "undefined" || typeof $scope.data.password === "undefined"){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		if($scope.data.username == '' || $scope.data.password == ''){
			KBToast.error($scope.t.msg_fill_required_info);
			return;	
		}

		if($scope.data.username == null || $scope.data.password == null){
			KBToast.error($scope.t.msg_fill_required_info);
			return;	
		}

		if ($scope.state === "signup" && !$scope.checkEmail($scope.data.username)) {
			KBToast.error($scope.t.msg_fill_valid_email);
			return;
		}

		if($scope.state == 'signup'){
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			Account.signUp($scope.data,
				function(data, status, headers, config){
					//Success Callback
					$ionicLoading.hide();

					if(status == 200){
						SignUpSuccess();
					}
				},
				function(data, status, headers, config){
					//Fail Callback
					$ionicLoading.hide();
					console.log(status,data);
					if (status == 409){
						KBToast.error($scope.t.Username_exist);
					}
					else
					{
						KBToast.error($scope.t.create_account_fail);
					}
				}
			);
		}
		else if($scope.state == 'login'){
			console.log('Start Login')

			var LoginProcess = function(){
				$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
				Account.login($scope.data.username,$scope.data.password,
					function(data, status, headers, config){
						//Success Callback
						$ionicLoading.hide();
						if(status == 200){
							console.log('Start Login Success');
							LoginSuccess();
						}
					},
					function(data, status, headers, config){
						//Fail Callback
						console.log('Start Login Fail');
						$ionicLoading.hide();
						KBToast.debug(status +' ' + data);
						KBToast.error($scope.t.login_fail);
					}
				);
			}
			console.log($scope.account)
			if($scope.account.IsGuestAccount === true){
				
				//Get Account exist paid report or not
				var bHasPaidReport = false;

				if($scope.account.profile === null || typeof $scope.account.profile === 'undefined'){
					bHasPaidReport = false
				}
				else{
					if($scope.account.profile.paid === true){
						bHasPaidReport = true
					}
					else{
						var personalReportList = Datastore.getPersonalReportList();
						for (i in personalReportList){
							if(personalReportList[i].paid === true){
								bHasPaidReport = true
								break;
							}
						}
					}
				}

				if(bHasPaidReport === true){
					showWarningDialog(
						function(){
							//Confirm to login
							LoginProcess();
						},
						function(){
							//cancel
							//router to sign up page
							$scope.data.username = "";
							$scope.data.password = "";
							$scope.state = 'signup';
						}
					)
				}
				else{
					LoginProcess();
				}
			}
			else{
				LoginProcess();
			}
		}
	}

	var Init = function(){
		console.log('AppCtrl Init');

		$scope.account.is_social_account = LocalStorage.getItem('is_social_account');

		if($scope.account.IsLoggedIn === true){
			$scope.getRaveYear();

			// if ($scope.account.social_account !== null) {
			// 	console.log('social_account :', $scope.account.social_account);
			// 	LocalStorage.setItem('is_social_account', true);
			// } else {
			// 	LocalStorage.setItem('is_social_account', false);
			// 	console.log('social_account :', $scope.account.social_account);
			// }			

			if ($scope.account.is_social_account) {
				Social.refreshToken(function(res){
					// $scope.getRequiredResources();
				}, function(error){
					var socialAccount = Social.getAccount();
					KBToast.error(socialAccount.provider + $scope.t.account_disconnect_fb);
					$scope.logout();
					return;
					//$scope.getRequiredResources();
				});
			} 

			if ($scope.account.bGetAboutData === false){
				AboutContentManager.getAboutContent($scope.ds.about,$scope.settings.lg,
					function(about){
						//Success
						$scope.account.bGetAboutData = true;
						$scope.ds.about = about;
					},
					function(about){
						//error
						$scope.ds.about = about;
					}
				);
			}

			if ($scope.account.bGetSectionData === false){
				SectionContentManager.getSectionContent($scope.ds.section,$scope.settings.lg,
					function(section){
						//Success
						$scope.account.bGetSectionData = true;
						$scope.ds.section = section;
					},
					function(section){
						//error
						$scope.ds.section = section;
					}
				);
			}

			if($scope.account.bGetProfileData === false){
				//$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});
				GetProfileData(
					function(){
						//Get Profile Success
						if($scope.account.profile.is_staff){
							console.log('get profile data success, is_staff:', $scope.account.profile.is_staff);
							getDictionaryData();
						}

						GetPersonalChartData(
							function(){
								//Get Presonal Chart Success
								$ionicLoading.hide();								
								Redirect();
							},
							function(){
								//Get Presonal Chart Fail
								$ionicLoading.hide();
								ShowRetryDialog();
							 }
						);
					},
					function(){
						//Get Profile Fail
						$ionicLoading.hide();
						ShowRetryDialog();
				 	}
				);
			}
			else if($scope.account.bGetPersonalChartData === false){
				//$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});
				GetPersonalChartData(
					function(){
						//Get Presonal Chart Success
						$ionicLoading.hide();
						Redirect();
					},
					function(){
						//Get Presonal Chart Fail
						$ionicLoading.hide();
						ShowRetryDialog();
				 	}
				 );
			}
			else{
				Redirect();
			} 
		}
		else{
			// if($scope.account.IsGuestAccount === null){
				console.log('Register Guest Account');

				$scope.account.IsProfileChartGenerated	= false;
				LocalStorage.setItem('IsProfileChartGenerated',false)
				LocalStorage.setItem('is_social_account', false)

				//$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});
				Account.registerAsGuest(
					function(){
						//Success
						console.log('Register Guest Account Success');
						$scope.account.IsGuestAccount = true;
						$scope.account.IsLoggedIn = true;
						LocalStorage.setItem('IsGuestAccount',true)
						GetProfileData(
							function(){
								//Get Profile Success
								GetPersonalChartData(
									function(){
										//Get Presonal Chart Success
										$ionicLoading.hide();
									},
								function(){
									//Get Presonal Chart Fail
									$ionicLoading.hide();
									ShowRetryDialog();
									}
								);
							},
							function(){
								//Get Profile Fail
								$ionicLoading.hide();
								ShowRetryDialog();
						 	}
						);
					},
					function(){
						//Fail
						$ionicLoading.hide();
						console.log('Register Guest Account Fail');
						//KBToast.error('Fail to register account');
						ShowRetryDialog();
					}
				);//end of registerAsGuest

				//Go to Create Page without wait server response
				$ionicHistory.nextViewOptions({
					historyRoot : true,
				});
				$state.go('app.firstcreate');

			// }//end of IsGuestAccount === null
			// else{
			// 	$ionicLoading.hide();
			// 	console.log('Wait for user login/sign up');
			// 	$state.go('app.login');
			// }
		}
	}

	//------------------------------
	// General Functions
	//------------------------------

	$scope.openExternalLink = function(website){
		window.open(website, '_system');
		return false;
	}	

	/*$scope.getProductName = function(){
		if(!$scope.device.bIsNative){
			return;
		}

		if($scope.device.platform === 'ios'){
			return "com.newageideas.tier7.personalreport";
		} else if($scope.device.platform === 'android'){
			return "com.newageideas.hd.personalreport";
		}
	}*/

	//------------------------------
	// Event
	//------------------------------
	ionic.Platform.ready(function() {

		$scope.device = {
			bIsNative: false,
			platform:'',
		}

		if (window.cordova){
			$scope.device.bIsNative = true;
		}

		// if($scope.device.bIsNative){
		// 	cordova.plugins.Keyboard.disableScroll(true);
		// 	cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
		// 	console.log('cordova keyboard ready');
		// }

		// window.addEventListener('native.keyboardshow', function(){
  //   		document.body.classList.add('bg-transparent');
  // 		});

		// window.addEventListener('native.keyboardhide', keyboardHideHandler);

		// function keyboardHideHandler(e){
		// 	$('input').blur();
		// 	$('textarea').blur();
		// }

		//Get Device
		$scope.device.platform = ionic.Platform.platform().toLowerCase();

		console.log($scope.device);
	})

	$scope.$on('$ionicView.beforeEnter', function (ev) {
		if(ev.targetScope !== $scope)
        	return;

		// console.log('AppCtrl current state', $state.current.name.split(".").join("/"));
		console.log('AppCtrl beforeEnter, current state:',$state.current.name, $scope.account.bAppCtrlReInit)
		if (window.ga && $state.current.url !== "/loading") {
			window.ga.trackView("/" + $state.current.name.split(".").join("/"));
			// console.log('AppCtrl current state', "/" + $state.current.name.split(".").join("/"));
		}

		if($scope.account.bAppCtrlReInit === true){
			//Login from side menu
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			Init();
			console.log('run here');
			if (LocalStorage.getItem('IsGuestAccount') == true) {
				console.log('its a guest account');
			}
		}

		// $ionicHistory.clearHistory();
		// $ionicHistory.clearCache();
	});// end of $ionicView.beforeEnter

	$scope.$watch('settings.lg', function(newVal, oldVal){
		console.log('settings.lg',newVal);
		//Get Translation Files
		Translation.get({code:newVal},function(data){
			$scope.t = data;
			$scope.resourceState.language = 'ready';
			console.log("Load Translation file complete")
		});
		
	});

	$scope.$watch('resourceState.location', function(newVal, oldVal){
		console.log('resourceState.location: ',newVal)
		if(newVal !== oldVal){
			if(newVal == 'startToLoad'){
				console.log("Load Resource start")
				$timeout(function(){
					Location_v2.query(function(data){
						console.log("Load Location file complete")
						$scope.resourceState.location = 'ready'
						$scope.locations = data;
					});
				},1000);

				$timeout(function() {
					TimeOffset.query(function(data){
						console.log("Load UTC file complete")
						$scope.utcoffsets = data;
					});
				}, 1000);
			}
			else if(newVal == 'ready'){
				Init();
			}
		}
	});

	//------------------------------
	// Valuable Define
	//------------------------------
	//Read Data from LocalStorage
	$scope.account = {
		IsGuestAccount: LocalStorage.getItem('IsGuestAccount'),
		IsLoggedIn: Account.isLoggedIn(),
		IsProfileChartGenerated: LocalStorage.getItem('IsProfileChartGenerated'),
		is_social_account: LocalStorage.getItem('is_social_account'),
		social_account: LocalStorage.getObject('social_account'),
		birth: null,
		bGetPersonalChartData: false,
		bPesonalChartExist:false,
		bGetProfileData: false,
		bGetAboutData: false,
		bGetSectionData: false,
		bAppCtrlReInit: false,
		profile: LocalStorage.getObject('profile'),
	};

	$scope.resourceState = {
		location: null,
		language: null,
	}

	$scope.settings = {}


	$scope.debug = g_debug;
	$scope.personalchart = {};
	$scope.curtransitchart = {};
	$scope.relationshipchart = {};
	$scope.personalReportList = []
	$scope.status = {};
	$scope.status.payment = false;
	$scope.status.paymentId = null;
	$scope.status.paymentCountDown = 5;
	$scope.counter = null;

	//Data Storage, Used in 1.1.0
	$scope.ds = {};
	$scope.ds.centerTypeList = [];
	$scope.ds.typeTypeList = [];
	$scope.ds.gateTypeList = [];
	$scope.ds.authorityTypeList = [];
	$scope.ds.profileTypeList = [];
	$scope.ds.channelTypeList = [];

	//Get Settings
	$scope.settings = LocalStorage.getObject('settings');

	// if (!$scope.settings.theme_code) {
	// 	$scope.settings.theme_code = 2;
	// 	LocalStorage.setObject('settings',$scope.settings);
	// }

	if($scope.settings === null){

		$scope.settings = {}
		//Detect OS Language
		sys_lg = ionic.Platform.navigator.language.toLowerCase();

		//KBToast.debug(sys_lg);
		if(sys_lg == 'zh-tw' || sys_lg == 'zh-hk'){
			$scope.settings.lg = 'zh-tw'
		}
		else if(sys_lg == 'zh-cn'){
			$scope.settings.lg = 'zh-cn'
		}
		else{
			$scope.settings.lg = 'en'
		}

		$scope.settings.report_default_lg = $scope.settings.lg;
		$scope.settings.show_birth = true;
		$scope.settings.bUseListView = false;
		// $scope.settings.theme_code = 2;

		LocalStorage.setObject('settings',$scope.settings);
	}

	//Version Patch
	var v1_1_0_patch = LocalStorage.getItem('v1_1_0_patch')

	if(v1_1_0_patch === false || v1_1_0_patch === null || typeof v1_1_0_patch == 'undefined'){
		console.log("1.1.0 patch data start")

		if( $scope.account.IsProfileChartGenerated === true){
			//1. Clear Profile data from Local Storage
			LocalStorage.removeObject('profile');

			//2. Clear Personal Chart data from Local Storage
			LocalStorage.removeObject('personalChart');

			LocalStorage.setItem('v1_1_0_patch',true)
			console.log("1.1.0 patch data end")

			//3. Add List Mode Config
			$scope.settings.bUseListView = false;
			LocalStorage.setObject('settings',$scope.settings);
		}
	}
	
})


.controller('LoadingCtrl', function($scope,$state,$ionicHistory,TimeOffset){

	$scope.$on('$ionicView.enter', function () {
		console.log('LoadingCtrl enter');
		if($scope.resourceState.location === null){
			$scope.resourceState.location = 'startToLoad';
		}

		$ionicHistory.clearHistory();
		$ionicHistory.clearCache();
	});
})

.controller('LoginCtrl', function($scope,$state,LocalStorage){
	$scope.Reset = function(){
		LocalStorage.clearUp();
	}
})

//====================================
// Payment Controller
//====================================
.controller('PaymentCtrl', function($scope,$ionicHistory,KBStore,PaymentService) {

	$scope.paymentData = PaymentService.getData();

	console.log($scope.paymentData);

	//1. Get available payment service
	$scope.paymentServices = KBStore.getAvailableServices();

	$scope.checkoutItem = function (service) {
		KBStore.checkoutItem(service,$scope.paymentData.item.id,$scope.success,$scope.fail);
	};

	$scope.success = function(){
		console.log('payment success');
		if($scope.paymentData.success != null){
			$scope.paymentData.success();
		}
		$ionicHistory.goBack();
	};

	$scope.fail = function(){
		console.log('payment fail');
		if($scope.paymentData.fail != null){
			$scope.paymentData.fail();
		}
	};
})
