angular.module('starter.controllers')

//====================================
// Register Controller
//====================================
.controller('PersonalChartEditCtrl', function($scope,
										$state,
										$filter,
										$ionicLoading,
										$ionicHistory,
										LocalStorage,
										Airstation,
										Datastore,
										Account,
										ReportManager,
										Utility,
										KBToast){

	var getReportContent = function(lg_code){

		console.log('getReportContent',$scope.ds.personalreport)
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		if($scope.ds.personalreport.IsUser === false){
			ReportManager.getPersonalChartReport($scope.ds.personalreport.data,lg_code,
				function(report){
					$ionicLoading.hide();
					//success
					$scope.ds.personalreport.data = report
					$scope.content.t = $scope.ds.personalreport.data.content[lg_code]
					$scope.refresh = false;
				},
				function(){
					//fail
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
					$scope.refresh = false;
				}
			);
		}
		else{
			ReportManager.getProfileChartReport($scope.account.profile,lg_code,
				function(report){
					//success
					$ionicLoading.hide();
					$scope.ds.personalreport.data = report
					$scope.content.t = $scope.ds.personalreport.data.content[lg_code];
					$scope.refresh = false;
				},
				function(){
					//fail
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
					$scope.refresh = false;
				}
			);
		}     
	}

	//-------------------------
	// initial chart 
	//------------------------	
	$scope.$on("$ionicView.beforeEnter", function(event, data){
	   // handle event
	   console.log("State Params: ", data.stateParams);

	   //Update current profile data to model
	   console.log("ready edit info");

	   //input Data
	   $scope.editData = {}
	   $scope.editData.state = {
	   	timezoneSelected : true,
	   	locationSelected :true,
	   }

	   //declare content
	   $scope.content = {};
	   $scope.content.lg = $scope.settings.report_default_lg;

	   console.log('personalreport', $scope.ds.personalreport);

	   if($scope.ds.personalreport.IsUser === false){
	   	window.ga.trackView('/app/personlchart/edit');
	   	$scope.editData.name = $scope.ds.personalreport.data.name;
	   	$scope.editData.gender = $scope.ds.personalreport.data.gender;
	   	$scope.editData.birth = $scope.ds.personalreport.data.birth;
	   	$scope.editData.country = $scope.ds.personalreport.data.country;
	   	$scope.editData.city = $scope.ds.personalreport.data.city;
	   	$scope.editData.cty_code = $scope.ds.personalreport.data.cty_code;
	   	$scope.editData.paid = $scope.ds.personalreport.data.paid;
	   }
	   else{
	   	window.ga.trackView('/app/account/edit');
	   	$scope.editData.name = $scope.account.profile.real_name;
	   	$scope.editData.gender = $scope.account.profile.gender;
	   	$scope.editData.birth = $scope.account.profile.birth;
	   	$scope.editData.country = $scope.account.profile.country;
	   	$scope.editData.city = $scope.account.profile.city;
	   	$scope.editData.cty_code = $scope.account.profile.cty_code;
	   	$scope.editData.paid = $scope.account.profile.paid;
	   }

	   console.log('editChartModal, editData:', $scope.editData);


	   $scope.editData.state = {
	   	locationSelected: true,
	   };

	   var loc = _.findWhere( $scope.locations,{
	   	name: $scope.editData.city,
	   	cc: $scope.editData.cty_code,
	   })
	   //console.log(loc)

	   $scope.editData.birth.location = angular.copy(loc);

	   try{
	   	$scope.editData.birth.city = $filter('capitalize')($scope.editData.birth.location.name);
	   }
	   catch (e){
	   	console.log(e);
	   }

	   $scope.editData.birth.date = new Date(moment($scope.editData.birth.dt).format('MM/DD/YYYY '));
	   $scope.editData.birth.time = new Date(moment($scope.editData.birth.dt).format('MM/DD/YYYY HH:mm'));
	   $scope.editData.birth.max = new Date()
	   $scope.editData.birth.min = new Date('1900-01-01')



	   //Check Edit Modal is inited
	   // if($scope.EditChartModel !== null && typeof $scope.EditChartModel != 'undefined'){
	   // 	$scope.EditChartModel.show();
	   // }
	   // else
	   // {
	   // 	$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});
	   // 	$ionicModal.fromTemplateUrl('templates/app-personalchart-edit.html', {
	   // 	scope: $scope
	   // 	}).then(function(modal) {
	   // 		$ionicLoading.hide();
	   // 		$scope.EditChartModel = modal;
	   // 		$scope.EditChartModel.show();
	   // 	});
	   // }

	});

	$scope.OnUpdateChartData = function(){
		console.log("OnUpdateChartData");
		console.log($scope.editData);

		$scope.showError = true;

		if (typeof $scope.editData.birth.date === "undefined"){
			KBToast.error($scope.t.msg_fill_valid_info);
		return;
		}

		if ($scope.editData.birth.date < $scope.editData.birth.min){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if($scope.editData.birth.date > $scope.editData.birth.max && !$scope.account.profile.is_staff){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if(typeof $scope.editData.name === "undefined" || typeof $scope.editData.birth.city === "undefined" || $scope.editData.birth.location === null){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		//Get Bithday Time
		var date_str = moment($scope.editData.birth.date).format('YYYY-MM-DD');
		var time_str = moment($scope.editData.birth.time).format('HH:mm');

		var time = date_str+' '+time_str;
		var new_birth_ts = moment.tz(time, $scope.editData.birth.location.tz).format('YYYY-MM-DD HH:mmZ');
		var new_birth_local_ts = moment.tz(time, $scope.editData.birth.location.tz).format();

		var formdata = {
			city: $scope.editData.birth.location.name.toLowerCase(),
			country: $scope.editData.birth.location.cty,
			cty_code: $scope.editData.birth.location.cc,
			timezone: $scope.editData.birth.location.tz,
			birth_ts: new_birth_ts,
			birth_local_ts: new_birth_local_ts,
			gender: $scope.editData.gender,
		};

		if($scope.ds.personalreport.IsUser === false){
			formdata.id = $scope.ds.personalreport.data.id
			formdata.name = $scope.editData.name
		}
		else{
			formdata.id = $scope.account.profile.id
			formdata.real_name = $scope.editData.name
		}

		$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});
		if($scope.ds.personalreport.IsUser === false){
			Airstation.put(
				{
					app:'hdapp',
					resource:'personalchart',
					id:$scope.ds.personalreport.data.id,
				},
				formdata,
				function(rpn_data){

					$ionicLoading.hide();

					Utility.AdjustBirthByLocation(rpn_data);

					$scope.ds.personalreport.data = rpn_data

					//2. Clear Report Content
					$scope.ds.personalreport.data.content = {};
					Datastore.updatePersonalReport($scope.ds.personalreport.data)

					//3. reload report data
					getReportContent($scope.content.lg);
					
					$ionicHistory.goBack();

					window.ga.trackView('/app/personlchart/edit/success');
					
				},function(error){
					//2.1 Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_update_personalchart_fail);
					window.ga.trackView('/app/personlchart/edit/fail');
				}
			);
		}
		else{

			Account.updateProfile(formdata,
				function(data, status, headers, config){
					//Success Callback
					$ionicLoading.hide();

					if(status == 200){

						$scope.account.profile = data;
						Utility.AdjustBirthByLocation($scope.account.profile);

						if($scope.account.profile.chart_img_url != ""){
							LocalStorage.setItem('IsProfileChartGenerated',true);
							$scope.account.IsProfileChartGenerated = true;
						}

						LocalStorage.setObject('profile',$scope.account.profile);

						//3. reload report data
						$scope.ds.personalreport.data.content = {};
						getReportContent($scope.content.lg);

						$ionicHistory.goBack();

						window.ga.trackView('/app/account/edit/success');

					}
				},
				function(data, status, headers, config){
					//Fail Callback
					$ionicLoading.hide();
					KBToast.debug(status + ' ' +data);
					KBToast.error($scope.t.update_profile_fail);
					window.ga.trackView('/app/account/edit/fail');
				}
			);//end of updateProfile
		}

		console.log(formdata)
	}
});

