angular.module('starter.controllers')

//------------------------------------
// Personal Chart Report Controller v2
//------------------------------------
.controller('PersonalChartReportCtrl_v2', function($scope,$state,$stateParams,
																$ionicLoading,
																$filter,
																$ionicHistory,
																$ionicModal,
																$ionicPopup,
																Account,
																Datastore,
																LocalStorage,
																Airstation,
																ReportManager,
																KBStore,
																KBToast,
																PaymentService,
																Utility,
																AboutContentManager,
																SectionContentManager) {
	
	//------------------------------------
	// function
	//------------------------------------
	var chunk = function(arr, size) {
		var newArr = [];
		for (var i=0; i<arr.length; i+=size) {
			newArr.push(arr.slice(i, i+size));
		}
		return newArr;
	}

	var getAboutContent = function(lg_code){
		AboutContentManager.getAboutContent($scope.ds.about,lg_code,
			function(about){
				$scope.ds.about = about;
				//Success
				$scope.abouts = $scope.ds.about[$scope.content.lg]
			},
			function(about){
				//Fail
				$scope.abouts = $scope.ds.about[$scope.content.lg]
			}
		);
	}

	var getSectionContent = function(lg_code){
		SectionContentManager.getSectionContent($scope.ds.section,lg_code,
			function(section){
				$scope.ds.section = section;
				//Success
				$scope.sections = $scope.ds.section[$scope.content.lg]
			},
			function(section){
				//Fail
				$scope.sections = $scope.ds.section[$scope.content.lg]
			}
		);
	}

	var getReportContent = function(lg_code){

		console.log('getReportContent',$scope.ds.personalreport)
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		if($scope.ds.personalreport.IsUser === false){
			ReportManager.getPersonalChartReport($scope.ds.personalreport.data,lg_code,
				function(report){
					$ionicLoading.hide();
					//success
					$scope.ds.personalreport.data = report
					$scope.content.t = $scope.ds.personalreport.data.content[lg_code]
					$scope.refresh = false;

					console.log($scope.content.t.center_reports);

					$scope.content.t.gate_reports = _.sortBy($scope.content.t.gate_reports, 'number');
					$scope.center_reports_list = chunk($scope.content.t.center_reports, 3);
					$scope.channel_reports_list = chunk($scope.content.t.channel_reports, 3);
					$scope.gate_reports_list = chunk($scope.content.t.gate_reports, 3);		

					console.log($scope.center_reports_list);
				},
				function(){
					//fail
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
					$scope.refresh = false;
				}
			);
		}
		else{
			ReportManager.getProfileChartReport($scope.account.profile,lg_code,
				function(report){
					//success
					$ionicLoading.hide();
					$scope.ds.personalreport.data = report
					$scope.content.t = $scope.ds.personalreport.data.content[lg_code];
					$scope.refresh = false;

					$scope.content.t.gate_reports = _.sortBy($scope.content.t.gate_reports, 'number');
					$scope.center_reports_list = chunk($scope.content.t.center_reports, 3);
					$scope.channel_reports_list = chunk($scope.content.t.channel_reports, 3);
					$scope.gate_reports_list = chunk($scope.content.t.gate_reports, 3);		
				},
				function(){
					//fail
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
					$scope.refresh = false;
				}
			);
		}     
	}

	$scope.OnChangeLanguage = function(lang_code){
		var language = null;
		$scope.state.showLanguageBar = false;
		console.log('OnChangeLanguage',lang_code);

		if (window.ga) {
			window.ga.trackView('/app/personlchart/report/' + lang_code);
		}

		$scope.content.lg = lang_code;
		$scope.settings.report_default_lg = lang_code;

		LocalStorage.setObject('settings',$scope.settings);


		$scope.ds.title = $scope.heading[lang_code];
		if(lang_code in $scope.ds.personalreport.data.content){
			console.log('report '+lang_code+ ' exist');
			$scope.content.t = $scope.ds.personalreport.data.content[lang_code];

			console.log($scope.content.t.center_reports);

			$scope.content.t.gate_reports = _.sortBy($scope.content.t.gate_reports, 'number');
			$scope.center_reports_list = chunk($scope.content.t.center_reports, 3);
			$scope.channel_reports_list = chunk($scope.content.t.channel_reports, 3);
			$scope.gate_reports_list = chunk($scope.content.t.gate_reports, 3);		

			console.log($scope.center_reports_list);
		}
		else{
			getReportContent(lang_code);
		}

		if(lang_code in $scope.ds.about){
			$scope.abouts = $scope.ds.about[lang_code];
		}
		else{
			getAboutContent($scope.content.lg);
		}

		if(lang_code in $scope.ds.section){
			$scope.sections = $scope.ds.section[lang_code];
		}
		else{
			getSectionContent($scope.content.lg);
		}

	}

	$scope.GetAuthorityImage = function(id){
		//console.log('GetAuthorityImage')
		return ReportManager.getAuthorityImage(id,$scope.ds.personalreport.data.gender)
	}

	$scope.GetCenterImage = function(id,IsDefined){
		//console.log('GetCenterImage')
		return ReportManager.getCenterImage(id,$scope.ds.personalreport.data.gender,IsDefined)
	}

	$scope.GetGateImage = function(gate){
		//console.log('GetGateImage')
		return ReportManager.getGateImage(gate,$scope.ds.personalreport.data.gender)
	}

	$scope.GetChannelImage = function(id){
		//console.log('GetChannelImage')
		return ReportManager.getChannelImage(id,$scope.ds.personalreport.data.gender)
	}

	$scope.GetTypeImage = function(id){
		//console.log('GetTypeImage')
		return ReportManager.getTypeImage(id,$scope.ds.personalreport.data.gender)
	}

	$scope.GetLanguageTitle = function(code){

		var lg = _.findWhere($scope.content.available_lg,{code:code});

		if (typeof lg !== "undefined" && lg !== null){
			return lg.title;
		}
		else{
			return "";
		}

	}

	$scope.GetCenterDescription = function(){
		var about = _.findWhere($scope.abouts,{name:'about_center'});
		//console.log(about)

		if (typeof about !== "undefined" && about !== null){
			return about.content;
		}
		else{
			return "";
		}
	}

	$scope.GetSectionDescription = function(name){
		var desc = _.findWhere($scope.sections,{name:name});

		if (typeof desc !== "undefined" && desc !== null){
			return desc.free;
		}
		else{
			return "";
		}
	}

	// ------------------------------------
	// Report More modal function
	// ------------------------------------
	$ionicModal.fromTemplateUrl('templates/modal/modal-report-more.html', {
		scope: $scope,
		animation: 'slide-in-up'
	}).then(function(modal) {
		$scope.modal = modal;
	})

	$scope.openModal = function() {
		$scope.modal.show();
	}

	$scope.closeModal = function() {
		$scope.modal.hide();
	}

	$scope.$on('$destroy', function() {
		$scope.modal.remove();
	})

	$scope.goState = function(state) {
		$scope.closeModal();
		$state.go(state);
	}

	$scope.goCurtransit = function() {
		if ($scope.ds.personalreport.IsUser === false) {
			$state.go('app.curtransitchart', {profile_id: $scope.ds.personalreport.data.id});
		} else {
			$state.go('app.curtransitchart', {profile_id: $scope.account.profile.id});
		}
	}

	//fe
	
	//-------------------------------
	// Report Panel On Select
	//-------------------------------
	$scope.OnSelectType = function(){
		$scope.ds.type_report = $scope.content.t.type_report;
		$scope.ds.type_report.gender = $scope.ds.personalreport.data.gender
		$scope.ds.type_report.desc = $scope.GetSectionDescription('type_desc')
		$state.go('app.personalchart.report_v2.type');
	}

	$scope.OnSelectProfile = function(){
		$scope.ds.profile_report = $scope.content.t.profile_report;
		$scope.ds.profile_report.desc = $scope.GetSectionDescription('profile_desc')
		$state.go('app.personalchart.report_v2.profile');
	}

	$scope.OnSelectAuthority = function(){
		$scope.ds.authority_report = $scope.content.t.authority_report;
		$scope.ds.authority_report.gender = $scope.ds.personalreport.data.gender
		$scope.ds.authority_report.desc = $scope.GetSectionDescription('authority_desc')
		$state.go('app.personalchart.report_v2.authority');
	}

	$scope.OnSelectCenter = function(item){
		if($scope.ds.personalreport.data.paid === false){
			$scope.OpenPaymentModal('center');
		}
		else{
			$scope.ds.center_reports = {};
			$scope.ds.center_reports.data = $scope.content.t.center_reports;
			$scope.ds.center_reports.displayIndex = _.findIndex($scope.content.t.center_reports, item);
			$scope.ds.center_reports.gender = $scope.ds.personalreport.data.gender

			//$scope.ds.center_report.img_link = $scope.GetCenterImage($scope.ds.center_report.id,$scope.ds.center_report.IsDefine)
			//console.log('Center Report Content: ', $scope.ds.center_report)
			$state.go('app.personalchart.report_v2.center');
		}
	}

	$scope.OnSelectGate = function(item){
		if($scope.ds.personalreport.data.paid === false){
			$scope.OpenPaymentModal('gate');
		}
		else{
			$scope.ds.gate_reports = {};
			$scope.ds.gate_reports.data = $scope.content.t.gate_reports;
			$scope.ds.gate_reports.displayIndex = _.findIndex($scope.content.t.gate_reports, item);
			$scope.ds.gate_reports.gender = $scope.ds.personalreport.data.gender
			$state.go('app.personalchart.report_v2.gate');
		}
	}

	$scope.OnSelectChannel = function(item){
	
		if($scope.ds.personalreport.data.paid === false){
			$scope.OpenPaymentModal('channel');
		}
		else{
			$scope.ds.channel_reports = {};
			$scope.ds.channel_reports.data = $scope.content.t.channel_reports;
			$scope.ds.channel_reports.displayIndex = _.findIndex($scope.content.t.channel_reports, item);
			$scope.ds.channel_reports.gender = $scope.ds.personalreport.data.gender

			$state.go('app.personalchart.report_v2.channel');
		}
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.leave', function () {
		//Remove Chart enlargement #746 
		//$scope.imgModal.hide();
	});

	$scope.$watch('refresh', function(newVal, oldVal){
		if(newVal !== oldVal && newVal === false){
			$scope.$broadcast('scroll.refreshComplete');
		}
	});

	$scope.$on('$ionicView.beforeEnter', function() {
		console.log('Personal report v2 Before Enter, current state: ',$state.current.name);
		if ($scope.status.payment === true) {
			$scope.OpenPaymentModal('read_more');
			$scope.checkoutItem($scope.status.paymentId);
			$scope.status.payment = false;
			$scope.status.paymentId = null;
		}
	});

	$scope.$on('$ionicView.afterEnter', function () {
		console.log('afterEnter')
		if (window.ga) {
			window.ga.trackView('/app/personlchart/report/' + $scope.content.lg);
		}
		$ionicLoading.hide();
		$scope.state.showDetail = true;
	});

	$scope.$on('$ionicView.loaded', function () {
		console.log('PersonalChartReportCtrl_v2 loaded')
		console.log('perosnalreport data',$scope.ds.personalreport);

		$scope.content.lg = $scope.settings.report_default_lg;
		$scope.content.t = $scope.ds.personalreport.data.content[$scope.content.lg];
		$scope.ds.title = $scope.heading[$scope.content.lg]

		//AutoSave
		if($scope.ds.personalreport.IsAutoSave === true && $scope.ds.personalreport.IsUser === false){
			Datastore.addPersonalReport($scope.ds.personalreport.data);
			$scope.ds.personalreport.IsAutoSave = false
		}

		$scope.socialshare.data = {
			title:'Human Design Chart',
			img_url: api_domain + $scope.ds.personalreport.data.chart_img_url,
		};

		getAboutContent($scope.content.lg);
		getSectionContent($scope.content.lg);

		$scope.content.t.gate_reports = _.sortBy($scope.content.t.gate_reports, 'number');
		$scope.center_reports_list = chunk($scope.content.t.center_reports, 3);
		$scope.channel_reports_list = chunk($scope.content.t.channel_reports, 3);
		$scope.gate_reports_list = chunk($scope.content.t.gate_reports, 3);
	});


	//------------------------------------
	// Variable Define
	//------------------------------------
	console.log('PersonalChartReportCtrl_v2');
	//console.log('Start Param',$stateParams);

	$scope.heading = {}
	$scope.heading['en'] = {
		personal_chart_report_name : "Name",
		personal_chart_report_type : "Type",
		personal_chart_report_authority : "Authority",
		personal_chart_report_profile : "Profile",
		personal_chart_report_type_report : "Type",
		personal_chart_report_authority_report : "Authority",
		personal_chart_report_profile_report : "Profile",
		personal_chart_report_center_report : "Center",
		personal_chart_report_channel_report : "Channel",
		personal_chart_report_gate_report : "Gate",
		text_defined : "Defined",
		text_undefined : "Undefined",
	}

	$scope.heading['zh-tw'] = {
		personal_chart_report_tite : "報告",
		personal_chart_report_name : "名字 ",
		personal_chart_report_type : "類型 ",
		personal_chart_report_authority : "內在權威 ",
		personal_chart_report_profile : "輪廓 ",
		personal_chart_report_type_report : "類型",
		personal_chart_report_authority_report : "內在權威",
		personal_chart_report_profile_report : "輪廓",
		personal_chart_report_center_report : "能量中心",
		personal_chart_report_channel_report : "通道",
		personal_chart_report_gate_report : "閘門",
		text_defined : "有色",
		text_undefined : "無色",
	}

	$scope.heading['zh-cn'] = {
		personal_chart_report_tite : "报告",
		personal_chart_report_name : "名字 ",
		personal_chart_report_type : "类型 ",
		personal_chart_report_authority : "內在权威 ",
		personal_chart_report_profile : "轮廓 ",
		personal_chart_report_type_report : "类型",
		personal_chart_report_authority_report : "內在权威",
		personal_chart_report_profile_report : "轮廓",
		personal_chart_report_center_report : "能量中心",
		personal_chart_report_channel_report : "通道",
		personal_chart_report_gate_report : "闸门",
		text_defined : "有色",
		text_undefined : "无色",
	}

	$scope.refresh = false;

	$scope.content = {};
	$scope.content.available_lg = {}
	$scope.content.available_lg = g_report_available_lg

	$scope.api_domain = api_domain
	$scope.socialshare = Datastore.getSocialShare();

	$scope.map = Datastore.getGoogleMapSetting();

	$scope.showError = false;
	$scope.showDateInvalid = false;

	$scope.state = {}
	$scope.state.showLanguageBar = false;
	$scope.state.showDetail = false;


	//-------------------------
	// DateTime Picker
	//-------------------------
	$scope.OpenNativeDatePicker = function(){
		if($scope.editData.paid && !$scope.account.profile.is_staff){
			return;
		}

		var options = {
			date: new Date(moment($scope.editData.birth.date).format('MM/DD/YYYY')),
			mode: 'date',
			minDate: new Date(moment($scope.editData.birth.min).format('MM/DD/YYYY')),
			maxDate: new Date(moment($scope.editData.birth.max).format('MM/DD/YYYY')),
		};

		
		datePicker.show(options, function(datetime){
			//alert("date result " + datetime); 
			if (datetime !== null && typeof datetime != 'undefined') {

				//valid
				newDateTime = moment(datetime);
				minDateTime = moment($scope.editData.birth.min);
				maxDateTime = moment($scope.editData.birth.max);

				if(newDateTime <= maxDateTime && newDateTime >= minDateTime){
					$scope.showDateInvalid = false;
				}
				else if(newDateTime > maxDateTime && !$scope.account.profile.is_staff){
					$scope.showDateInvalid = true;
					//alert("Invalid Date " + datetime); 
				} else {
					$scope.showDateInvalid = false;
				}

				$scope.editData.birth.date = new Date(moment(datetime).format('MM/DD/YYYY'));

				$scope.$apply();
			}
		});

	}

	$scope.OpenNativeTimePicker = function(){
		if($scope.editData.paid && !$scope.account.profile.is_staff){
			return;
		}

		var options = {
			date: new Date(moment($scope.editData.birth.time).format('MM/DD/YYYY HH:mm')),
			mode: 'time',
		};

		
		datePicker.show(options, function(datetime){
			//alert("date result " + datetime);  
			if (datetime !== null && typeof datetime != 'undefined') {
				$scope.editData.birth.time = new Date(moment(datetime).format('MM/DD/YYYY HH:mm'));
				$scope.$apply();
			}
		});

	}


	//-------------------------
	// edit Chart Model
	//------------------------	
	$scope.OpenEditChartModel = function(){

		//Update current profile data to model
		console.log("OpenEditChartModel");

		//input Data
		$scope.editData = {}
		$scope.editData.state = {
			timezoneSelected : true,
			locationSelected :true,
		}

		console.log('personalreport', $scope.ds.personalreport);

		if($scope.ds.personalreport.IsUser === false){
			if (window.ga) {
				window.ga.trackView('/app/personlchart/edit');
			}
			$scope.editData.name = $scope.ds.personalreport.data.name;
			$scope.editData.gender = $scope.ds.personalreport.data.gender;
			$scope.editData.birth = $scope.ds.personalreport.data.birth;
			$scope.editData.country = $scope.ds.personalreport.data.country;
			$scope.editData.city = $scope.ds.personalreport.data.city;
			$scope.editData.cty_code = $scope.ds.personalreport.data.cty_code;
			$scope.editData.paid = $scope.ds.personalreport.data.paid;
		}
		else{
			if (window.ga) {
				window.ga.trackView('/app/account/edit');
			}
			$scope.editData.name = $scope.account.profile.real_name;
			$scope.editData.gender = $scope.account.profile.gender;
			$scope.editData.birth = $scope.account.profile.birth;
			$scope.editData.country = $scope.account.profile.country;
			$scope.editData.city = $scope.account.profile.city;
			$scope.editData.cty_code = $scope.account.profile.cty_code;
			$scope.editData.paid = $scope.account.profile.paid;
		}

		console.log('editChartModal, editData:', $scope.editData);


		$scope.editData.state = {
			locationSelected: true,
		};

		var loc = _.findWhere( $scope.locations,{
			name: $scope.editData.city,
			cc: $scope.editData.cty_code,
		})
		//console.log(loc)

		$scope.editData.birth.location = angular.copy(loc);

		try{
			$scope.editData.birth.city = $filter('capitalize')($scope.editData.birth.location.name);
		}
		catch (e){
			console.log(e);
		}

		$scope.editData.birth.date = new Date(moment($scope.editData.birth.dt).format('MM/DD/YYYY '));
		$scope.editData.birth.time = new Date(moment($scope.editData.birth.dt).format('MM/DD/YYYY HH:mm'));
		$scope.editData.birth.max = new Date()
		$scope.editData.birth.min = new Date('1900-01-01')



		//Check Edit Modal is inited
		if($scope.EditChartModel !== null && typeof $scope.EditChartModel != 'undefined'){
			$scope.EditChartModel.show();
		}
		else
		{
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			$ionicModal.fromTemplateUrl('templates/app-personalchart-edit.html', {
			scope: $scope
			}).then(function(modal) {
				$ionicLoading.hide();
				$scope.EditChartModel = modal;
				$scope.EditChartModel.show();
			});
		}

	};

	$scope.CloseEditChartModel = function() {
		$scope.EditChartModel.hide();
	};

	$scope.toggleGender = function(newVal) {
		if ($scope.editData.gender !== newVal) {
			$scope.editData.gender = newVal;
		}
	}

	$scope.OnUpdateChartData = function(){
		console.log("OnUpdateChartData");
		console.log($scope.editData);

		$scope.showError = true;

		if (typeof $scope.editData.birth.date === "undefined"){
			KBToast.error($scope.t.msg_fill_valid_info);
		return;
		}

		if ($scope.editData.birth.date < $scope.editData.birth.min){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if($scope.editData.birth.date > $scope.editData.birth.max && !$scope.account.profile.is_staff){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if(typeof $scope.editData.name === "undefined" || $scope.editData.name === ""){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		if ($scope.editData.birth.location === null && $scope.editData.birth.offset === null) {
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		//Get Bithday Time
		var date_str = moment($scope.editData.birth.date).format('YYYY-MM-DD');
		var time_str = moment($scope.editData.birth.time).format('HH:mm');

		var time = date_str+' '+time_str;

		var new_birth_ts;
		var new_birth_local_ts;
		var new_birth_name;
		var new_birth_cty;
		var new_birth_cc;
		var new_birth_tz;

		if ($scope.editData.birth.location !== null) {
			new_birth_ts = moment.tz(time, $scope.editData.birth.location.tz).format('YYYY-MM-DD HH:mmZ');
			new_birth_local_ts = moment.tz(time, $scope.editData.birth.location.tz).format();
			new_birth_name = $scope.editData.birth.location.name.toLowerCase();
			new_birth_cty =  $scope.editData.birth.location.cty;
			new_birth_cc = $scope.editData.birth.location.cc;
			new_birth_tz = $scope.editData.birth.location.tz;
		}  
		else if ($scope.editData.birth.offset !== null) {
			time = date_str + 'T' + time_str + $scope.editData.birth.offset;
			new_birth_ts = moment(time).utcOffset($scope.editData.birth.offset).format('YYYY-MM-DD HH:mmZ');
			new_birth_local_ts = moment(time).utcOffset($scope.editData.birth.offset).format();
			new_birth_name = "";
			new_birth_cty =  "";
			new_birth_cc = "";
			new_birth_tz = "null";
		}
		
		var formdata = {
			city: new_birth_name,
			country: new_birth_name,
			cty_code: new_birth_cc,
			timezone: new_birth_tz,
			birth_ts: new_birth_ts,
			birth_local_ts: new_birth_local_ts,
			gender: $scope.editData.gender
		};

		if($scope.ds.personalreport.IsUser === false){
			formdata.id = $scope.ds.personalreport.data.id
			formdata.name = $scope.editData.name
		}
		else{
			formdata.id = $scope.account.profile.id
			formdata.real_name = $scope.editData.name
		}

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		if($scope.ds.personalreport.IsUser === false){
			Airstation.put(
				{
					app:'hdapp',
					resource:'personalchart',
					id:$scope.ds.personalreport.data.id,
				},
				formdata,
				function(rpn_data){

					$ionicLoading.hide();

					Utility.AdjustBirthByLocation(rpn_data);

					$scope.ds.personalreport.data = rpn_data

					//2. Clear Report Content
					$scope.ds.personalreport.data.content = {};
					Datastore.updatePersonalReport($scope.ds.personalreport.data)

					//3. reload report data
					getReportContent($scope.content.lg);

					$scope.EditChartModel.hide();
					if (window.ga) {
						window.ga.trackView('/app/personlchart/edit/success');
					}
					
				},function(error){
					//2.1 Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_update_personalchart_fail);
					if (window.ga) {
						window.ga.trackView('/app/personlchart/edit/fail');
					}
				}
			);
		}
		else{

			Account.updateProfile(formdata,
				function(data, status, headers, config){
					//Success Callback
					$ionicLoading.hide();

					if(status == 200){

						$scope.account.profile = data;
						Utility.AdjustBirthByLocation($scope.account.profile);

						if($scope.account.profile.chart_img_url != ""){
							LocalStorage.setItem('IsProfileChartGenerated',true);
							$scope.account.IsProfileChartGenerated = true;
						}

						LocalStorage.setObject('profile',$scope.account.profile);

						//3. reload report data
						$scope.ds.personalreport.data.content = {};
						getReportContent($scope.content.lg);

						$scope.EditChartModel.hide();

						if (window.ga) {
							window.ga.trackView('/app/account/edit/success');
						}
					}
				},
				function(data, status, headers, config){
					//Fail Callback
					$ionicLoading.hide();
					KBToast.debug(status + ' ' +data);
					KBToast.error($scope.t.update_profile_fail);
					if (window.ga) {
						window.ga.trackView('/app/account/edit/fail');
					}
				}
			);//end of updateProfile
		}

		console.log(formdata)
	}

	//------------------------------------
	// Payment
	//------------------------------------
	$scope.payment = {};

	//Chcek Item is valid
	//for android
	//$scope.payment.product = KBStore.getProduct("com.newageideas.hd.personalreport");	
	//for ios
	//$scope.payment.product = KBStore.getProduct("com.newageideas.tier7.personalreport");
	$scope.payment.product = KBStore.getProduct(g_product_name);

	if($scope.payment.product != null){
		$scope.payment.available = true;
	}
	else{
		$scope.payment.available = false;
	}

	$scope.payment.paymentServices = KBStore.getAvailableServices();
	//console.log($scope.payment);

	$scope.OpenPaymentModal = function(src) {
		if (window.ga) {
			window.ga.trackView('/app/payment');
			window.ga.trackEvent('Personal', 'click $', src);
		}
		//$scope.CheckoutSuccess('paypal',{id:1111})
		if($scope.paymentModal !== null && typeof $scope.paymentModal != 'undefined'){
			$scope.paymentModal.show()
		}
		else{
			$ionicModal.fromTemplateUrl('templates/app-payment.html', {
				scope: $scope,
				animation: 'slide-in-up'
				}).then(function(modal){
					$scope.paymentModal = modal
					$scope.paymentModal.show()
				}
			);
		}

	};

	$scope.ClosePaymentModal = function() {

		//console.log($state.current);
		$scope.status.payment = false;
		$scope.paymentModal.hide()
	};

	$scope.checkoutItem = function (service_id) {
		if (!$scope.account.IsGuestAccount) {
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			service = $scope.payment.paymentServices[service_id]
			//console.log(service)
			if (window.ga) {
				window.ga.trackView('/app/payment/begin');
				if(service.name == 'iap'){
					window.ga.trackEvent('Personal', 'checkout begin', service.iap_name);
				}
				else{
					window.ga.trackEvent('Personal', 'checkout begin', service.name);
				}	
			}
			KBStore.checkoutItem(service_id,'Personal',$scope.payment.product.id,$scope.CheckoutSuccess,$scope.CheckoutFail,$scope.CheckoutCancel);
		} 
		else {
			$scope.ClosePaymentModal();
			$scope.status.payment = true;
			$scope.status.paymentId = service_id;
			$state.go('app.register');
			KBToast.error($scope.t.login_about);
		}
	};

	$scope.CheckoutFail = function(servicename){
		$ionicLoading.hide();
		if (window.ga) {
			window.ga.trackView('/app/payment/fail');
			window.ga.trackEvent('Personal', 'checkout fail', servicename);
		}
		console.log('payment fail');
		KBToast.error('Fail to purchase item');
	};

	$scope.CheckoutCancel = function(servicename){
		$ionicLoading.hide();
		if (window.ga) {
			window.ga.trackView('/app/payment/cancel');
			window.ga.trackEvent('Personal', 'checkout cancel', servicename);
		}
		console.log('payment cancel');
	};


	$scope.CheckoutSuccess = function(servicename,payment){
		//console.log('payment success:',servicename,payment);
		if (window.ga) {
			window.ga.trackView('/app/payment/success');
			window.ga.trackEvent('Personal', 'checkout payment success', servicename);
		}
		$scope.paymentModal.hide()
		//Perpare Request data
		var rqt_data = {}

		if(servicename == 'paypal'){
			console.log('paypal')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else if (servicename == 'appstore'){
			console.log('appstore')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else if (servicename == 'googleplay'){
			console.log('googleplay')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else{
			console.log('Invalid service name')
		}

		//1. Update payment record to server
		console.log(rqt_data)
		//$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});

		var retryTime = 0;
		if($scope.ds.personalreport.IsUser === false){
			var pendingUpdateReportList = LocalStorage.getObject('pending_update_report_list_' + $scope.account.profile.id);
			var buyReport = function(){
				Airstation.put(
					{
						app:'hdapp',
						resource:'personalchart',
						id:$scope.ds.personalreport.data.id,
						sub_resource:'payment',
					},
					rqt_data,
					function(rpn_data){
						console.log('checkout success');
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout success', servicename);
						}
						$ionicLoading.hide();
						$scope.ds.personalreport.data.paid = true;

						//2. Clear Report Content
						$scope.ds.personalreport.data.content = {};
						Datastore.updatePersonalReport($scope.ds.personalreport.data);

						//3. reload report data
						getReportContent($scope.content.lg);

						var object = _.findWhere(pendingUpdateReportList, {id: $scope.ds.personalreport.data.id});

						if(object){
							pendingUpdateReportList = _.without(pendingUpdateReportList, object);
							if(pendingUpdateReportList.length > 0){
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
							} else {
								LocalStorage.removeObject('pending_update_report_list_' + $scope.account.profile.id);
							}
						}
					},function(error){
						//2.1 Fail Handle
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', servicename);
						}
						retryTime++;

						if(retryTime < 10){
							buyReport();
						} else {
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_update_personalchart_fail);

							if(!pendingUpdateReportList){
								pendingUpdateReportList = [];
							}

							var object = _.findWhere(pendingUpdateReportList, {id: $scope.ds.personalreport.data.id});
							if(!object){
								pendingUpdateReportList.push({id: $scope.ds.personalreport.data.id, data: rqt_data});
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);								
							}							
						}
					}
				);
			}

			buyReport();
		} else {
			var pendingUpdatePersonalReportList = LocalStorage.getObject('pending_update_personal_report_list');
			var buyPersonalReport = function(){
				Account.buyPersonalReport(
					rqt_data,
					function(data, status, headers, config){

						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server success', servicename);
						}
						//Success
						$ionicLoading.hide();
						$scope.account.profile.paid = true;
						$scope.ds.personalreport.data.paid = true;

						//2. Clear Report Content
						$scope.ds.personalreport.data.content = {};
						$scope.account.profile.hdreport.content = {};
						LocalStorage.setObject('profile',$scope.account.profile);
						
						getReportContent($scope.content.lg);

						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(object){
							pendingUpdatePersonalReportList = _.without(pendingUpdatePersonalReportList, object);
							if(pendingUpdatePersonalReportList.length > 0){
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							} else {
								LocalStorage.removeObject('pending_update_personal_report_list');
							}
						}
					},
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', servicename);
						}	
						retryTime++;

						//fail
						if(retryTime < 10){
							buyPersonalReport();
						} else {
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_update_personalchart_fail);

							if(!pendingUpdatePersonalReportList){
								pendingUpdatePersonalReportList = [];
							}

							var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
							if(!object){
								pendingUpdatePersonalReportList.push({id: $scope.account.profile.id, data: rqt_data});
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							}
						}
					}
				);
			}

			buyPersonalReport();
		}
	};

	//------------------------------------
	// Social Share
	//------------------------------------


	$scope.shareViaFacebook =function(){
		console.log("shareViaFacebook");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint($scope.socialshare.data.title,
			null /* img */,
			$scope.socialshare.data.img_url,
			function(){
				console.log('share ok')
			},
			function(errormsg){
				//alert(errormsg)
			}
		); 
	};

	$scope.shareViaWhatsapp =function(){
		console.log("shareViaWhatsapp");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaWhatsApp($scope.socialshare.data.title,
			$scope.socialshare.data.img_url,
			null,
			function(){
				console.log('share ok')
			},
			function(errormsg){
				//alert(errormsg)
			}
		); 
	};

	$scope.shareVia = function(){
		console.log("shareVia");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.share($scope.socialshare.data.title,
			null,
			$scope.socialshare.data.img_url,
			null,
			function(){
				console.log('share ok')
			},
			function(errormsg){
				//alert(errormsg)
			}
		); 
	};
	
	//------------------------------------
	// UI Function
	//------------------------------------
	$scope.doRefresh = function(){
		console.log('Do doRefresh')
		$scope.refresh = true;
		//$scope.ds.personalreport.data.content = {};

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		if($scope.ds.personalreport.IsUser === false){
			Airstation.get(
				{
					app:'hdapp',
					resource:'personalchart',
					id:$scope.ds.personalreport.data.id,
				},
				function(rpn_data){
					//$ionicLoading.hide();
					console.log('Refresh Personal Chart',rpn_data)
					Utility.AdjustBirthByLocation(rpn_data);
					
					$scope.ds.personalreport.data = rpn_data;
					Datastore.updatePersonalReport($scope.ds.personalreport.data)

					getReportContent($scope.content.lg);
				},
				function(error) {
					//2.1 Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
				}
			);
		}
		else{
			Airstation.get(
				{
					app:'profile',
					id:$scope.account.profile.id,
				},
				function(rpn_data){
					//$ionicLoading.hide();
					console.log('Refresh Profile Chart',rpn_data)
					Utility.AdjustBirthByLocation(rpn_data);

					$scope.account.profile = rpn_data
					LocalStorage.setObject('profile',$scope.account.profile);

					$scope.ds.personalreport.data = {};
					getReportContent($scope.content.lg);
				},
				function(error) {
					//2.1 Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
				}
			);
		}
	}

	// $scope.showAlert = function() {
	// 	$scope.closeModal();
	// 	alertPopup = $ionicPopup.show({
	// 		scope: $scope,
	// 		templateUrl: 'templates/modal/delete-popup.html'
	// 	});
	// };

 //     $scope.sendOrder = function() {
 //      alertPopup.close();
 //    };

 // ------------------------------------
	// Delete pop up modal function
	// ------------------------------------
	$ionicModal.fromTemplateUrl('templates/modal/delete-popup.html', {
		scope: $scope,
		animation: 'scale-in'
	}).then(function(modal) {
		$scope.deleteModal = modal;
	})

	$scope.openDeleteModal = function() {
		$scope.closeModal();
		$scope.deleteModal.show();
	}

	$scope.closeDeleteModal = function() {
		$scope.deleteModal.hide();
	}

	$scope.$on('$destroy', function() {
		$scope.deleteModal.remove();
	})

	$scope.deleteProfile = function() {
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		Airstation.delete({app:'hdapp',resource:'personalchart',id:$scope.ds.personalreport.data.id},
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.closeDeleteModal();
				Datastore.delPersonalReport($scope.ds.personalreport.data.id);
				$ionicHistory.nextViewOptions({
					historyRoot : true,
				});
				$state.go('app.personalchart');

			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_del_personalchart_fail);
			}
		);
	}

	$scope.showDelConfirmDialog = function() {
		var confirmPopup = $ionicPopup.confirm({
			title: $scope.t.dialog_del_personal_chart_title,
			template: $scope.t.dialog_del_personal_chart_content,
			cancelText: $scope.t.cancel_button,
			okText: $scope.t.delete_button,
			okType: 'button-assertive',
			cancelType: 'button-balanced',
			cssClass: 'confirm-dialog',
		});

		confirmPopup.then(function(res) {
			if(res) {
				$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
				Airstation.delete({app:'hdapp',resource:'personalchart',id:$scope.ds.personalreport.data.id},
					function(rpn_data){
						//2.1 Success Handle
						$ionicLoading.hide();
						$scope.closeModal();
						Datastore.delPersonalReport($scope.ds.personalreport.data.id);
						$ionicHistory.nextViewOptions({
							historyRoot : true,
						});
						$state.go('app.personalchart');

					},
					function(error) {
						//2.1 Fail Handle
						$ionicLoading.hide();
						KBToast.error($scope.t.msg_error_del_personalchart_fail);
					}
				);
			}
			else{
			console.log('Del cancel');
			}
		});
	};

})