angular.module('starter.controllers')

.controller('CurTransitChartCtrl', function($scope,$state,$ionicLoading,
														$ionicHistory,
														$stateParams,
														Datastore,
														Account,
														Airstation,
														KBToast,
														Utility) {

	//--------------------------------
	// Function
	//--------------------------------
	var GetCurTransitChart = function(){
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		var rqt_data = {}

		
		Airstation.post({app:'hdapp',resource:'curtranitchart'},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.report = rpn_data
				$scope.report.cur_ts_str = moment(rpn_data.cur_ts).format('YYYY-MM-DD HH:mm')
				$scope.ready = true;
				$scope.refresh = false;
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_get_curtransitchart_fail);
				$scope.ready = false;
				$scope.refresh = false;
		})
    }

    var GetTransitChart = function(chart_obj){
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		console.log(chart_obj)

		var rqt_data = {
			//reportid: chart_obj.id,
			//profileid: $scope.account.profile.id,
			name: chart_obj.name,
			gender: chart_obj.gender,
			birth_ts: chart_obj.birth_ts,
		}

		if(chart_obj.id){
			rqt_data.reportid = chart_obj.id;
			rqt_data.profileid = null;
		} else {
			rqt_data.reportid = null;
			rqt_data.profileid = $scope.account.profile.id;
		}

		Airstation.post({app:'hdapp',resource:'curtranitchart', lg: $scope.settings.lg},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.curtransitchart.report = rpn_data;

				$scope.curtransitchart.report.cur_ts_str = moment(rpn_data.cur_ts).format('YYYY / MM / DD HH:mm');
				

				//Fix Invalid Birth Date
				//$scope.curtransitchart.report.birth_str = moment(rpn_data.birth_ts).format('YYYY-MM-DD HH:mm a')
				$scope.curtransitchart.report.p = chart_obj;

				console.log($scope.curtransitchart);
				$state.go('app.curtransitchart.report');
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_get_curtransitchart_fail);
		});
    }

    //--------------------------------
	// UI function
	//--------------------------------
	$scope.createChart = function(){
		if ($scope.ds.personalreport.IsUser) {
			var userPersonalReport = angular.copy($scope.account.profile);
			userPersonalReport.name = userPersonalReport.real_name + ' (You)';
			userPersonalReport.id = null;
			GetTransitChart(userPersonalReport);
		} else {
			GetTransitChart($scope.ds.personalreport.data);
		}	
	}

	$scope.doRefresh = function(){
		console.log('Do doRefresh')
		$scope.refresh = true;
		GetCurTransitChart();
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('CurTransitChartCtrl beforeEnter',$ionicHistory.forwardView());

		if($ionicHistory.forwardView() === null){
			GetCurTransitChart();
		}
		else{
			if($ionicHistory.forwardView().stateId != 'app.curtransitchart.create'){
				GetCurTransitChart();
			}
		}

		if ($ionicHistory.backView() !== null) {
			$scope.hasBackView = true;
		}

	});// end of $ionicView.beforeEnter

	$scope.$watch('refresh', function(newVal, oldVal){
		if(newVal !== oldVal && newVal === false){
			$scope.$broadcast('scroll.refreshComplete');
		}
	});


	//--------------------------------
	// Valuable Define 
	//--------------------------------
	$scope.api_domain = api_domain
	$scope.report = {}
	$scope.ready = false;
	$scope.refresh = false;
	$scope.hasBackView = false;
})

//====================================
// Currnet Transit Chart Controller
//====================================
.controller('CurTransitChartCreateCtrl', function($scope,$state,$ionicLoading,
														  $ionicSlideBoxDelegate,
														  $ionicHistory,
														  Datastore,
														  Airstation,
														  Account,
														  KBToast,
														  LocalStorage,
														  Utility) {
	
	//init data
	$scope.api_domain = api_domain
	$scope.filter_options = [
								{ title: 'Name', id: 'name' },
								{ title: 'City', id: 'city' },
							];

	//--------------------------------
	// Function
	//--------------------------------
	var updateServerPurchasedReport = function(successCallback, failCallback){
		if(!$scope.account.profile.id){
			return;
		}

		var pendingUpdateReportList = LocalStorage.getObject('pending_update_report_list_' + $scope.account.profile.id);		
		var pendingUpdatePersonalReportList = LocalStorage.getObject('pending_update_personal_report_list');

		if(!pendingUpdateReportList && !pendingUpdatePersonalReportList){
			RefreshDisplayList();
			return;
		}

		if(pendingUpdateReportList){		

			var buyReport = function(reportid, data){				
				Airstation.put(
					{
						app:'hdapp',
						resource:'personalchart',
						id: reportid,
						sub_resource:'payment',
					},
					data,
					function(rpn_data){
						console.log('checkout success');
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout success', data.gateway);
						}	
						//$ionicLoading.hide();
						
						//update local data, set paid to true
						var report = _.findWhere($scope.selectList, {id: reportid});
						if(report){
							report.paid = true;
						}
						Datastore.updatePersonalReport(report);

						var object = _.findWhere(pendingUpdateReportList, {id: reportid});
						if(object){
							pendingUpdateReportList = _.without(pendingUpdateReportList, object);							
							if(pendingUpdateReportList.length > 0){
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
							} else {
								LocalStorage.removeObject('pending_update_report_list_' + $scope.account.profile.id);
							}
						}

						RefreshDisplayList();
					},function(error){
						//2.1 Fail Handle
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', data.gateway);
						}

						//$ionicLoading.hide();
						//KBToast.error($scope.t.msg_error_update_personalchart_fail);

						if(!pendingUpdateReportList){
							pendingUpdateReportList = [];
						}

						var object = _.findWhere(pendingUpdateReportList, {id: reportid});
						if(object){
							pendingPurchaseList.push({id: reportid, data: data});
							LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
						}
					}
				);
			}

			for(var i=0; i<pendingUpdateReportList.length; i++){				
				var object = pendingUpdateReportList[i];
				buyReport(object.id, object.data);
			}
		}
		
		if(pendingUpdatePersonalReportList){
			var buyPersonalReport = function(data){				
				Account.buyPersonalReport(
					data,
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server success', data.gateway);
						}
						//Success
						$ionicLoading.hide();
						$scope.account.profile.paid = true;
						/*if($scope.displayList){
							var personalReport = $scope.displayList[0];
							if(personalReport.id === $scope.account.profile.id){
								personalReport.paid = true;
							}
						}*/

						//2. Clear Report Content
						//$scope.ds.personalreport.data.content = {};
						//$scope.account.profile.hdreport.content = {};
						LocalStorage.setObject('profile',$scope.account.profile);
						
						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(object){
							pendingUpdatePersonalReportList = _.without(pendingUpdatePersonalReportList, object);
							if(pendingUpdatePersonalReportList.length > 0){
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							} else {
								LocalStorage.removeObject('pending_update_personal_report_list');
							}
						} 

						RefreshDisplayList();
					},
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', data.gateway);
						}
						//fail
						
						//$ionicLoading.hide();
						//KBToast.error($scope.t.msg_error_update_personalchart_fail);

						if(!pendingUpdatePersonalReportList){
							pendingUpdatePersonalReportList = [];
						}

						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(!object){
							pendingUpdatePersonalReportList.push({id: $scope.account.profile.id, data: data});
							LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
						}						
					}
				);
			}

			var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
			if(object){
				buyPersonalReport(object.data);
			}
		}
	}

	var RefreshDisplayList = function(){

		//clear up
		$scope.selectList = [];

		//get personal chart list
		$scope.selectList  = angular.copy($scope.personalReportList);

		//$scope.selectList = $scope.selectList.sort(function(a,b){return b.id - a.id});

		//add profile personal chart
		if($scope.account.profile != null){
			var userPersonalReport = angular.copy($scope.account.profile);
			userPersonalReport.name = userPersonalReport.real_name + ' (You)';
			userPersonalReport.id = null;
			$scope.selectList.unshift(userPersonalReport);
		}
	}

	$scope.refreshPersonalChartList = function(){
		console.log("Refresh Personal Chart List From Server");
		Airstation.list({app:'hdapp',resource:'personalchart'},
			function(rpn_data){
				//2.1 Success Handle
				console.log("GetPersonalChartData Success", rpn_data);

				//2.2 Adjust Birth Datetime
				for (index in rpn_data){
					var chart_data = rpn_data[index];
					Utility.AdjustBirthByLocation(chart_data);
				}

				$scope.personalReportList = rpn_data;
				Datastore.setPersonalReportList($scope.personalReportList);

				Account.getProfile(
					function(data, status, headers, config){
						//Success Callback
						if(status == 200){
							$scope.account.profile = data[0];

							console.log("GetProfileData Success, data:", data);
							//console.log($scope.account.profile);

							//Get time zone from location
							Utility.AdjustBirthByLocation($scope.account.profile);

							//RefreshDisplayList();
							updateServerPurchasedReport();

						}//end of status 200
						else{
							KBToast.error('Fail to get profile data');
							KBToast.debug(status +' ' + data);
						}		 

						$scope.refresh = false;
						$scope.$broadcast('scroll.refreshComplete');
					},//end of get profile success
					function(data, status, headers, config){
						//Fail Callback
						KBToast.error('Fail to get profile data');
						KBToast.debug(status +' ' + data);

						$scope.refresh = false;
						$scope.$broadcast('scroll.refreshComplete');

						if(status == 401){
							console.log('Get profile Unauthorized');
							Logout();
						}
					}
				);

				//$scope.refresh = false;
			},
			function(error) {
				//2.1 Fail Handle
				KBToast.error('failed to get personal chart list');
				$scope.refresh = false;
				$scope.$broadcast('scroll.refreshComplete');
			}
		);
	}

	var GetTransitChart = function(chart_obj){
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

		console.log(chart_obj)

		var rqt_data = {
			//reportid: chart_obj.id,
			//profileid: $scope.account.profile.id,
			name: chart_obj.name,
			gender: chart_obj.gender,
			birth_ts: chart_obj.birth_ts,
		}

		if(chart_obj.id){
			rqt_data.reportid = chart_obj.id;
			rqt_data.profileid = null;
		} else {
			rqt_data.reportid = null;
			rqt_data.profileid = $scope.account.profile.id;
		}

		Airstation.post({app:'hdapp',resource:'curtranitchart', lg: $scope.settings.lg},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.curtransitchart.report = rpn_data;

				$scope.curtransitchart.report.cur_ts_str = moment(rpn_data.cur_ts).format('YYYY / MM / DD HH:mm');
				

				//Fix Invalid Birth Date
				//$scope.curtransitchart.report.birth_str = moment(rpn_data.birth_ts).format('YYYY-MM-DD HH:mm a')
				$scope.curtransitchart.report.p = chart_obj;

				console.log($scope.curtransitchart);
				$state.go('app.curtransitchart.report');
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_get_curtransitchart_fail);
		});
    }

	//--------------------------------
	// UI function
	//--------------------------------
	$scope.onClickChart = function(index){
		//1. Get Current Side Box Index
		console.log("Current Index: " + index);


		//1. Find personal chart obj
		var chart_obj = $scope.selectList[index];

		console.log("Gen Current Transit Chart of " + chart_obj.name);
		console.log("chart_obj");
		GetTransitChart(chart_obj);
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('CurTransitChartCreateCtrl beforeEnter');

		$scope.data = {
			showDelete: false,
			showSearch: false,
			slideIndex: 0 ,
			numViewableSlides: 0,
			filter_by: $scope.filter_options[0],
			filter_value: '',
		};

		// if ($scope.settings.bUseListView === true){
		// 	$scope.data.showSearch = true;
		// }
		$scope.data.showSearch = false;
		
		//RefreshDisplayList();
		$scope.refreshPersonalChartList();

	});// end of $ionicView.beforeEnter

	$scope.$watch('account.profile', function(newVal, oldVal){
		RefreshDisplayList();
	});

	$scope.$watch('personalReportList', function(newVal, oldVal){
		RefreshDisplayList();
	});

	$scope.$watch('selectList', function(newVal, oldVal){

		$scope.data.numViewableSlides = newVal.length;
		$scope.data.slideIndex = 0;

		$ionicSlideBoxDelegate.slide(0);
		$ionicSlideBoxDelegate.update();

	});

	$scope.next = function() {
		$ionicSlideBoxDelegate.next();
	};

	$scope.previous = function() {
		$ionicSlideBoxDelegate.previous();
	};
    // Called each time the slide changes
	$scope.OnSlideChanged = function(index) {
		$scope.data.slideIndex = index;
	};

	$scope.filterReport = function(item) {
		try{		

			var search_value = $scope.data.filter_value.toLowerCase();
			var name = item.name.toLowerCase();
			var city = item.city.toLowerCase();

			//console.log(item);

			if(name.indexOf(search_value) > -1){
				return true;
			}
			else if(city.indexOf(search_value) > -1){
				return true;
			}
			else{
				return false;
			}

		}
		catch(e){
			console.log(e)
			return true;
		}
	}

	$scope.OnChangeChartMode = function(){
		
		$scope.data.filter_value = '';
		$scope.settings.bUseListView = false;
		$scope.data.showSearch = false;
		
		$scope.data.slideIndex = 0;
		$ionicSlideBoxDelegate.slide(0);
		$ionicSlideBoxDelegate.update();

		LocalStorage.setObject('settings',$scope.settings);
	}

	$scope.OnChangeListMode = function(){
		$scope.settings.bUseListView = true;
		$scope.data.showSearch = true;
		LocalStorage.setObject('settings',$scope.settings);
	}

	//--------------------------------
	// Main
	//--------------------------------
	$scope.selectList = [];
})

//------------------------------------
// Current Transit Chart Report Controller
//------------------------------------
.controller('CurTransitChartReportCtrl', function($scope,$state,$ionicLoading,
																$ionicHistory,
																$ionicModal,
																$ionicPopup,
																Account,
																Datastore,
																LocalStorage,
																Airstation,
																KBStore,
																KBToast,
																ReportManager,
																PaymentService,
																Utility){

	//Testing Code
	/*
	var GetCurTransitChart = function(){s
		$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});

		var rqt_data = {
			name: 'text',
			gender: 'M',
			birth_ts: '2015-02-18T18:57:00Z',
		}


		Airstation.post({resource:'hdreport/curtranitchart'},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.report = rpn_data

				console.log($scope.report)
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_get_curtransitchart_fail);
		})
    }*/

    //------------------------------------
	// function
	//------------------------------------
	var chunk = function(arr, size) {
		var newArr = [];
		for (var i=0; i<arr.length; i+=size) {
			newArr.push(arr.slice(i, i+size));
		}
		return newArr;
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('CurTransitChartReportCtrl beforeEnter');
		//console.log($scope.curtransitchart);
		//$scope.report = $scope.curtransitchart;
		$scope.report.chart_data.new_gates = _.sortBy($scope.report.chart_data.new_gates, 'number');
		$scope.new_centers_list = chunk($scope.report.chart_data.new_centers, 3);
		$scope.new_channels_list = chunk($scope.report.chart_data.new_channels, 3);
		$scope.new_gates_list = chunk($scope.report.chart_data.new_gates, 3);

		if ($scope.status.payment === true) {
			$scope.OpenPaymentModal('read_more');
			$scope.checkoutItem($scope.status.paymentId);
			$scope.status.payment = false;
			$scope.status.paymentId = null;
		}
	});

	$scope.$on('$ionicView.leave', function () {
		
		//Remove Chart enlargement #746 
		//$scope.imgModal.hide();
	});


	//------------------------------------
	// Main
	//------------------------------------
	console.log('CurTransitChartReportCtrl');
	$scope.report = $scope.curtransitchart.report;	
	$scope.api_domain = api_domain;
	$scope.socialshare = Datastore.getSocialShare();

	$scope.GetAuthorityImage = function(id){
		//console.log('GetAuthorityImage')
		return ReportManager.getAuthorityImage(id,$scope.report.chart_data.gender)
	}

	$scope.GetCenterImage = function(id,IsDefined){
		//console.log('GetCenterImage')
		return ReportManager.getCenterImage(id,$scope.report.chart_data.gender, IsDefined)
	}

	$scope.GetGateImage = function(gate){
		//console.log('GetGateImage')
		return ReportManager.getGateImage(gate, $scope.report.chart_data.gender);
	}

	$scope.GetChannelImage = function(id){
		//console.log('GetChannelImage')
		return ReportManager.getChannelImage(id,$scope.report.chart_data.gener);
	}

	$scope.GetTypeImage = function(id){
		//console.log('GetTypeImage')
		return ReportManager.getTypeImage(id,$scope.report.chart_data.gender);
	}

	/*$scope.GetLanguageTitle = function(code){

		var lg = _.findWhere($scope.content.available_lg,{code:code});

		if (typeof lg !== "undefined" && lg !== null){
			return lg.title;
		}
		else{
			return "";
		}

	}*/

	$scope.GetCenterDescription = function(){
		var about = _.findWhere($scope.abouts,{name:'about_center'});
		//console.log(about)

		if (typeof about !== "undefined" && about !== null){
			return about.content;
		}
		else{
			return "";
		}
	}

	$scope.GetSectionDescription = function(name){
		var desc = _.findWhere($scope.sections,{name:name});

		if (typeof desc !== "undefined" && desc !== null){
			return desc.free;
		}
		else{
			return "";
		}
	}



	$scope.OnSelectCenter = function(item){
		console.log('OnSelectCenter');
		if(!$scope.report.chart_data.paid){
			//KBToast.error($scope.t.curtransit_chart_report_not_paid);
			$scope.data.showAdditionalMessage = true;
			$scope.OpenPaymentModal();
		} else{
			$scope.ds.center_reports = {};
			$scope.ds.center_reports.data = $scope.report.chart_data.new_centers;
			$scope.ds.center_reports.displayIndex = _.findIndex($scope.report.chart_data.new_centers, item);;
			$scope.ds.center_reports.gender = $scope.report.chart_data.gender;

			//$scope.ds.center_report.img_link = $scope.GetCenterImage($scope.ds.center_report.id,$scope.ds.center_report.IsDefine)
			//console.log('Center Report Content: ', $scope.ds.center_report)
			$state.go('app.personalchart.report_v2.center');
		}
	}

	$scope.OnSelectGate = function(item){
		console.log('OnSelectGate');
		if(!$scope.report.chart_data.paid){
			//KBToast.error($scope.t.curtransit_chart_report_not_paid);
			$scope.data.showAdditionalMessage = true;
			$scope.OpenPaymentModal();
		} else{
			$scope.ds.gate_reports = {};
			$scope.ds.gate_reports.data = $scope.report.chart_data.new_gates;
			$scope.ds.gate_reports.displayIndex = _.findIndex($scope.report.chart_data.new_gates, item);;
			$scope.ds.gate_reports.gender = $scope.report.chart_data.gender;
			$state.go('app.personalchart.report_v2.gate');
		}
	}

	$scope.OnSelectChannel = function(item){	
		console.log('OnSelectChannel');
		if(!$scope.report.chart_data.paid){
			//KBToast.error($scope.t.curtransit_chart_report_not_paid);
			$scope.data.showAdditionalMessage = true;
			$scope.OpenPaymentModal();
		} else {
			$scope.ds.channel_reports = {};
			$scope.ds.channel_reports.data = $scope.report.chart_data.new_channels;
			$scope.ds.channel_reports.displayIndex = _.findIndex($scope.report.chart_data.new_channels, item);;
			$scope.ds.channel_reports.gender = $scope.report.chart_data.gender;

			$state.go('app.personalchart.report_v2.channel');
		}
	}

	//------------------------------------
    // Payment
    //------------------------------------
	$scope.payment = {};

	//Chcek Item is valid
	//for android
	//$scope.payment.product = KBStore.getProduct("com.newageideas.hd.personalreport");	
	//for ios
	//$scope.payment.product = KBStore.getProduct("com.newageideas.tier7.personalreport");
	$scope.payment.product = KBStore.getProduct(g_product_name);

	if($scope.payment.product != null){
		$scope.payment.available = true;
	}
	else{
		$scope.payment.available = false;
	}

    $scope.payment.paymentServices = KBStore.getAvailableServices();
    //console.log($scope.payment);

	$scope.OpenPaymentModal = function(src) {
		if (window.ga) {
			window.ga.trackView('/app/payment');
			window.ga.trackEvent('Personal', 'click $', src);
		}
		//$scope.CheckoutSuccess('paypal',{id:1111})
		if($scope.paymentModal !== null && typeof $scope.paymentModal != 'undefined'){
			$scope.paymentModal.show()
		}
		else{
			$ionicModal.fromTemplateUrl('templates/app-payment.html', {
				scope: $scope,
				animation: 'slide-in-up'
				}).then(function(modal){
					$scope.paymentModal = modal
					$scope.paymentModal.show()
				}
			);
		}

	};

	$scope.ClosePaymentModal = function() {

		//console.log($state.current);
		$scope.status.payment = false;
		$scope.paymentModal.hide()
	};

	$scope.checkoutItem = function (service_id) {
		if (!$scope.account.IsGuestAccount) {
			$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
			service = $scope.payment.paymentServices[service_id]
			//console.log(service)
			if (window.ga) {
				window.ga.trackView('/app/payment/begin');
				if(service.name == 'iap'){
					window.ga.trackEvent('Personal', 'checkout begin', service.iap_name);
				}
				else{
					window.ga.trackEvent('Personal', 'checkout begin', service.name);
				}	
			}
			KBStore.checkoutItem(service_id,'Personal',$scope.payment.product.id,$scope.CheckoutSuccess,$scope.CheckoutFail,$scope.CheckoutCancel);
		}
		else {
			$scope.ClosePaymentModal();
			$scope.status.payment = true;
			$scope.status.paymentId = service_id;
			$state.go('app.register');
			KBToast.error($scope.t.login_about);
		}
	};

	$scope.CheckoutFail = function(servicename){
		$ionicLoading.hide();
		if (window.ga) {
			window.ga.trackView('/app/payment/fail');
			window.ga.trackEvent('Personal', 'checkout fail', servicename);
		}
		console.log('payment fail');
		KBToast.error('Fail to purchase item');
	};

	$scope.CheckoutCancel = function(servicename){
		$ionicLoading.hide();
		if (window.ga) {
			window.ga.trackView('/app/payment/cancel');
			window.ga.trackEvent('Personal', 'checkout cancel', servicename);
		}
		console.log('payment cancel');
	};


	$scope.CheckoutSuccess = function(servicename,payment){
		//console.log('payment success:',servicename,payment);
		if (window.ga) {
			window.ga.trackView('/app/payment/success');
			window.ga.trackEvent('Personal', 'checkout payment success', servicename);
		}
		$scope.paymentModal.hide()
		//Perpare Request data
		var rqt_data = {}

		if(servicename == 'paypal'){
			console.log('paypal')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else if (servicename == 'appstore'){
			console.log('appstore')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else if (servicename == 'googleplay'){
			console.log('googleplay')
			rqt_data.gateway = servicename;
			rqt_data.ref_no = payment.id;
			rqt_data.product_id = $scope.payment.product.id
			rqt_data.remark = JSON.stringify(payment);
		}
		else{
			console.log('Invalid service name')
		}

		//1. Update payment record to server
		console.log(rqt_data)
		//$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});

		var retryTime = 0;

		if($scope.report.p.id){			
			var pendingUpdateReportList = LocalStorage.getObject('pending_update_report_list_' + $scope.account.profile.id);
			var buyReport = function(){
				Airstation.put(
					{
						app:'hdapp',
						resource:'personalchart',
						id: $scope.report.p.id,
						sub_resource:'payment',
					},
					rqt_data,
					function(rpn_data){
						console.log('checkout success');
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout success', servicename);
						}
						$ionicLoading.hide();
						
						//update local data, set paid to true
						$scope.report.chart_data.paid = true;
						$scope.personalReportList = Datastore.getPersonalReportList();

						var report = _.findwhere($scope.personalReportList, {id: $scope.report.p.id});
						if(report){
							report.paid = true;
						}

						Datastore.updatePersonalReport(report);

						var object = _.findWhere(pendingUpdateReportList, {id: $scope.report.p.id});
						if(object){
							pendingUpdateReportList = _.without(pendingUpdateReportList, object);
							if(pendingUpdateReportList.length > 0){
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
							} else {
								LocalStorage.removeObject('pending_update_report_list_' + $scope.account.profile.id);
							}
						}

					},function(error){
						//2.1 Fail Handle
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', servicename);
						}
						retryTime++;
						if(retryTime < 10){
							buyReport();
						} else {
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_update_personalchart_fail);

							if(!pendingUpdateReportList){
								pendingUpdateReportList = [];
							}

							var object = _.findWhere(pendingUpdateReportList, {id: $scope.report.p.id});
							if(!object){
								pendingUpdateReportList.push({id: $scope.report.p.id, data: rqt_data});
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
							}
						}
					}
				);
			}

			buyReport();
		} else {
			var pendingUpdatePersonalReportList = LocalStorage.getObject('pending_update_personal_report_list');
			var buyPersonalReport = function(){
				Account.buyPersonalReport(
					rqt_data,
					function(data, status, headers, config){
						if(window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server success', servicename);
						}
						//Success
						$ionicLoading.hide();
						$scope.account.profile.paid = true;
						$scope.report.chart_data.paid = true;

						//2. Clear Report Content
						//$scope.ds.personalreport.data.content = {};
						//$scope.account.profile.hdreport.content = {};
						LocalStorage.setObject('profile',$scope.account.profile);
						
						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(object){
							pendingUpdatePersonalReportList = _.without(pendingUpdatePersonalReportList, object);
							if(pendingUpdatePersonalReportList.length > 0){
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							} else {
								LocalStorage.removeObject('pending_update_personal_report_list');
							}
						} 
					},
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', servicename);
						}
						//fail
						retryTime++;
						if(retryTime < 10){
							buyPersonalReport();
						} else {
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_update_personalchart_fail);

							if(!pendingUpdatePersonalReportList){
								pendingUpdatePersonalReportList = [];
							}

							var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
							if(!object){
								pendingUpdatePersonalReportList.push({id: $scope.account.profile.id, data: rqt_data});
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							}
						}
					}
				);
			}

			buyPersonalReport();
		}
	};

	//------------------------------------
	// Social Share
	//------------------------------------
	$scope.socialshare.data = { title:'Human Design Chart',
								img_url: api_domain + $scope.report.chart_img_url,

	};

	$scope.shareViaFacebook =function(){
		console.log("shareViaFacebook");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint($scope.socialshare.data.title,
			null /* img */,
			$scope.socialshare.data.img_url,
			function(){
			console.log('share ok')
			},
			function(errormsg){
			//alert(errormsg)
		}); 
	};

	$scope.shareViaWhatsapp =function(){
		console.log("shareViaWhatsapp");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaWhatsApp($scope.socialshare.data.title,
			$scope.socialshare.data.img_url,
			null,
			function(){
			  console.log('share ok')
			},
			function(errormsg){
			  //alert(errormsg)
		}); 
	};

	$scope.shareVia = function(){
		console.log("shareVia");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.share($scope.socialshare.data.title,
			null,
			$scope.socialshare.data.img_url,
			null,
			function(){
			console.log('share ok')
			},
			function(errormsg){
			//alert(errormsg)
		}); 
	};
    
	//------------------------------------
	// Chart Image Model
	//------------------------------------
	/* Remove Chart enlargement #746 
	$ionicModal.fromTemplateUrl('image-modal.html',{
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(modal){
			$scope.imgModal = modal;
		}
	);

	$scope.openModal = function() {
		console.log('Open Modal');
		$scope.imgModal.show();
	}

	$scope.closeModal = function () {
		console.log('Close Modal');
		$scope.imgModal.hide();
	}*/

	$('img.svg').each(function(){
			var $img = $(this);
			var imgID = $img.attr('id');
			var imgClass = $img.attr('class');
			var imgURL = $img.attr('src');

			$.get(imgURL, function(data) {
			// Get the SVG tag, ignore the rest
			var $svg = $(data).find('svg');

			// Add replaced image's ID to the new SVG
			if(typeof imgID !== 'undefined') {
				$svg = $svg.attr('id', imgID);
			}
			// Add replaced image's classes to the new SVG
			if(typeof imgClass !== 'undefined') {
				$svg = $svg.attr('class', imgClass+' replaced-svg');
			}

			// Remove any invalid XML tags as per http://validator.w3.org
			$svg = $svg.removeAttr('xmlns:a');

			// Replace image with new SVG
			$img.replaceWith($svg);

		}, 'xml');
	});


	//------------------------------------
	// Variables
	//------------------------------------
	$scope.heading = {}
	$scope.heading['en'] = {
		personal_chart_report_name : "Name",
		personal_chart_report_type : "Type",
		personal_chart_report_authority : "Authority",
		personal_chart_report_profile : "Profile",
		personal_chart_report_type_report : "Type",
		personal_chart_report_authority_report : "Authority",
		personal_chart_report_profile_report : "Profile",
		personal_chart_report_center_report : "Additional Center",
		personal_chart_report_channel_report : "Additional Channel",
		personal_chart_report_gate_report : "Additional Gate",
		text_defined : "Defined",
		text_undefined : "Undefined",
	}

	$scope.heading['zh-tw'] = {
		personal_chart_report_tite : "報告",
		personal_chart_report_name : "名字 ",
		personal_chart_report_type : "類型 ",
		personal_chart_report_authority : "內在權威 ",
		personal_chart_report_profile : "輪廓 ",
		personal_chart_report_type_report : "類型",
		personal_chart_report_authority_report : "內在權威",
		personal_chart_report_profile_report : "輪廓",
		personal_chart_report_center_report : "附加能量中心",
		personal_chart_report_channel_report : "附加通道",
		personal_chart_report_gate_report : "附加閘門",
		text_defined : "有色",
		text_undefined : "無色",
	}

	$scope.heading['zh-cn'] = {
		personal_chart_report_tite : "报告",
		personal_chart_report_name : "名字 ",
		personal_chart_report_type : "类型 ",
		personal_chart_report_authority : "內在权威 ",
		personal_chart_report_profile : "轮廓 ",
		personal_chart_report_type_report : "类型",
		personal_chart_report_authority_report : "內在权威",
		personal_chart_report_profile_report : "轮廓",
		personal_chart_report_center_report : "附加能量中心",
		personal_chart_report_channel_report : "附加通道",
		personal_chart_report_gate_report : "附加闸门",
		text_defined : "有色",
		text_undefined : "无色",
	}

	$scope.ds.title = $scope.heading[$scope.settings.lg];
	$scope.data = {};
})