angular.module('starter.controllers')

//====================================
// Account Controller
//====================================
.controller('DictionaryCategoryCtrl', function($scope, $state){

	//--------------------------------
	// Function
	//--------------------------------
	$scope.showDictionaryList = function(category){
		$state.go('app.dictionarylist', {category: category});
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.afterEnter', function(){
		$scope.data.reportCategoryList = [
			{
				type: "authority",
				name: $scope.t.personal_chart_report_authority
			},
			{
				type: "center",
				name: $scope.t.personal_chart_report_center_report
			},
			{
				type: "channel",
				name: $scope.t.personal_chart_report_channel_report
			},
			{
				type: "gate",
				name: $scope.t.personal_chart_report_gate_report
			},
			{
				type: "profile",
				name: $scope.t.personal_chart_report_profile
			},
			{
				type: "type",
				name: $scope.t.personal_chart_report_type
			}
		];
	});

	//--------------------------------
	// Valuable Define 
	//--------------------------------
	$scope.data = {};
	$scope.data.reportCategoryList = [];
})

.controller('DictionaryListCtrl', function($scope,$state,$stateParams,$ionicScrollDelegate,
																		Airstation,																		
																		KBToast){
	

	//--------------------------------
	// Function
	//--------------------------------
	$scope.doRefresh = function(){		
		var category = $scope.data.category;
		if(!category){
			$scope.$broadcast('scroll.refreshComplete');
			return;
		}

		var successCallback = function(data){
			$scope.data.reportList = data;
			$scope.$broadcast('scroll.refreshComplete');
		}

		var failCallback = function(data){
			KBToast.error($scope.t.msg_error_get_dictionary);
			$scope.$broadcast('scroll.refreshComplete');
		}

		if(category === 'center'){
			$scope.getCenterTypeList(successCallback, failCallback);			
		} else if(category === 'type'){
			$scope.getTypeTypeList(successCallback, failCallback);
		} else if(category === 'gate'){
			$scope.getGateTypeList(successCallback, failCallback);
		} else if(category === 'authority'){
			$scope.getAuthorityTypeList(successCallback, failCallback);
		} else if(category === 'profile'){
			$scope.getProfileTypeList(successCallback, failCallback);
		} else if(category === 'channel'){
			$scope.getChannelTypeList(successCallback, failCallback);
		}
	}

	$scope.filterByKeyword = function(report){
		if(!$scope.data.filter_value){
			return true;
		}

		var keyword = $scope.data.filter_value.toLowerCase();

		if($scope.data.category !== 'profile' && $scope.data.category !== 'gate'){
			return report.name.toLowerCase().indexOf(keyword) >= 0;
		} else if($scope.data.category === 'gate'){
			return (report.gate_dtl.number.toString().indexOf(keyword) >= 0)
				|| (report.name.toLowerCase().indexOf(keyword) >= 0);
		} else {
			var name = report.profile_dtl.line_1 + '/' + report.profile_dtl.line_2;
			return (name.indexOf(keyword) >= 0);
		}
	}

	$scope.showDictionDetail = function(id){
		$state.go('app.dictionarydetail', {id: id, category: $scope.data.category});
	}

	$scope.resizeList = function(){
		$ionicScrollDelegate.resize();
		if(!$scope.$$phase) {
			$scope.$apply();
		}
	}

	//--------------------------------
	// Event
	//--------------------------------

	$scope.$watch('data.filter_value', function(newValue, oldValue){
		$ionicScrollDelegate.resize();
		if(!$scope.$$phase) {
			$scope.$apply();
		}
	});

	$scope.$on('$ionicView.beforeEnter', function(){
		$scope.data.category = $stateParams.category;
		var category = $scope.data.category;

		if(category === 'center'){
			$scope.data.reportList = $scope.ds.centerTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		} else if(category === 'type'){
			$scope.data.reportList = $scope.ds.typeTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		} else if(category === 'gate'){
			$scope.data.reportList = $scope.ds.gateTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		} else if(category === 'authority'){
			$scope.data.reportList = $scope.ds.authorityTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		} else if(category === 'profile'){
			$scope.data.reportList = $scope.ds.profileTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		} else if(category === 'channel'){
			$scope.data.reportList = $scope.ds.channelTypeList[$scope.settings.lg];
			if(!$scope.data.reportList){
				$scope.doRefresh();
			}
		}
	});

	//--------------------------------
	// Valuable Define 
	//--------------------------------
	$scope.data = {};
	$scope.data.reportList = [];
})

.controller('DictionaryDetailCtrl', function($scope,$state,$stateParams){
	//--------------------------------
	// Function
	//--------------------------------


	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function(){		
		if($stateParams.id && $stateParams.category){
			$scope.data.category = $stateParams.category;
			
			var id = parseInt($stateParams.id);
			var category = $stateParams.category;

			if(category === 'center'){
				$scope.data.report = _.findWhere($scope.ds.centerTypeList[$scope.settings.lg], {id: id});
				console.log('data.report', $scope.data.report);
			} else if(category === 'type'){
				$scope.data.report = _.findWhere($scope.ds.typeTypeList[$scope.settings.lg], {id: id});			
			} else if(category === 'gate'){
				$scope.data.report = _.findWhere($scope.ds.gateTypeList[$scope.settings.lg], {id: id});
			} else if(category === 'authority'){
				$scope.data.report = _.findWhere($scope.ds.authorityTypeList[$scope.settings.lg], {id: id});
			} else if(category === 'profile'){
				$scope.data.report = _.findWhere($scope.ds.profileTypeList[$scope.settings.lg], {id: id});
			} else if(category === 'channel'){
				$scope.data.report = _.findWhere($scope.ds.channelTypeList[$scope.settings.lg], {id: id});
			}
		}
	});

	//--------------------------------
	// Valuable Define 
	//--------------------------------
	$scope.data = {};
	$scope.data.report = {};

});
