angular.module('starter.controllers')

//------------------------------------
// Personal Chart Menu Controller
//------------------------------------
.controller('PersonalChartListCtrl', function($scope,$state,$ionicLoading,
															$ionicHistory,
															$ionicSlideBoxDelegate,
															$timeout,
															$ionicModal,
															Account,
															LocalStorage,
															Datastore,
															Airstation,
															ReportManager,
															Utility,
															KBToast) {


	//------------------------------------
	// Function
	//-----------------------------------
	var updateServerPurchasedReport = function(successCallback, failCallback){
		if(!$scope.account.profile.id){
			return;
		}

		var pendingUpdateReportList = LocalStorage.getObject('pending_update_report_list_' + $scope.account.profile.id);		
		var pendingUpdatePersonalReportList = LocalStorage.getObject('pending_update_personal_report_list');

		if(!pendingUpdateReportList && !pendingUpdatePersonalReportList){
			RefreshDisplayList();
			return;
		}

		if(pendingUpdateReportList){		

			var buyReport = function(reportid, data){				
				Airstation.put(
					{
						app:'hdapp',
						resource:'personalchart',
						id: reportid,
						sub_resource:'payment',
					},
					data,
					function(rpn_data){
						console.log('checkout success');
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout success', data.gateway);	
						}
						//$ionicLoading.hide();
						
						//update local data, set paid to true
						var report = _.findWhere($scope.displayList, {id: reportid});
						if(report){
							report.paid = true;
						}
						Datastore.updatePersonalReport(report);

						var object = _.findWhere(pendingUpdateReportList, {id: reportid});
						if(object){
							pendingUpdateReportList = _.without(pendingUpdateReportList, object);							
							if(pendingUpdateReportList.length > 0){
								LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
							} else {
								LocalStorage.removeObject('pending_update_report_list_' + $scope.account.profile.id);
							}
						}

						RefreshDisplayList();
					},function(error){
						//2.1 Fail Handle
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', data.gateway);
						}

						//$ionicLoading.hide();
						//KBToast.error($scope.t.msg_error_update_personalchart_fail);

						if(!pendingUpdateReportList){
							pendingUpdateReportList = [];
						}

						var object = _.findWhere(pendingUpdateReportList, {id: reportid});
						if(object){
							pendingPurchaseList.push({id: reportid, data: data});
							LocalStorage.setObject('pending_update_report_list_' + $scope.account.profile.id, pendingUpdateReportList);
						}
					}
				);
			}

			for(var i=0; i<pendingUpdateReportList.length; i++){				
				var object = pendingUpdateReportList[i];
				buyReport(object.id, object.data);
			}
		}
		
		if(pendingUpdatePersonalReportList){
			var buyPersonalReport = function(data){				
				Account.buyPersonalReport(
					data,
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server success', data.gateway);
						}
						//Success
						$ionicLoading.hide();
						$scope.account.profile.paid = true;
						/*if($scope.displayList){
							var personalReport = $scope.displayList[0];
							if(personalReport.id === $scope.account.profile.id){
								personalReport.paid = true;
							}
						}*/

						//2. Clear Report Content
						//$scope.ds.personalreport.data.content = {};
						//$scope.account.profile.hdreport.content = {};
						LocalStorage.setObject('profile',$scope.account.profile);
						
						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(object){
							pendingUpdatePersonalReportList = _.without(pendingUpdatePersonalReportList, object);
							if(pendingUpdatePersonalReportList.length > 0){
								LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
							} else {
								LocalStorage.removeObject('pending_update_personal_report_list');
							}
						} 

						RefreshDisplayList();
					},
					function(data, status, headers, config){
						if (window.ga) {
							window.ga.trackEvent('Personal', 'checkout update server fail', data.gateway);
						}
						//fail
						
						//$ionicLoading.hide();
						//KBToast.error($scope.t.msg_error_update_personalchart_fail);

						if(!pendingUpdatePersonalReportList){
							pendingUpdatePersonalReportList = [];
						}

						var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
						if(!object){
							pendingUpdatePersonalReportList.push({id: $scope.account.profile.id, data: data});
							LocalStorage.setObject('pending_update_personal_report_list', pendingUpdatePersonalReportList);
						}						
					}
				);
			}

			var object = _.findWhere(pendingUpdatePersonalReportList, {id: $scope.account.profile.id});
			if(object){
				buyPersonalReport(object.data);
			}
		}
	}

	var RefreshDisplayList = function(){
		$scope.displayList = [];

		if($scope.personalReportList !== null){
			$scope.displayList = angular.copy($scope.personalReportList);

			//$scope.displayList = $scope.displayList.sort(function(a,b){return b.id - a.id});

			if($scope.personalReportList.length > 0){
				$scope.account.bPesonalChartExist = true
			}
			else{
				$scope.account.bPesonalChartExist = false
			}
		}

		if($scope.account.profile != null){
			var userPersonalReport = angular.copy($scope.account.profile);
			userPersonalReport.name = userPersonalReport.real_name + ' (You)';
			userPersonalReport.id = 0;
			userPersonalReport.IsUser = true;
			userPersonalReport.paid = $scope.account.profile.paid;

			$scope.displayList.unshift(userPersonalReport);
		}
	}

	var RefreshPersonalChartList = function(){
		console.log("Refresh Personal Chart List From Server");
		Airstation.list({app:'hdapp',resource:'personalchart'},
			function(rpn_data){
				//2.1 Success Handle
				console.log("GetPersonalChartData Success");

				//2.2 Adjust Birth Datetime
				for (index in rpn_data){
					var chart_data = rpn_data[index];
					Utility.AdjustBirthByLocation(chart_data);
				}

				$scope.personalReportList = rpn_data;
				Datastore.setPersonalReportList($scope.personalReportList);


				Account.getProfile(
					function(data, status, headers, config){
						//Success Callback
						if(status == 200){
							$scope.account.profile = data[0];

							console.log("GetProfileData Success, data:", data);
							//console.log($scope.account.profile);

							//Get time zone from location
							Utility.AdjustBirthByLocation($scope.account.profile);

							updateServerPurchasedReport();
						}//end of status 200
						else{
							KBToast.error('Failed to get personal chart data');
							KBToast.debug(status +' ' + data);
						}		 

						$scope.refresh = false;
					},//end of get profile success
					function(data, status, headers, config){
						//Fail Callback
						KBToast.error('Fail to get profile data');
						KBToast.debug(status +' ' + data);

						$scope.refresh = false;
						if(status == 401){
							console.log('Get profile Unauthorized');
							Logout();
						}
					}
				);

				//$scope.refresh = false;
			},
			function(error) {
				//2.1 Fail Handle
				KBToast.error('Failed to get personal chart list');
				$scope.refresh = false;

			}
		);
	}


	//------------------------------------
	// Event
	//-----------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('PersonalChartListCtrl beforeEnter');

		$scope.data = {
			showDelete: false,
			showSearch: false,
			slideIndex: 0 ,
			numViewableSlides: 0,
			filter_by: $scope.filter_options[0],
			filter_value: '',
		};

		// if ($scope.settings.bUseListView === true){
		// 	$scope.data.showSearch = true;
		// }
		$scope.data.showSearch = false;
		// RefreshDisplayList();
		$scope.doRefresh();
	});// end of $ionicView.beforeEnter

	$scope.$watch('refresh', function(newVal, oldVal){
		if(newVal !== oldVal && newVal === false){
			$scope.$broadcast('scroll.refreshComplete');
		}
	});

	$scope.$watch('displayList', function(newVal, oldVal){

		$scope.data.numViewableSlides = newVal.length;
		$scope.data.slideIndex = 0;

		$ionicSlideBoxDelegate.slide(0);
		$ionicSlideBoxDelegate.update();
	});

	$scope.$watch('data.filter_value', function(newVal, oldVal){
		//RefreshFilteredList();		
	});

	$scope.$watch('data.filter_by', function(newVal, oldVal){
		//RefreshFilteredList();
	});

	$scope.$watch('personalReportList', function(newVal, oldVal){
		console.log("On update personalReportList")

		//console.log(newVal)
		RefreshDisplayList();
	});

	//-----------------------------------
	// Valuable Define
	//-----------------------------------
	$scope.displayList = [];
	$scope.api_domain = api_domain
	$scope.filter_options = [
		{ title: 'Name', id: 'name' },
		{ title: 'City', id: 'city' },
	];
	$scope.refresh = false;

	//-----------------------------------
	// UI Function
	//-----------------------------------
	$scope.doRefresh = function(){
		console.log('Do doRefresh')
		$scope.refresh = true;
		RefreshPersonalChartList();
	}

	$scope.onItemDelete = function(){

		curSlideIndex = $ionicSlideBoxDelegate.currentIndex();

		item = $scope.personalReportList[curSlideIndex];
		console.log('delete item: ' + item.id);        

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		Airstation.delete({app:'hdapp',resource:'personalchart',id:item.id},
			function(rpn_data){

				//2.1 Success Handle
				$ionicLoading.hide();

				//Remove item from Datastore
				Datastore.delPersonalReport(item.id);

				//Reload
				$scope.personalReportList = Datastore.getPersonalReportList();

			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t.msg_error_del_personalchart_fail);
			}
		);
	}

	$scope.onItemSelect = function(id){
		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		$timeout(function(){
			if(id == 0){
				//User Personal Report
				ReportManager.getProfileChartReport($scope.account.profile,$scope.settings.report_default_lg,
					function(report){
						//success
						$scope.ds.personalreport = {};
						$scope.ds.personalreport.data = report;
						$scope.ds.personalreport.IsAutoSave = false;
						$scope.ds.personalreport.IsUser = true;
						
						$state.go('app.account.report_v2');
					},
					function(){
						//fail
						KBToast.error($scope.t.msg_error_get_personalchart_fail);
					}
				);
			}
			else{
				//Other Personal Report
				var report_obj;
				for (index in $scope.personalReportList ){
					var report = $scope.personalReportList[index];
					if(id == report.id){
						report_obj = report;
						break;
					}
				}

				//2.Get Report Content
				ReportManager.getPersonalChartReport(report_obj,$scope.settings.report_default_lg,
					function(report){
						//success
						$scope.ds.personalreport = {}
						$scope.ds.personalreport.data = report;
						$scope.ds.personalreport.IsAutoSave = false;
						$scope.ds.personalreport.IsUser = false;
						$state.go('app.personalchart.report_v2');
					},
					function(){
						//fail
						$ionicLoading.hide();
						KBToast.error($scope.t.msg_error_get_personalchart_fail);
					}
				);
			}
		},50);
	}
    

	$scope.createChart = function() {
		console.log("createChart");
		$state.go('app.personalchart.create');
	}

	$scope.listChart = function() {
		console.log("listChart");
		$state.go('app.personalchart.list');
	}

	$scope.next = function() {
		$ionicSlideBoxDelegate.next();
	};
	$scope.previous = function() {
		$ionicSlideBoxDelegate.previous();
	};
	// Called each time the slide changes
	$scope.OnSlideChanged = function(index) {
		$scope.data.slideIndex = index;
		console.log("Current Index: " + $scope.data.slideIndex );
	};

	$scope.filterReport = function(item) {
		try{
			var search_value = $scope.data.filter_value.toLowerCase();
			var name = item.name.toLowerCase();
			var city = item.city.toLowerCase();

			//console.log(item);

			if(name.indexOf(search_value) > -1){
				return true;
			}
			else if(city.indexOf(search_value) > -1){
				return true;
			}
			else{
				return false;
			}
		}
		catch(e){
			return false;
		}
	}

	$scope.OnChangeChartMode = function(){
		$scope.settings.bUseListView = false;

		if ($scope.data.filter_value != ''){
			$scope.data.showSearch = true;
		}
		else{
			$scope.data.showSearch = false;
		}
		LocalStorage.setObject('settings',$scope.settings);
	}

	$scope.OnChangeListMode = function(){
		$scope.settings.bUseListView = true;
		$scope.data.showSearch = true;
		LocalStorage.setObject('settings',$scope.settings);
	}
})

//------------------------------------
// Personal Chart Create Controller
//------------------------------------
.controller('PersonalChartCreateCtrl', function($scope,$state,$ionicLoading,$ionicHistory,
																			$ionicModal,
																			Datastore,
																			LocalStorage,
																			Account,
																			Airstation,
																			ReportManager,
																			Utility,
																			KBToast){

	/*
	$scope.$on('$ionicView.afterLeave', function () {
	  console.log('PersonalChartCreateCtrl afterLeave');
	  console.log($ionicHistory.viewHistory());
	});

	$scope.$on('$ionicView.unloaded', function () {
	  console.log('PersonalChartCreateCtrl unloaded');
	  console.log($ionicHistory.viewHistory());
	});
	*/

	//-------------------------
	// function
	//------------------------
	var getTime = function() {

		var date_str = moment($scope.birth.date).format('YYYY-MM-DD');
		var time_str = moment($scope.birth.time).format('HH:mm');

		Datastore.setDate(date_str);
		Datastore.setTime(time_str);
		Datastore.setTimezone($scope.birth.timezone);
		Datastore.setLocation($scope.birth.location);

		$scope.state.locationSelected = true;
		$scope.state.timezoneSelected = true;

		var time = date_str+' '+time_str;
		return moment.tz(time, $scope.birth.timezone);
	}

	var getUTC = function() {
		var date_str = moment($scope.birth.date).format('YYYY-MM-DD');
		var time_str = moment($scope.birth.time).format('HH:mm');

		Datastore.setDate(date_str);
		Datastore.setTime(time_str);

		$scope.state.locationSelected = false;
		$scope.state.timezoneSelected = true;

		var time = date_str + 'T' + time_str + $scope.birth.offset;
		var output = moment(time).utcOffset($scope.birth.offset);

		// var utcTime2 = moment(time).utcOffset("+08:00").format();	//correct for birth_local_ts
		// var utcTime1 = moment(utcTime2).utc();
		// utcTime1 = utcTime1.format('YYYY-MM-DD HH:mmZ');
		// console.log("utcoffset birth_ts", utcTime1);
		// console.log("utcoffset birth_local_ts", utcTime2);
		
		// console.log("getUTC output", output);
		return output;


		
	}

	//-------------------------
	// Event
	//------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('Create Personal Chart Before Enter, current state: ',$state.current.name);

		//Reset city selection
		$scope.state.locationSelected = false;
		$scope.state.timezoneSelected = false;
		$scope.birth.date = new Date(moment().format('MM/DD/YYYY'));
		$scope.birth.time = new Date(moment().format('MM/DD/YYYY HH:mm'));
		
		if($state.current.name == 'app.firstcreate' && $scope.account.IsProfileChartGenerated === true){
			console.log('Create Personal Chart route to menu');
			
			$ionicHistory.nextViewOptions({
				historyRoot : true,
			});

			$state.go('app.personalchart');
		}
	});

	$scope.$watch('tutorialModal', function(newVal, oldVal){
		if(newVal != null){
			if($scope.account.IsProfileChartGenerated === false){
				$scope.tutorialModal.show();
			}
		}
	});

	//-------------------------
	// Toggle button style
	//-------------------------
	$scope.toggleGender = function(newVal) {
		if ($scope.rqt_data.gender !== newVal) {
			$scope.rqt_data.gender = newVal;
		}
	}

	//-------------------------
	// DateTime Picker
	//-------------------------
	$scope.OpenNativeDatePicker = function(){
		

		var options = {
			date: new Date(moment($scope.birth.date).format('MM/DD/YYYY')),
			mode: 'date',
			minDate: new Date(moment($scope.birth.min).format('MM/DD/YYYY')),
			maxDate: new Date(moment($scope.birth.max).format('MM/DD/YYYY')),
		};

		
		datePicker.show(options, function(datetime){
			//alert("date result " + datetime); 
			if (datetime !== null && typeof datetime != 'undefined') {
				console.log('OpenNativeDatePicker, datetime:', datetime);

				//valid
				newDateTime = moment(datetime);
				minDateTime = moment($scope.birth.min);
				maxDateTime = moment($scope.birth.max);

				if(newDateTime >= minDateTime){
					if(newDateTime <= maxDateTime){
						$scope.showDateInvalid = false;
					} else if($scope.account.profile.is_staff){
						$scope.showDateInvalid = false;
					} else {
						$scope.showDateInvalid = true;
					}
				} else{
					$scope.showDateInvalid = true;
					//alert("Invalid Date " + datetime); 
				}

				$scope.birth.date = new Date(moment(datetime).format('MM/DD/YYYY'));

				$scope.$apply();
			}
		});

	}

	$scope.OpenNativeTimePicker = function(){
		

		var options = {
			date: new Date(moment($scope.birth.time).format('MM/DD/YYYY HH:mm')),
			mode: 'time',
		};

		
		datePicker.show(options, function(datetime){
			//alert("date result " + datetime);  
			if (datetime !== null && typeof datetime != 'undefined') {
				$scope.birth.time = new Date(moment(datetime).format('MM/DD/YYYY HH:mm'));
				$scope.$apply();
			}
		});

	}

	//-------------------------
	//	Valuable Define
	//------------------------
	//For Map
	$scope.map = Datastore.getGoogleMapSetting();

	$scope.rqt_data = {
		name : "",
		birth_ts: null,
		gender: "M",
		valid: false,
	}

	$scope.birth = {
		timezone : Datastore.getTimezone(),
		location : Datastore.getLocation(),
		offset : null,
		date : new Date(moment(Datastore.getDate()).format('MM/DD/YYYY')),
		time : new Date(moment(Datastore.getTime()).format('MM/DD/YYYY HH:mm')),
		min : new Date('1900-01-01'),
		max : new Date(),
	}

	$scope.zones = moment.tz.names();
	$scope.tutorialModal = null

	$scope.state = {
		timezoneSelected : (Datastore.getTimezone()?true:false),
		locationSelected : (Datastore.getLocation()?true:false),
	}

	$scope.showError = false;
	$scope.showDateInvalid = false;

	//Create Personal Chart Tutorial
	
	$ionicModal.fromTemplateUrl('templates/modal-tutorial.html',{
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.tutorialModal = modal
	});

	//-------------------------
	//	UI Function
	//------------------------
	$scope.ShowTutorialModal = function() {
		$scope.tutorialModal.show();
	};

	$scope.CloseTutorialModal = function() {
		$scope.tutorialModal.hide();
	};

	$scope.data.tutorialList = [
		{
			title: $scope.t.title_tutorial_1,
			text: $scope.t.text_tutorial_1,
			image: 'img/tutorial/tutorial_pic1.png',
		},
		{
			title: $scope.t.title_tutorial_2,
			text: $scope.t.text_tutorial_2,
			image: 'img/tutorial/tutorial_pic2.png',
		},			
		{
			title: $scope.t.title_tutorial_3,
			text: $scope.t.text_tutorial_3,
			image: 'img/tutorial/tutorial_pic3.png',
		},
		{
			title: $scope.t.title_tutorial_4,
			text: $scope.t.text_tutorial_4,
			image: 'img/tutorial/tutorial_pic4.png',
		},
		{
			title: $scope.t.title_tutorial_5,
			text: $scope.t.text_tutorial_5,
			image: 'img/tutorial/tutorial_pic5.png',
		},
	];

	$scope.generateChart = function() {
		$scope.showError = true;

		if (typeof $scope.birth.date === "undefined"){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if ($scope.birth.date < $scope.birth.min){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if($scope.birth.date > $scope.birth.max && !$scope.account.profile.is_staff){
			KBToast.error($scope.t.msg_fill_valid_info);
			return;
		}

		if(typeof $scope.rqt_data.name === "undefined"){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		if($scope.rqt_data.name == ''){
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		if ($scope.birth.location === null && $scope.birth.offset === null) {
			KBToast.error($scope.t.msg_fill_required_info);
			return;
		}

		// console.log("$scope.rqt_data.name", $scope.rqt_data.name);
		// console.log("$scope.birth.location", $scope.birth.location);
		// console.log("$scope.birth.location.name", $scope.birth.location.name);
		// console.log("$scope.birth.offset", $scope.birth.offset);

		//1. Perpare Request Data
		if ($scope.birth.location) {
			$scope.rqt_data.birth_ts = getTime().format('YYYY-MM-DD HH:mmZ');
			$scope.rqt_data.birth_local_ts = getTime().format();
			$scope.rqt_data.city = $scope.birth.location.name.toLowerCase();
			$scope.rqt_data.country = $scope.birth.location.cty
			$scope.rqt_data.cty_code = $scope.birth.location.cc
			$scope.rqt_data.timezone = $scope.birth.timezone;	
		} else {
			$scope.rqt_data.birth_ts = getUTC().format('YYYY-MM-DD HH:mmZ');
			$scope.rqt_data.birth_local_ts = getUTC().format();
			$scope.rqt_data.city = "";
			$scope.rqt_data.country = "";
			$scope.rqt_data.cty_code = "";
			$scope.rqt_data.timezone = "null";
		}
		
 
		console.log("request data", $scope.rqt_data);

		//2. Make request
		$ionicLoading.show({template:'<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		if($scope.account.IsProfileChartGenerated === true){
			//Normal Create Chart
			Airstation.post({app:'hdapp',resource:'personalchart'},$scope.rqt_data,
				function(rpn_data){
					//2.1 Success Handle
					$ionicLoading.hide();

					Utility.AdjustBirthByLocation(rpn_data);

					console.log("Response data", rpn_data);

					//Get Personal Report Content
					ReportManager.getPersonalChartReport(rpn_data,$scope.settings.report_default_lg,
						function(report){
							//success
							$scope.ds.personalreport = {}
							$scope.ds.personalreport.data = report;
							$scope.ds.personalreport.IsAutoSave = true;
							$scope.ds.personalreport.IsUser = false;
							$state.go('app.personalchart.report_v2');
						},
						function(){
							//fail
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_get_personalchart_fail);
						}
					);
				},
				function(error){
					//2.1 Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
				}
			);
		}
		else{
			//Gerenate User Personal Chart

			//1. Get Profile
			$scope.rqt_data.id =  LocalStorage.getItem('user_id');
			$scope.rqt_data.real_name = $scope.rqt_data.name;

			Account.updateProfile($scope.rqt_data,
				function(data, status, headers, config){
					//Success Handle

					LocalStorage.setItem('IsProfileChartGenerated',true);
					$scope.account.IsProfileChartGenerated = true;

					$scope.account.profile = data;
					Utility.AdjustBirthByLocation($scope.account.profile);

					ReportManager.getProfileChartReport($scope.account.profile,$scope.settings.report_default_lg,
						function(report){
							//success
							$scope.ds.personalreport = {}
							$scope.ds.personalreport.data = report;
							$scope.ds.personalreport.IsAutoSave = false;
							$scope.ds.personalreport.IsUser = true;
							$state.go('app.account.report_v2');
						},
						function(){
							//fail
							$ionicLoading.hide();
							KBToast.error($scope.t.msg_error_get_personalchart_fail);
						}
					);
				},//end of updateProfile success handle
				function(error) {
					//Fail Handle
					$ionicLoading.hide();
					KBToast.error($scope.t.msg_error_get_personalchart_fail);
				}
			);
		}
	}
})

//------------------------------------
// Personal Chart Report Controller
//------------------------------------
// .controller('PersonalChartReportCtrl', function($scope,$state,$ionicLoading,
// 																$filter,
// 																$ionicHistory,
// 																$ionicModal,
// 																$ionicPopup,
// 																Account,
// 																Datastore,
// 																LocalStorage,
// 																Airstation,
// 																ReportManager,
// 																KBStore,
// 																KBToast,
// 																PaymentService,
// 																Utility) {
	
// 	//------------------------------------
// 	// function
// 	//------------------------------------
// 	var getReportContent = function(lg_code){

// 		if($scope.personalchart.IsUser === false){
// 			ReportManager.getPersonalChartReport($scope.report,lg_code,
// 				function(report){
// 					//success
// 					$scope.report = report
// 					$scope.content.t = $scope.report.content[lg_code]
// 					$scope.refresh = false;
// 				},
// 				function(){
// 					//fail
// 					KBToast.error($scope.t.msg_error_get_personalchart_fail);
// 					$scope.refresh = false;
// 				}
// 			);
// 		}
// 		else{
// 			ReportManager.getProfileChartReport($scope.account.profile,lg_code,
// 				function(report){
// 					//success
// 					$scope.report = report
// 					$scope.content.t = $scope.report.content[lg_code];
// 					$scope.refresh = false;
// 				},
// 				function(){
// 					//fail
// 					KBToast.error($scope.t.msg_error_get_personalchart_fail);
// 					$scope.refresh = false;
// 				}
// 			);
// 		}     
// 	}

// 	$scope.OnChangeLanguage = function(lang_code){
// 		var language = null;
// 		console.log('OnChangeLanguage',lang_code)

// 		if (window.ga) {
// 			window.ga.trackView('/app/personlchart/report/' + lang_code);
// 		}

// 		$scope.content.lg = lang_code
// 		$scope.content.title = $scope.heading[lang_code]
// 		if(lang_code in $scope.report.content){
// 			console.log('report '+lang_code+ ' exist')
// 			$scope.content.t = $scope.report.content[lang_code]
// 		}
// 		else{
// 			getReportContent(lang_code);
// 		}
// 	}

// 	//--------------------------------
// 	// Event
// 	//--------------------------------
// 	$scope.$on('$ionicView.leave', function () {
// 		//Remove Chart enlargement #746 
// 		//$scope.imgModal.hide();
// 	});

// 	$scope.$watch('refresh', function(newVal, oldVal){
// 		if(newVal !== oldVal && newVal === false){
// 			$scope.$broadcast('scroll.refreshComplete');
// 		}
// 	});

// 	$scope.$on('$ionicView.afterEnter', function () {
// 		if (window.ga) {
// 			window.ga.trackView('/app/personlchart/report/' + $scope.content.lg);
// 		}
// 	});



// 	//------------------------------------
// 	// Valuable Define
// 	//------------------------------------
// 	console.log('PersonalChartReportCtrl');
// 	console.log($scope.personalchart);

// 	$scope.heading = {}
// 	$scope.heading['en'] = {
// 		personal_chart_report_name : "Name",
// 		personal_chart_report_type : "Type",
// 		personal_chart_report_authority : "Authority",
// 		personal_chart_report_profile : "Profile",
// 		personal_chart_report_type_report : "Type",
// 		personal_chart_report_authority_report : "Authority",
// 		personal_chart_report_profile_report : "Profile",
// 		personal_chart_report_center_report : "Center",
// 		personal_chart_report_channel_report : "Channel",
// 		personal_chart_report_gate_report : "Gate",
// 		text_defined : "(Defined)",
// 	}

// 	$scope.heading['zh-tw'] = {
// 		personal_chart_report_tite : "報告",
// 		personal_chart_report_name : "名字 ",
// 		personal_chart_report_type : "類型 ",
// 		personal_chart_report_authority : "內在權威 ",
// 		personal_chart_report_profile : "輪廓 ",
// 		personal_chart_report_type_report : "類型",
// 		personal_chart_report_authority_report : "內在權威",
// 		personal_chart_report_profile_report : "輪廓",
// 		personal_chart_report_center_report : "能量中心",
// 		personal_chart_report_channel_report : "通道",
// 		personal_chart_report_gate_report : "閘門",
// 		text_defined : "(定義)",
// 	}

// 	$scope.heading['zh-cn'] = {
// 		personal_chart_report_tite : "报告",
// 		personal_chart_report_name : "名字 ",
// 		personal_chart_report_type : "类型 ",
// 		personal_chart_report_authority : "內在权威 ",
// 		personal_chart_report_profile : "轮廓 ",
// 		personal_chart_report_type_report : "类型",
// 		personal_chart_report_authority_report : "內在权威",
// 		personal_chart_report_profile_report : "轮廓",
// 		personal_chart_report_center_report : "能量中心",
// 		personal_chart_report_channel_report : "通道",
// 		personal_chart_report_gate_report : "闸门",
// 		text_defined : "(定义)",
// 	}

// 	$scope.refresh = true;
// 	$scope.report = {};
// 	$scope.report = $scope.personalchart.report;

// 	$scope.content = {};
// 	$scope.content.available_lg = {}
// 	$scope.content.available_lg = g_report_available_lg

// 	$scope.content.lg = $scope.settings.report_default_lg;
// 	$scope.content.t = $scope.personalchart.report.content[$scope.content.lg];
// 	$scope.content.title = $scope.heading[$scope.content.lg]

// 	$scope.api_domain = api_domain
// 	$scope.socialshare = Datastore.getSocialShare();

// 	$scope.map = Datastore.getGoogleMapSetting();

// 	$scope.showError = false;
// 	$scope.showDateInvalid = false;

// 	//AutoSave
// 	if($scope.personalchart.IsAutoSave === true && $scope.personalchart.IsUser === false){
// 		Datastore.addPersonalReport($scope.report);
// 	}

// 	//-------------------------
// 	// DateTime Picker
// 	//-------------------------
// 	$scope.OpenNativeDatePicker = function(){
		

// 		var options = {
// 			date: new Date(moment($scope.editData.birth.date).format('MM/DD/YYYY')),
// 			mode: 'date',
// 			minDate: new Date(moment($scope.editData.birth.min).format('MM/DD/YYYY')),
// 			maxDate: new Date(moment($scope.editData.birth.max).format('MM/DD/YYYY')),
// 		};

		
// 		datePicker.show(options, function(datetime){
// 			//alert("date result " + datetime); 
// 			if (datetime !== null && typeof datetime != 'undefined') {

// 				//valid
// 				newDateTime = moment(datetime);
// 				minDateTime = moment($scope.editData.birth.min);
// 				maxDateTime = moment($scope.editData.birth.max);

// 				if(newDateTime >= minDateTime){
// 					$scope.showDateInvalid = false;
// 				} else if(newDateTime <= maxDateTime && $scope.account.profile.is_staff !== true){
// 					$scope.showDateInvalid = false;
// 					//alert("Invalid Date " + datetime); 
// 				} else {
// 					$scope.showDateInvalid = true;
// 				}

// 				$scope.editData.birth.date = new Date(moment(datetime).format('MM/DD/YYYY'));

// 				$scope.$apply();
// 			}
// 		});

// 	}

// 	$scope.OpenNativeTimePicker = function(){

// 		var options = {
// 			date: new Date(moment($scope.editData.birth.time).format('MM/DD/YYYY HH:mm')),
// 			mode: 'time',
// 		};

// 		datePicker.show(options, function(datetime){
// 			//alert("date result " + datetime);  
// 			if (datetime !== null && typeof datetime != 'undefined') {
// 				$scope.editData.birth.time = new Date(moment(datetime).format('MM/DD/YYYY HH:mm'));
// 				$scope.$apply();
// 			}
// 		});

// 	}

//     //------------------------------------
//     // Payment
//     //------------------------------------
// 	$scope.payment = {};

// 	//Chcek Item is valid
// 	//for android
// 	//$scope.payment.product = KBStore.getProduct("com.newageideas.hd.personalreport");
// 	//for ios
// 	//$scope.payment.product = KBStore.getProduct("com.newageideas.tier7.personalreport");
// 	$scope.payment.product = KBStore.getProduct(g_product_name);

// 	console.log($scope.payment)
// 	if($scope.payment.product != null){
// 		$scope.payment.available = true;
// 	}
// 	else{
// 		$scope.payment.available = false;
// 	}

//     $scope.payment.paymentServices = KBStore.getAvailableServices();
//     //console.log($scope.payment);
// 	$ionicModal.fromTemplateUrl('templates/app-payment.html', {
// 		scope: $scope,
// 		animation: 'slide-in-up'
// 		}).then(function(modal){
// 			$scope.paymentModal = modal;
// 		}
// 	);

// 	$scope.OpenPaymentModal = function() {
// 		window.ga.trackView('/app/payment');
// 		window.ga.trackEvent('click $',{category:'Personal'});
// 		//$scope.CheckoutSuccess();
// 		$scope.paymentModal.show()
// 	};

// 	$scope.ClosePaymentModal = function() {
// 		console.log($state.current);
// 		$scope.status.payment = false;
// 		$scope.paymentModal.hide()
// 	};

// 	$scope.checkoutItem = function (service_id) {

// 		service = $scope.payment.paymentServices[service_id]
// 		//console.log(service)
// 		window.ga.trackView('/app/payment/begin');
// 		if(service.name == 'iap'){
// 			window.ga.trackEvent('checkout begin',{category:'Personal',label:service.iap_name});
// 		}
// 		else{
// 			window.ga.trackEvent('checkout begin',{category:'Personal',label:service.name});
// 		}	
// 		KBStore.checkoutItem(service_id,'Personal',$scope.payment.product.id,$scope.CheckoutSuccess,$scope.CheckoutFail);
// 	};

// 	$scope.CheckoutSuccess = function(servicename){
// 		console.log('payment success');
// 		window.ga.trackView('/app/payment/success');
// 		window.ga.trackEvent('checkout update server begin',{category:'Personal',label:servicename});	
// 		$scope.paymentModal.hide()

// 		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});

// 		//1. Update payment record to server
// 		if($scope.personalchart.IsUser === false){
// 			Airstation.put(
// 				{
// 					app:'hdapp',
// 					resource:'personalchart',
// 					id:$scope.report.id,
// 					sub_resource:'payment',
// 				},
// 				{},
// 				function(rpn_data){


// 					window.ga.trackEvent('checkout update server success',{category:'Personal',label:servicename});	
// 					$ionicLoading.hide();
// 					$scope.report.paid = true;

// 					//2. Clear Report Content
// 					$scope.report.content = {};
// 					Datastore.updatePersonalReport($scope.report)

// 					//3. reload report data
// 					getReportContent($scope.content.lg);
// 				},function(error){
// 					//2.1 Fail Handle
// 					window.ga.trackEvent('checkout update server fail',{category:'Personal',label:servicename});	
// 					$ionicLoading.hide();
// 					KBToast.error($scope.t.msg_error_update_personalchart_fail);
// 				}
// 			);
// 		}
// 		else{
// 			Account.buyPersonalReport(
// 				function(data, status, headers, config){

// 					window.ga.trackEvent('checkout update server success',{category:'Personal',label:servicename});	
// 					//Success
// 					$ionicLoading.hide();
// 					$scope.account.profile.paid = true;
// 					$scope.report.paid = true;

// 					//2. Clear Report Content
// 					$scope.report.content = {};
// 					$scope.account.profile.hdreport.content = {};
// 					LocalStorage.setObject('profile',$scope.account.profile);
					
// 					getReportContent($scope.content.lg);
// 				},
// 				function(data, status, headers, config){
// 					window.ga.trackEvent('checkout update server fail',{category:'Personal',label:servicename});	
// 					//fail
// 					$ionicLoading.hide();
// 					KBToast.error($scope.t.msg_error_update_personalchart_fail);
// 				}
// 			);
// 		}
// 	};

// 	$scope.CheckoutFail = function(servicename){
// 		window.ga.trackView('/app/payment/fail');
// 		console.log('payment fail');
// 		KBToast.error('Fail to purchase item');
// 	};

// 	//------------------------------------
// 	// Social Share
// 	//------------------------------------
// 	$scope.socialshare.data = {
// 		title:'Human Design Chart',
// 		img_url: api_domain + $scope.report.chart_img_url,
// 	};

// 	$scope.shareViaFacebook =function(){
// 		console.log("shareViaFacebook");
// 		console.log($scope.socialshare.data);
// 		window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint($scope.socialshare.data.title,
// 			null /* img */,
// 			$scope.socialshare.data.img_url,
// 			function(){
// 				console.log('share ok')
// 			},
// 			function(errormsg){
// 				//alert(errormsg)
// 			}
// 		); 
// 	};

// 	$scope.shareViaWhatsapp =function(){
// 		console.log("shareViaWhatsapp");
// 		console.log($scope.socialshare.data);
// 		window.plugins.socialsharing.shareViaWhatsApp($scope.socialshare.data.title,
// 			$scope.socialshare.data.img_url,
// 			null,
// 			function(){
// 				console.log('share ok')
// 			},
// 			function(errormsg){
// 				//alert(errormsg)
// 			}
// 		); 
// 	};

// 	$scope.shareVia = function(){
// 		console.log("shareVia");
// 		console.log($scope.socialshare.data);
// 		window.plugins.socialsharing.share($scope.socialshare.data.title,
// 			null,
// 			$scope.socialshare.data.img_url,
// 			null,
// 			function(){
// 				console.log('share ok')
// 			},
// 			function(errormsg){
// 				//alert(errormsg)
// 			}
// 		); 
// 	};
    
// 	//------------------------------------
// 	// UI Function
// 	//------------------------------------
// 	$scope.doRefresh = function(){
// 		console.log('Do doRefresh')
// 		$scope.refresh = true;
// 		$scope.report.content = {};
// 		getReportContent($scope.content.lg);
// 	}

// 	$scope.showDelConfirmDialog = function() {
// 		var confirmPopup = $ionicPopup.confirm({
// 			title: $scope.t.dialog_del_personal_chart_title,
// 			template: $scope.t.dialog_del_personal_chart_content,
// 			cancelText: $scope.t.cancel_button,
// 			okText: $scope.t.delete_button,
// 			okType: 'button-assertive',
// 			cancelType: 'button-balanced',
// 			cssClass: 'confirm-dialog',
// 		});

// 		confirmPopup.then(function(res) {
// 			if(res) {
// 				$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
// 				Airstation.delete({app:'hdapp',resource:'personalchart',id:$scope.report.id},
// 					function(rpn_data){
// 						//2.1 Success Handle
// 						$ionicLoading.hide();
// 						Datastore.delPersonalReport($scope.report.id);
// 						$ionicHistory.nextViewOptions({
// 							historyRoot : true,
// 						});
// 						$state.go('app.personalchart');

// 					},
// 					function(error) {
// 						//2.1 Fail Handle
// 						$ionicLoading.hide();
// 						KBToast.error($scope.t.msg_error_del_personalchart_fail);
// 					}
// 				);
// 			}
// 			else{
// 			console.log('Del cancel');
// 			}
// 		});
// 	};

// 	//------------------------------------
// 	// Chart Image Model
// 	//------------------------------------

// 	/* Remove Chart enlargement #746 
// 	$ionicModal.fromTemplateUrl('image-modal.html',{
// 		scope: $scope,
// 		animation: 'slide-in-up'
// 	}).then(function(modal){
// 		$scope.imgModal = modal;
// 	});
// 	$scope.openModal = function() {
// 		console.log('Open Modal');
// 		$scope.imgModal.show();
// 	}

// 	$scope.closeModal = function () {
// 		console.log('Close Modal');
// 		$scope.imgModal.hide();
// 	}*/

// 	$('img.svg').each(function(){
// 		var $img = $(this);
// 		var imgID = $img.attr('id');
// 		var imgClass = $img.attr('class');
// 		var imgURL = $img.attr('src');

// 		$.get(imgURL, function(data) {
// 			// Get the SVG tag, ignore the rest
// 			var $svg = $(data).find('svg');

// 			// Add replaced image's ID to the new SVG
// 			if(typeof imgID !== 'undefined') {
// 				$svg = $svg.attr('id', imgID);
// 			}
// 			// Add replaced image's classes to the new SVG
// 			if(typeof imgClass !== 'undefined') {
// 				$svg = $svg.attr('class', imgClass+' replaced-svg');
// 			}

// 			// Remove any invalid XML tags as per http://validator.w3.org
// 			$svg = $svg.removeAttr('xmlns:a');

// 			// Replace image with new SVG
// 			$img.replaceWith($svg);

// 		},'xml');
// 	});
// })