angular.module('starter.controllers')

//====================================
// Account Controller
//====================================
.controller('RaveYearCtrl',function($scope,$state,$interval,$ionicLoading,LocalStorage,Airstation,Datastore,KBToast){

	

	//--------------------------------
	// Function
	//--------------------------------
	var startCountDown = function(){
		$scope.data.countDownTimer = $interval(function(){
			console.log('secondsLeft',$scope.data.secondsLeft);
			$scope.data.secondsLeft--;
			if(!$scope.$$phase) {
				$scope.$apply();
			}

			if($scope.data.secondsLeft <= 0){
				$scope.data.secondsLeft = $scope.getSecondsLeft();
			}
		},1000);
	}

	$scope.getDaysLeft = function(){
		return Math.floor($scope.data.secondsLeft / 3600 / 24);
	}

	$scope.getHoursLeft = function(){
		return Math.floor(($scope.data.secondsLeft - $scope.getDaysLeft() * 3600 * 24)/ 3600);
	}

	$scope.getMinutesLeft = function(){
		return Math.floor(($scope.data.secondsLeft - ($scope.getDaysLeft() * 3600 * 24
			+ $scope.getHoursLeft() * 3600)) / 60);
	}

	/*$scope.getRaveYearList = function(){
		Airstation.get({app: 'hdapp',resource: 'raveyear'},function(data){
			console.log('list raveyear success,data:',data);
			$scope.ds.raveyear = data.results;
			LocalStorage.setObject('raveyear',$scope.ds.raveyear);
			$scope.data.secondsLeft = $scope.getSecondsLeft();
			startCountDown();
		},function(error){
			console.log('list raveyear failed,error:',error);
			KBToast.error($scope.t.error_get_rave_year);
		});
	}*/

	var getRaveObject = function(year){
		var raveObject = _.findWhere($scope.ds.raveyear,{year: year});
		if(!raveObject){
			return null;
		}

		//return moment(raveObject.rave_date);
		return raveObject;
	}

	$scope.getSecondsLeft = function(){
		if(!$scope.ds.raveyear){
			return;
		}

		var currentDate = new Date();
		//var raveDate = getRaveDate(currentDate.getFullYear().toString());		
		var raveObject = getRaveObject((currentDate.getFullYear()+1).toString());
		var raveDate = moment(raveObject.rave_date);

		if(!raveDate){
			return;
		}

		var difference = raveDate.diff(moment(currentDate),'seconds');
		if(difference > 0){
			//$scope.data.raveDate = raveDate;
			//$scope.data.raveChart = raveObject.chart_img_url;
			raveObject.imageUrl = api_domain + raveObject.chart_img_url;
			raveObject.raveDate = moment(raveObject.rave_date);
			$scope.data.raveObject = raveObject;
			return difference;
		} else {
			//var raveDate = getRaveDate((currentDate.getFullYear()+1).toString());
			var raveObject = getRaveDate((currentDate.getFullYear()+1).toString());
			var raveDate = moment(raveObject.rave_date);
			if(!raveDate){
				return;
			}

			//$scope.data.raveDate = raveDate;
			//$scope.data.raveChart = raveObject.chart_img_url;
			raveObject.imageUrl = api_domain + raveObject.chart_img_url;
			raveObject.raveDate = moment(raveObject.rave_date);
			$scope.data.raveObject = raveObject;
			var difference = raveDate.diff(moment(currentDate),'seconds');
			return difference;
		}
	}

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter',function(){
		if(!$scope.ds.raveyear){
			$scope.ds.raveyear = LocalStorage.getObject('raveyear');
		}

		if(!$scope.ds.raveyear){
			$scope.ds.raveyear = [
				{
					"year": "2016",
					"rave_date": "2016-01-22T14:37:56Z",
					"chart_img_url": "/media/rave_year/2016.png"
				},
				{
					"year": "2017",
					"rave_date": "2017-01-21T20:33:30Z",
					"chart_img_url": "/media/rave_year/2017.png"
				},
				{
					"year": "2018",
					"rave_date": "2018-01-22T02:18:30Z",
					"chart_img_url": "/media/rave_year/2018.png"
				},
				{
					"year": "2019",
					"rave_date": "2019-01-22T08:10:26Z",
					"chart_img_url": "/media/rave_year/2019.png"
				},
				{
					"year": "2020",
					"rave_date": "2020-01-22T14:03:27Z",
					"chart_img_url": "/media/rave_year/2020.png"
				},
				{
					"year": "2021",
					"rave_date": "2021-01-21T19:49:38Z",
					"chart_img_url": "/media/rave_year/2021.png"
				},
				{
					"year": "2022",
					"rave_date": "2022-01-22T01:49:48Z",
					"chart_img_url": "/media/rave_year/2022.png"
				},
				{
					"year": "2023",
					"rave_date": "2023-01-22T07:38:11Z",
					"chart_img_url": "/media/rave_year/2023.png"
				},
				{
					"year": "2024",
					"rave_date": "2024-01-22T13:17:48Z",
					"chart_img_url": "/media/rave_year/2024.png"
				},
				{
					"year": "2025",
					"rave_date": "2025-01-21T19:10:13Z",
					"chart_img_url": "/media/rave_year/2025.png"
				},
				{
					"year": "2026",
					"rave_date": "2026-01-22T00:53:55Z",
					"chart_img_url": "/media/rave_year/2026.png"
				},
				{
					"year": "2027",
					"rave_date": "2027-01-22T06:40:29Z",
					"chart_img_url": "/media/rave_year/2027.png"
				},
				{
					"year": "2028",
					"rave_date": "2028-01-22T12:31:01Z",
					"chart_img_url": "/media/rave_year/2028.png"
				},
				{
					"year": "2029",
					"rave_date": "2029-01-21T18:10:22Z",
					"chart_img_url": "/media/rave_year/2029.png"
				},
				{
					"year": "2030",
					"rave_date": "2030-01-22T00:05:07Z",
					"chart_img_url": "/media/rave_year/2030.png"
				},
				{
					"year": "2031",
					"rave_date": "2031-01-22T05:56:20Z",
					"chart_img_url": "/media/rave_year/2031.png"
				},
				{
					"year": "2032",
					"rave_date": "2032-01-22T11:40:56Z",
					"chart_img_url": "/media/rave_year/2032.png"
				},
				{
					"year": "2033",
					"rave_date": "2033-01-21T17:42:42Z",
					"chart_img_url": "/media/rave_year/2033.png"
				},
				{
					"year": "2034",
					"rave_date": "2034-01-21T23:35:42Z",
					"chart_img_url": "/media/rave_year/2034.png"
				},
				{
					"year": "2035",
					"rave_date": "2035-01-22T05:24:31Z",
					"chart_img_url": "/media/rave_year/2035.png"
				},
				{
					"year": "2036",
					"rave_date": "2036-01-22T11:20:18Z",
					"chart_img_url": "/media/rave_year/2036.png"
				},
				{
					"year": "2037",
					"rave_date": "2037-01-21T17:02:38Z",
					"chart_img_url": "/media/rave_year/2037.png"
				},
				{
					"year": "2038",
					"rave_date": "2038-01-21T22:59:18Z",
					"chart_img_url": "/media/rave_year/2038.png"
				},
				{
					"year": "2039",
					"rave_date": "2039-01-22T04:52:10Z",
					"chart_img_url": "/media/rave_year/2039.png"
				},
				{
					"year": "2040",
					"rave_date": "2040-01-22T10:30:26Z",
					"chart_img_url": "/media/rave_year/2040.png"
				},
				{
					"year": "2041",
					"rave_date": "2041-01-21T16:23:32Z",
					"chart_img_url": "/media/rave_year/2041.png"
				},
				{
					"year": "2042",
					"rave_date": "2042-01-21T22:08:16Z",
					"chart_img_url": "/media/rave_year/2042.png"
				},
				{
					"year": "2043",
					"rave_date": "2043-01-22T03:51:15Z",
					"chart_img_url": "/media/rave_year/2043.png"
				},
				{
					"year": "2044",
					"rave_date": "2044-01-22T09:46:36Z",
					"chart_img_url": "/media/rave_year/2044.png"
				},
				{
					"year": "2045",
					"rave_date": "2045-01-21T15:30:27Z",
					"chart_img_url": "/media/rave_year/2045.png"
				},
				{
					"year": "2046",
					"rave_date": "2046-01-21T21:25:58Z",
					"chart_img_url": "/media/rave_year/2046.png"
				},
				{
					"year": "2047",
					"rave_date": "2047-01-22T03:18:32Z",
					"chart_img_url": "/media/rave_year/2047.png"
				},
				{
					"year": "2048",
					"rave_date": "2048-01-22T08:55:57Z",
					"chart_img_url": "/media/rave_year/2048.png"
				},
				{
					"year": "2049",
					"rave_date": "2049-01-21T14:51:16Z",
					"chart_img_url": "/media/rave_year/2049.png"
				},
				{
					"year": "2050",
					"rave_date": "2050-01-21T20:41:52Z",
					"chart_img_url": "/media/rave_year/2050.png"
				},
				{
					"year": "2051",
					"rave_date": "2051-01-22T02:28:04Z",
					"chart_img_url": "/media/rave_year/2051.png"
				},
				{
					"year": "2052",
					"rave_date": "2052-01-22T08:23:50Z",
					"chart_img_url": "/media/rave_year/2052.png"
				},
				{
					"year": "2053",
					"rave_date": "2053-01-21T14:07:26Z",
					"chart_img_url": "/media/rave_year/2053.png"
				},
				{
					"year": "2054",
					"rave_date": "2054-01-21T20:00:55Z",
					"chart_img_url": "/media/rave_year/2054.png"
				},
				{
					"year": "2055",
					"rave_date": "2055-01-22T01:57:49Z",
					"chart_img_url": "/media/rave_year/2055.png"
				},
				{
					"year": "2056",
					"rave_date": "2056-01-22T07:41:11Z",
					"chart_img_url": "/media/rave_year/2056.png"
				},
				{
					"year": "2057",
					"rave_date": "2057-01-21T13:40:04Z",
					"chart_img_url": "/media/rave_year/2057.png"
				},
				{
					"year": "2058",
					"rave_date": "2058-01-21T19:34:23Z",
					"chart_img_url": "/media/rave_year/2058.png"
				},
				{
					"year": "2059",
					"rave_date": "2059-01-22T01:15:38Z",
					"chart_img_url": "/media/rave_year/2059.png"
				},
				{
					"year": "2060",
					"rave_date": "2060-01-22T07:08:02Z",
					"chart_img_url": "/media/rave_year/2060.png"
				},
				{
					"year": "2061",
					"rave_date": "2061-01-21T12:50:38Z",
					"chart_img_url": "/media/rave_year/2061.png"
				},
				{
					"year": "2062",
					"rave_date": "2062-01-21T18:39:46Z",
					"chart_img_url": "/media/rave_year/2062.png"
				},
				{
					"year": "2063",
					"rave_date": "2063-01-22T00:33:12Z",
					"chart_img_url": "/media/rave_year/2063.png"
				},
				{
					"year": "2064",
					"rave_date": "2064-01-22T06:09:33Z",
					"chart_img_url": "/media/rave_year/2064.png"
				},
				{
					"year": "2065",
					"rave_date": "2065-01-21T11:58:50Z",
					"chart_img_url": "/media/rave_year/2065.png"
				},
				{
					"year": "2066",
					"rave_date": "2066-01-21T17:50:41Z",
					"chart_img_url": "/media/rave_year/2066.png"
				}				
			];
			startCountDown();
		} else {
			$scope.data.secondsLeft = $scope.getSecondsLeft();
			startCountDown();
		}
		console.log('raveyear list',$scope.ds.raveyear);
	});

	$scope.$on('$ionicView.beforeLeave',function(){
		if($scope.data.countDownTimer){
			console.log('RaveYearCtrl beforeLeave,cancel timer');
			$interval.cancel($scope.data.countDownTimer);
		}
	});

	//--------------------------------
	// Valuable Define 
	//--------------------------------
	$scope.data = {};
	//$scope.data.raveDate = null;
	//$scope.data.raveChart = null;
	$scope.data.raveObject = null;
	$scope.data.secondsLeft = null;
	$scope.data.countDownTimer = null;
});
