angular.module('starter.controllers')

//====================================
// Relationship Chart Controller
//====================================
.controller('RelationshipChartCtrl', function($scope,$state,$ionicLoading,
														  $ionicSlideBoxDelegate,
														  $filter,
														  $ionicModal,
														  $ionicHistory,
														  Datastore,
														  Airstation,
														  Account,
														  KBToast,
														  LocalStorage,
														  Utility) {
	
	//init data
	$scope.api_domain = api_domain
	$scope.filter_options = [
								{ title: 'Name', id: 'name' },
								{ title: 'City', id: 'city' },
							];

	//--------------------------------
	// Private Function
	//--------------------------------
	var RefreshDisplayList = function(){

		//get personal chart list
		$scope.perparingList  = angular.copy($scope.personalReportList);
		$scope.perparingList = $scope.perparingList.sort(function(a,b){return b.id - a.id});
		
		//add profile personal chart
		if($scope.account.profile != null){
			var userPersonalReport = angular.copy($scope.account.profile);
			userPersonalReport.name = userPersonalReport.real_name + ' (You)';
			// userPersonalReport.id = 0;
			$scope.perparingList.unshift(userPersonalReport);
		}

		//filter
		if ($scope.relationshipchart.data.bPersonl1Selected === true && $scope.relationshipchart.data.bPersonl2Selected === true) {
			
			filtered_list = [];
			for(i in $scope.perparingList ){
				if($scope.perparingList[i].id === $scope.relationshipchart.data.p1.id){
					continue;
				}
				else if ($scope.perparingList[i].id === $scope.relationshipchart.data.p2.id) {
					continue;
				}
				else{
					filtered_list.push($scope.perparingList[i]);
				}
			}

			$scope.selectList = filtered_list;
		}
		else if ($scope.relationshipchart.data.bPersonl1Selected === true && $scope.relationshipchart.data.bPersonl2Selected === false) {
			filtered_list = [];
			for(i in $scope.perparingList ){
				if($scope.perparingList[i].id == $scope.relationshipchart.data.p1.id){
					continue;
				}
				else{
					filtered_list.push($scope.perparingList[i]);
				}
			}
			$scope.selectList = filtered_list;
		}
		else if ($scope.relationshipchart.data.bPersonl1Selected === false && $scope.relationshipchart.data.bPersonl2Selected === true) {
			filtered_list = [];
			for(i in $scope.perparingList ){
				if($scope.perparingList[i].id == $scope.relationshipchart.data.p2.id){
					continue;
				}
				else{
					filtered_list.push($scope.perparingList[i]);
				}
			}
			$scope.selectList = filtered_list;
		}
		else{
			$scope.selectList = $scope.perparingList
		}
	}

	var GetRelationshipChart = function(){
		
		console.log("Get Relationship Chart");

		$ionicLoading.show({template: '<i class="fa fa-circle-o-notch fa-spin fa-2x fa-fw"></i>'});
		var rqt_data = {
			p1_gender: $scope.relationshipchart.data.p1.gender,
			p1_name: $scope.relationshipchart.data.p1.name,
			p1_birth_ts: $scope.relationshipchart.data.p1.birth_ts,
			p2_gender: $scope.relationshipchart.data.p2.gender,
			p2_name: $scope.relationshipchart.data.p2.name,
			p2_birth_ts: $scope.relationshipchart.data.p2.birth_ts,
		}

		Airstation.post({app:'hdapp',resource:'relationshipchart'},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.relationshipchart.data.report = rpn_data


				// Fix Invalid birth time
				/*
				var birth_p1 = moment(rpn_data.p1_birth_ts)
				$scope.relationshipchart.data.report.p1_birth_date_str = birth_p1.format('YYYY-MM-DD')
				$scope.relationshipchart.data.report.p1_birth_time_str = birth_p1.format('HH:mm a')

				var birth_p2 = moment(rpn_data.p2_birth_ts)
				$scope.relationshipchart.data.report.p2_birth_date_str = birth_p2.format('YYYY-MM-DD')
				$scope.relationshipchart.data.report.p2_birth_time_str = birth_p2.format('HH:mm a')*/

				console.log($scope.relationshipchart);
				$state.go('app.relationshipchart.report');
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.t._get_curtransitchart_fail);
		})
    }

    $scope.refreshPersonalChartList = function(){
    	console.log("Refresh Personal Chart List From Server");
    	Airstation.list({app:'hdapp',resource:'personalchart'},
    		function(rpn_data){
    			//2.1 Success Handle
    			console.log("GetPersonalChartData Success", $scope.personalReportList);

    			//2.2 Adjust Birth Datetime
    			for (index in rpn_data){
    				var chart_data = rpn_data[index];
    				Utility.AdjustBirthByLocation(chart_data);
    			}

    			$scope.personalReportList = rpn_data;
    			Datastore.setPersonalReportList($scope.personalReportList);

    			console.log("othersList object", $scope.personalReportList);
    			console.log("othersList length", $scope.personalReportList.length);

    			Account.getProfile(
    				function(data, status, headers, config){
    					//Success Callback
    					if(status == 200){
    						$scope.account.profile = data[0];

    						console.log("GetProfileData Success, data:", data);
    						//console.log($scope.account.profile);

    						//Get time zone from location
    						Utility.AdjustBirthByLocation($scope.account.profile);

    						//RefreshDisplayList();
    						// updateServerPurchasedReport();

    					}//end of status 200
    					else{
    						KBToast.error('Fail to get profile data');
    						KBToast.debug(status +' ' + data);
    					}		 

    					$scope.refresh = false;
    					$scope.$broadcast('scroll.refreshComplete');
    				},//end of get profile success
    				function(data, status, headers, config){
    					//Fail Callback
    					KBToast.error('Fail to get profile data');
    					KBToast.debug(status +' ' + data);

    					$scope.refresh = false;
    					$scope.$broadcast('scroll.refreshComplete');

    					if(status == 401){
    						console.log('Get profile Unauthorized');
    						Logout();
    					}
    				}
    			);

    			//$scope.refresh = false;
    		},
    		function(error) {
    			//2.1 Fail Handle
    			KBToast.error('failed to get personal chart list');
    			$scope.refresh = false;
    			$scope.$broadcast('scroll.refreshComplete');
    		}
    	);
    }
    // ------------------------------------
    // Select profile modal function
    // ------------------------------------
    $ionicModal.fromTemplateUrl('templates/modal/relationship-select.html', {
    	scope: $scope,
    	animation: 'slide-in-up'
    }).then(function(modal) {
    	$scope.modal = modal;
    })

    $scope.openModal = function(num) {
    	if ($scope.hasBackView === true && num === 1) {
    		return;
    	}

    	$scope.profile_num = num;
    	$scope.modal.show();
    }

    $scope.closeModal = function() {
    	$scope.modal.hide();
    }

    $scope.$on('$destroy', function() {
    	$scope.modal.remove();
    })

    $scope.goState = function(state) {
    	$scope.closeModal();
    	$state.go(state);
    }

    $scope.state = {};
    $scope.state.modal = "list";

    $scope.modalState = function(state) {
    	// body...
    	$scope.state.modal = state;
    }

    $scope.profile_num = 0;

    $scope.selectProfile = function(profile) {
    	if ($scope.profile_num === 1) {
    		console.log("Relationship Chart Person 1: " + profile.name);
    		console.log(profile);
    		$scope.relationshipchart.data.p1 = profile;
    		$scope.relationshipchart.data.bPersonl1Selected = true;
    	} 

    	if ($scope.profile_num === 2) {
    		console.log("Relationship Chart Person 2: " + profile.name);
    		console.log(profile);
			$scope.relationshipchart.data.p2 = profile;
			$scope.relationshipchart.data.bPersonl2Selected = true;
    	}
    	$scope.closeModal();
    }

	//--------------------------------
	// UI function
	//--------------------------------
	$scope.onClickChart = function(index){
		//1. Get Current Side Box Index
		console.log("Current Index: " + index );

		//1. Find personal chart obj
		var chart_obj = $scope.selectList[index];

		if($scope.relationshipchart.data.bPersonl1Selected === false){
			console.log("Relationship Chart Person 1: " + chart_obj.name);
			$scope.relationshipchart.data.p1 = chart_obj;
			$scope.relationshipchart.data.bPersonl1Selected = true;
			$state.go('app.relationshipchart.p2');
		}
		else if($scope.relationshipchart.data.bPersonl2Selected === false){
			console.log("Relationship Chart Person 2: " + chart_obj.name);
			$scope.relationshipchart.data.p2 = chart_obj;
			$scope.relationshipchart.data.bPersonl2Selected = true;
			GetRelationshipChart();
		}
		
	}

	$scope.onClickChart = function() {
		if ($scope.relationshipchart.data.bPersonl1Selected === true && $scope.relationshipchart.data.bPersonl2Selected === true) {
			GetRelationshipChart();
		} else {
			// KBToast.error($scope.t.msg_fill_required_info);
			$scope.openAlertModal();
		}
	}

	// ------------------------------------
	// Merge pop up warning function
	// ------------------------------------
	$ionicModal.fromTemplateUrl('templates/modal/relation-merge-popup.html', {
		scope: $scope,
		animation: 'scale-in'
	}).then(function(modal) {
		$scope.alertModal = modal;
	})

	$scope.openAlertModal = function() {
		$scope.alertModal.show();
	}

	$scope.closeAlertModal = function() {
		$scope.alertModal.hide();
	}

	$scope.$on('$destroy', function() {
		$scope.alertModal.remove();
	})

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('RelationshipChartCtrl beforeEnter, current state:',$state.current.name);

		$scope.data = {
			showDelete: false,
			showSearch: false,
			slideIndex: 0 ,
			numViewableSlides: 0,
			filter_by: $scope.filter_options[0],
			filter_value: '',
		};

		// if ($scope.settings.bUseListView === true){
		// 	$scope.data.showSearch = true;
		// }
		$scope.data.showSearch = false;

		if($state.current.name == 'app.relationshipchart'){
			$scope.relationshipchart.data = {
				bPersonl1Selected: false,
				bPersonl2Selected: false,
				p1: null,
				p2: null,
				header_text: $scope.t.relationship_chart_header_text_p1,
				title_text: $scope.t.relationship_chart_p1_title,
			}
		}
		// else if($state.current.name == 'app.relationshipchart.p2'){
		// 	$scope.relationshipchart.data.bPersonl2Selected = false;
		// 	$scope.relationshipchart.data.header_text = $scope.t.relationship_chart_header_text_p2;
		// 	$scope.relationshipchart.data.title_text = $scope.t.relationship_chart_p2_title;
		// }

		console.log($scope.relationshipchart);
		$scope.refreshPersonalChartList();
		RefreshDisplayList();

		$scope.relationshipchart.data.bPersonl1Selected = false;
		$scope.relationshipchart.data.bPersonl2Selected = false;
		$scope.state.modal = "list";
		$scope.profile_num = 0;

		if ($ionicHistory.backView() !== null) {
			$scope.hasBackView = true;
			$scope.profile_num = 1;
			if ($scope.ds.personalreport.IsUser === true) {
				// $scope.selectProfile($scope.ds.personalreport.data);
				var temp_profile = angular.copy($scope.account.profile);
				temp_profile.name = temp_profile.real_name + ' (You)';
				$scope.relationshipchart.data.p1 = temp_profile;
	    		$scope.relationshipchart.data.bPersonl1Selected = true;
			} else {
				// $scope.selectProfile($scope.account.profile);
				$scope.relationshipchart.data.p1 = $scope.ds.personalreport.data;
    			$scope.relationshipchart.data.bPersonl1Selected = true;	
			}
		}

		console.log($scope.hasBackView);
	});// end of $ionicView.beforeEnter

	$scope.$watch('account.profile', function(newVal, oldVal){
		RefreshDisplayList();
	});

	$scope.$watch('personalReportList', function(newVal, oldVal){
		RefreshDisplayList();
	});

	$scope.$watch('selectList', function(newVal, oldVal){

		console.log('Slide Box Count: ', newVal.length)

		$scope.data.numViewableSlides = newVal.length	
		$scope.data.slideIndex = 0;
		$ionicSlideBoxDelegate.slide(0);
		$ionicSlideBoxDelegate.update();

	});

	$scope.next = function() {
		$ionicSlideBoxDelegate.next();
	};

	$scope.previous = function() {
		$ionicSlideBoxDelegate.previous();
	};
	// Called each time the slide changes
	$scope.OnSlideChanged = function(index) {
		$scope.data.slideIndex = index;
		console.log("Current Index: " + $scope.data.slideIndex );
	};

	
	$scope.filterReport = function(item) {
		try{		
			if($scope.relationshipchart.data.bPersonl1Selected === true){
				if(item.id == $scope.relationshipchart.data.p1.id){
					return false
				}
			}

			if($scope.relationshipchart.data.bPersonl2Selected === true){
				if(item.id == $scope.relationshipchart.data.p2.id){
					return false
				}
			}

			var search_value = $scope.data.filter_value.toLowerCase();
			var name = item.name.toLowerCase();
			var city = item.city.toLowerCase();

			//console.log(item);

			if(name.indexOf(search_value) > -1){
				return true;
			}
			else if(city.indexOf(search_value) > -1){
				return true;
			}
			else{
				return false;
			}

		}
		catch(e){
			console.log(e)
			return true;
		}
	}

	$scope.OnChangeChartMode = function(){
		
		$scope.data.filter_value = '';
		$scope.settings.bUseListView = false;
		$scope.data.showSearch = false;

		$scope.data.slideIndex = 0;
		$ionicSlideBoxDelegate.slide(0);
		$ionicSlideBoxDelegate.update();

		LocalStorage.setObject('settings',$scope.settings);
	}

	$scope.OnChangeListMode = function(){
		$scope.settings.bUseListView = true;
		$scope.data.showSearch = true;
		LocalStorage.setObject('settings',$scope.settings);
	}
	

	//--------------------------------
	// Main
	//--------------------------------
	$scope.selectList = [];
	$scope.hasBackView = false;

})

//------------------------------------
// Relationship Chart Report Controller
//------------------------------------
.controller('RelationshipChartReportCtrl', function($scope,$state,$ionicLoading,
																$ionicHistory,
																$ionicModal,
																$ionicPopup,
																Datastore,
																Airstation,
																KBStore,
																PaymentService,
																Utility){
	//Testing Code
	/*
	var GetRelationshipChart = function(){
		$ionicLoading.show({template:'<i class="icon ion-ios7-reloading font-xxl"></i>'});

		var rqt_data = {
			p1_gender: 'M',
			p1_name: 'A',
			p1_birth_ts: '1999-02-18T13:57:00-05:00',
			p2_gender: 'F',
			p2_name: 'B',
			p2_birth_ts: '2015-02-18T13:57:00-08:00',
		}


		Airstation.post({resource:'hdreport/relationshipchart'},rqt_data,
			function(rpn_data){
				//2.1 Success Handle
				$ionicLoading.hide();
				$scope.report = rpn_data

				$scope.report.p1_birth_str = moment(rpn_data.p1_birth_ts).format('YYYY-MM-DD HH:mm a')
				$scope.report.p2_birth_str = moment(rpn_data.p2_birth_ts).format('YYYY-MM-DD HH:mm a')

				console.log($scope.report)
			},
			function(error) {
				//2.1 Fail Handle
				$ionicLoading.hide();
				KBToast.error($scope.relationshipr_get_curtransitchart_fail);
		})
    }*/

	//--------------------------------
	// Event
	//--------------------------------
	$scope.$on('$ionicView.beforeEnter', function () {
		console.log('RelationshipChartReportCtrl beforeEnter');
		//console.log($scope.relationshipchart);
		//$scope.report = $scope.relationshipchart;
	});

	$scope.$on('$ionicView.leave', function () {
		//Remove Chart enlargement #746 
		//$scope.imgModal.hide();
	});


	//------------------------------------
	// Main
	//------------------------------------
	console.log('RelationshipChartReportCtrl');
	
	$scope.report = $scope.relationshipchart.data.report;
	$scope.report.p1 = $scope.relationshipchart.data.p1
	$scope.report.p2 = $scope.relationshipchart.data.p2
	$scope.api_domain = api_domain
	$scope.socialshare = Datastore.getSocialShare();

    
	//------------------------------------
	// Social Share
	//------------------------------------
	
	$scope.socialshare.data = { title:'Human Design Chart',
								img_url: api_domain + $scope.report.chart_img_url,

	};
	
	$scope.shareViaFacebook =function(){
		console.log("shareViaFacebook");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaFacebookWithPasteMessageHint($scope.socialshare.data.title,
			null /* img */,
			$scope.socialshare.data.img_url,
			function(){
			console.log('share ok')
			},
			function(errormsg){
			//alert(errormsg)
		}); 
	};

	$scope.shareViaWhatsapp =function(){
		console.log("shareViaWhatsapp");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.shareViaWhatsApp($scope.socialshare.data.title,
			$scope.socialshare.data.img_url,
			null,
			function(){
			  console.log('share ok')
			},
			function(errormsg){
			  //alert(errormsg)
		}); 
	};

	$scope.shareVia = function(){
		console.log("shareVia");
		console.log($scope.socialshare.data);
		window.plugins.socialsharing.share($scope.socialshare.data.title,
			null,
			$scope.socialshare.data.img_url,
			null,
			function(){
			console.log('share ok')
			},
			function(errormsg){
			//alert(errormsg)
		}); 
	};
    
	//------------------------------------
	// Chart Image Model
	//------------------------------------
	/* Remove Chart enlargement #746 
	$ionicModal.fromTemplateUrl('image-modal.html',{
		scope: $scope,
		animation: 'slide-in-up'
		}).then(function(modal){
			$scope.imgModal = modal;
		}
	);

	$scope.openModal = function() {
		console.log('Open Modal');
		$scope.imgModal.show();
	}

	$scope.closeModal = function () {
		console.log('Close Modal');
		$scope.imgModal.hide();
	}*/

	$('img.svg').each(function(){
			var $img = $(this);
			var imgID = $img.attr('id');
			var imgClass = $img.attr('class');
			var imgURL = $img.attr('src');

			$.get(imgURL, function(data) {
			// Get the SVG tag, ignore the rest
			var $svg = $(data).find('svg');

			// Add replaced image's ID to the new SVG
			if(typeof imgID !== 'undefined') {
				$svg = $svg.attr('id', imgID);
			}
			// Add replaced image's classes to the new SVG
			if(typeof imgClass !== 'undefined') {
				$svg = $svg.attr('class', imgClass+' replaced-svg');
			}

			// Remove any invalid XML tags as per http://validator.w3.org
			$svg = $svg.removeAttr('xmlns:a');

			// Replace image with new SVG
			$img.replaceWith($svg);

		}, 'xml');
	});

})