angular.module('starter.controllers')

//====================================
// Account Controller
//====================================
.controller('SettingsCtrl', function($scope,$state,$filter,$ionicLoading,$ionicHistory,
																		LocalStorage,
																		Airstation,
																		Datastore,
																		Utility,
																		KBToast){

	
	//--------------------------------
	// Function
	//--------------------------------
	function createjscssfile(filename, filetype){
	    if (filetype=="js"){ //if filename is a external JavaScript file
	        var fileref=document.createElement('script')
	        fileref.setAttribute("type","text/javascript")
	        fileref.setAttribute("src", filename)
	    }
	    else if (filetype=="css"){ //if filename is an external CSS file
	        var fileref=document.createElement("link")
	        fileref.setAttribute("rel", "stylesheet")
	        fileref.setAttribute("type", "text/css")
	        fileref.setAttribute("href", filename)
	    }
	    return fileref
	}

	function removejscssfile(filename, filetype){
	    var targetelement=(filetype=="js")? "script" : (filetype=="css")? "link" : "none" //determine element type to create nodelist from
	    var targetattr=(filetype=="js")? "src" : (filetype=="css")? "href" : "none" //determine corresponding attribute to test for
	    var allsuspects=document.getElementsByTagName(targetelement)
	    for (var i=allsuspects.length; i>=0; i--){ //search backwards within nodelist for matching elements to remove
	    if (allsuspects[i] && allsuspects[i].getAttribute(targetattr)!=null && allsuspects[i].getAttribute(targetattr).indexOf(filename)!=-1)
	        allsuspects[i].parentNode.removeChild(allsuspects[i]) //remove element by calling parentNode.removeChild()
	    }
	}
	 
	function replacejscssfile(oldfilename, newfilename, filetype){
	    var targetelement=(filetype=="js")? "script" : (filetype=="css")? "link" : "none" //determine element type to create nodelist using
	    var targetattr=(filetype=="js")? "src" : (filetype=="css")? "href" : "none" //determine corresponding attribute to test for
	    var allsuspects=document.getElementsByTagName(targetelement)
	    for (var i=allsuspects.length; i>=0; i--){ //search backwards within nodelist for matching elements to remove
	        if (allsuspects[i] && allsuspects[i].getAttribute(targetattr)!=null && allsuspects[i].getAttribute(targetattr).indexOf(oldfilename)!=-1){
	            var newelement=createjscssfile(newfilename, filetype)
	            allsuspects[i].parentNode.replaceChild(newelement, allsuspects[i])
	        }
	    }
	}

	//--------------------------------
	// Event
	//--------------------------------

	$scope.showBirth = function(bool) {
		$scope.settings.show_birth = bool;
		if (window.ga) {
			window.ga.trackView('/app/settings/showbirth');
		}
		LocalStorage.setObject('settings',$scope.settings);

		//clear cache
		$ionicHistory.clearCache();
	}

	$scope.changeLang = function(code) {
		if (window.ga) {
			window.ga.trackView('/app/settings/chglg');
		}
		$scope.settings.lg = code;
		$scope.settings.report_default_lg = $scope.settings.lg;
		LocalStorage.setObject('settings',$scope.settings);

		//clear cache
		$ionicHistory.clearCache();
	}

	$scope.changeTheme = function(code) {
		if (window.ga) {
			window.ga.trackView('/app/settings/chgtheme');
		}
		$scope.settings.theme_code = code;
		LocalStorage.setObject('settings', $scope.settings);

		$ionicHistory.clearCache();
	}

	$scope.updateLang = function() {
		console.log('select lang', $scope.data.lg_sel);

		// var currentLang = LocalStorage.getObject('settings').lg;
		// console.log('current lang', currentLang);

		// if (currentLang !== $scope.data.lg_sel) {
			if (window.ga) {
				window.ga.trackView('/app/settings/chglg');
			}
			$scope.settings.lg = $scope.data.lg_sel.code;
			$scope.settings.report_default_lg = $scope.settings.lg;
			LocalStorage.setObject('settings',$scope.settings);

			//clear cache
			$ionicHistory.clearCache();
		// }
	}

	//--------------------------------
	// Valuable Define 
	//--------------------------------

	$scope.options = {}
	$scope.options.lg = g_report_available_lg;
	$scope.options.theme = g_report_theme;
	$scope.data = {}
	$scope.data.lg_sel  = _.findWhere( $scope.options.lg ,{code: $scope.settings.lg})
	// $scope.data.theme_sel = _.findWhere($scope.options.theme, {code: $scope.settings.theme.code})
	$scope.data.currentDate = new Date();
	$scope.version = version
});
