angular.module('kolorbox.utility', ['ng'])

.factory("Utility", function() {
	return {

		supports_html5_storage: function () {
			try {
				return 'localStorage' in window && window['localStorage'] !== null;
			} catch (e) {
				return false;
			}
		},

		genRandomString: function(length)
		{
			var text = "";
			var possible = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";

			for( var i=0; i < length; i++ )
					text += possible.charAt(Math.floor(Math.random() * possible.length));

			return text;
		},

		AdjustBirthByLocation: function(data){
			try{
				var dt;
				if (data.timezone === "" || data.timezone === "null") {
					dt = moment.parseZone(data.birth_local_ts);
				}
				else {
					dt = moment.tz(data.birth_ts,data.timezone);
				}
				var dt_str = dt.format('YYYY / MM / DD HH:mm');
				var d_str = dt.format('YYYY / MM / DD');
				var t_str = dt.format('HH:mm');
				var z_str = dt.format('Z');

				data.birth = {
					dt: dt,
					dt_str: dt_str,
					d_str: d_str,
					z_str: z_str,
					offset: z_str,
				};         
			}
			catch (e) {
				console.log(e);
			}
  		}
	}
})

.filter('capitalize', function() {
	return function(input, all) {
		return (!!input) ? input.replace(/([^\W_]+[^\s-]*) */g, function(txt){return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();}) : '';
	}
})

.filter('getProfileName', function() {
	return function(input, all) {

		try{
			var index = input.indexOf("-");

			if(index > 0){
				return input.substring(index + 2);
			}
			else{
				return input;
			}
		}
		catch (e) {
			return input;
		}
	}
})

;